#! /usr/local/bin/perl -wT
# $Id: autoas-num.pl,v 1.5 2008/12/02 12:35:14 ruben Exp $
use strict;

$ENV{'PATH'} = '/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/ncc/ttpro/bin:/home/ttraffic/bin';

foreach my $binary (qw(/ncc/ttpro/bin/ttconfig /usr/local/bin/whois3 /ncc/ttpro/bin/readttreg.pl /ncc/ttpro/bin/ttregconfig.pl))
{
	die "$binary not available\n" unless (-x $binary );
}

foreach my $ipaddr (grep {/ipaddr6?[^a-z0-9]/ && !/old[\-0-9]/} qx(/ncc/ttpro/bin/ttconfig -v ALL ACTIVE SETUP))
{
	my ($asnum,$asnumold,$asnumfield);
	chomp($ipaddr);
	my ($tt,$type,$addr) = split(/\s/, $ipaddr); 

	($tt) = $tt =~ /^([\w\-\.]+)$/;
	($addr) = $addr =~ /^(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[0-9A-Fa-f]{0,4}:([0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})$/;

	$asnum = qx(/usr/local/bin/whois3 -h riswhois -F -M $addr|egrep -v "^%|^\\\$" |awk "{print \\\$1}"); 
	$asnumfield = $type eq 'ipaddr' ? 'as-num' : ($type eq 'ipaddr6' ? 'as-num6' : undef);

	if (defined($asnumfield))
	{
		$asnumold = qx(/ncc/ttpro/bin/readttreg.pl $tt $asnumfield);
		chomp($asnum); 
		($asnum) = $asnum =~ /^(\d+)$/;

		if (defined($asnum) && $asnum && (!$asnumold || $asnum != $asnumold))
		{
			print "$tt: $asnumfield changed from @{[$asnumold ? $asnumold : qw(undefined) ]} to $asnum\n";
			print "$tt: setting $asnumfield failed: $!" if (system("/ncc/ttpro/bin/ttregconfig.pl MOD $asnumfield $tt $asnum > /dev/null 2>&1") != 0);
		}
	}
}
