#!/usr/local/bin/perl5 -w
#
# $Id: clean_everywhere.pl,v 1.4 2006/11/04 14:40:48 ruben Exp $
#

#
# Script to clean up old datafiles on all test boxes.
#


#
# Command line argument: -v for verbose output
#
$debug = 0;
if ( ($#ARGV == 0) && ($ARGV[0] eq "-v") ) { $debug = 1; }

# Name of config file
$config_file = "/home/ttraffic/config/list_of_testboxes";
$ssh_command = "/usr/local/bin/ssh -l ttraffic -i /ncc/ttpro/.ssh/ssh_ttraffic_key -x"; 


# Name of startup script on test-boxes
$start_command = "cleanup.pl";

#
# Read list of test-boxes
#
open (TBOXES, $config_file) || die "Cannot open $config_file \n";
while (<TBOXES>) {
   if (substr($_, 0, 1) eq "#") { next; }

   chop ;
   ($host, $directory) = split (/\s+/, $_);

   print "Connecting to $host\n";

   # Check if the host is alive
   $alive = `ping -Q $host 64 5 2>&1`;

   if (index ($alive, "alive") > -1 ) {
     if ($debug == 1) {print "$host is alive and kicking\n";}
     @result_list = `$ssh_command $host $directory/bin/$start_command`;
     for ($i=0 ; $i < $#result_list ; $i++) {
        print $result_list[$i];
     }
   } else {
     print "$host appears to be dead, skipped\n";
   }
   if ($debug == 1) {print "\n";}

}


