#!/usr/local/bin/perl
#
# $Id: collect_tb_configdata.pl,v 1.4 2006/11/04 14:40:48 ruben Exp $
#
# All Rights Reserved
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
# AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
# DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

#------------------------------------------------------------------------------
# Module Header
# Filename          : collect_tb_configdata.pl
# Purpose           : collect test boxes relation group configuration file
# Author            : Maximo Alves
# Date              : 15 May 2002
# Description       : connects to all test boxes from groups C and D
#                     it tries 3 times to connect 
# Language Version  : Perl 5
# OSs Tested        : Linux
# Command Line      : collect_tb_configdata.pl
# Input Files       : 
# Output Files      : 
# External Programs : ttconfig
#                    
# Problems          :
#                    
# To Do             : 
#                     
# Comments          : Must be run on Ginkgo as ttraffic
#                     
#------------------------------------------------------------------------------
use strict;


# --------------- Variable declaration ------------------------------

my $VERBOSE = 0;
my $remotedir = "/usr/home/ttraffic/config/";
my $localdir = "/ncc/ttpro/data/config/new/";
my @tblist = ();
my @secondtry = ();
my @thirdtry = ();


#fill list of TB's, only Group C and D\
@tblist = `/ncc/ttpro/bin/ttconfig -v TTSYNCLIST3 ACTIVE`;
push @tblist, `/ncc/ttpro/bin/ttconfig -v TTSYNCLIST4 ACTIVE`;
push @tblist, `/ncc/ttpro/bin/ttconfig -v TTSYNCLIST5 ACTIVE`;
push @tblist, `/ncc/ttpro/bin/ttconfig -v TTSYNCLIST6 ACTIVE`;
push @tblist, `/ncc/ttpro/bin/ttconfig -v TTSYNCLIST7 ACTIVE`;
@tblist = sort @tblist;

foreach my $tb (@tblist){    
    chop($tb);
    #Is alive?    
    my $status = `/ncc/ttpro/bin/ttping $tb`;
    if($status =~/alive/){
        #tb is alive
	my $aux = "/usr/local/bin/scp -4 -i /ncc/ttpro/.ssh/ssh_ttraffic_key ttraffic@";
        $aux = $aux . "$tb:/data/apache/htdocs/cgi-bin/relationgroup.config /ncc/ttpro/data/config/new/";
	$aux = $aux . "$tb.relationgroup.config";

	my $resp = `$aux`;
	if($resp){
	    print $resp . "\n";
	}else{
	    print "relationgroup.config from $tb collected \n" if($VERBOSE);
	}
    }else{
        #tb is unreachable
	print $tb . " is  unreachable \n" if($VERBOSE);
	push @secondtry, $tb;
    }

}#foreach my $tb

foreach my $tb (@secondtry){

    #Is alive?
    my $status = `/ncc/ttpro/bin/ttping $tb`;
    if($status =~/alive/){
        #tb is alive
	my $aux = "/usr/local/bin/scp -4 -i /ncc/ttpro/.ssh/ssh_ttraffic_key ttraffic@";
        $aux = $aux . "$tb:/data/apache/htdocs/cgi-bin/relationgroup.config /ncc/ttpro/data/config/new/";
	$aux = $aux . "$tb.relationgroup.config";

	my $resp = `$aux`;


	if($resp){
	    print $resp . "\n";
	}else{
	    print "relationgroup.config from $tb collected \n" if($VERBOSE);
	}
    }else{
        #tb is unreachable
	print $tb . " is  unreachable \n" if($VERBOSE);
	push @thirdtry, $tb;
    }

}#foreach my $tb


foreach my $tb (@thirdtry){

    #Is alive?
    my $status = `/ncc/ttpro/bin/ttping $tb`;
    if($status =~/alive/){
        #tb is alive
	my $aux = "/usr/local/bin/scp -4 -i /ncc/ttpro/.ssh/ssh_ttraffic_key ttraffic@";
        $aux = $aux . "$tb:/data/apache/htdocs/cgi-bin/relationgroup.config /ncc/ttpro/data/config/new/";
	$aux = $aux . "$tb.relationgroup.config";

	my $resp = `$aux`;	


	if($resp){
	    print $resp . "\n";
	}else{
	    print "relationgroup.config from $tb collected \n" if($VERBOSE);
	}
    }else{
        #tb is unreachable
	print $tb . " is  unreachable \n" if($VERBOSE);
    }

}#foreach my $tb
