#!/usr/local/bin/perl
#
# $Id: makefullmesh.pl,v 1.4 2006/11/04 14:40:49 ruben Exp $
#
#purpose: create in ttreg the necessary entries for a  full mesh measurement relation for a 
# test box when specified or all teste boxes is no one is specified 
#command line:
#   makefullmesh.pl {-v4 | -v6} [-t ttxx] [-e ttxy] [-e ttzz] [-e ttzx] [-e ...]


use strict;

my $DEBUG = 0;
my $portnumber = "6000";
my $packetrate = "120";
my $packetlength = "100 1 0";
my $tracerouterate = "10";
my $addvaluedelay = "";
my $addvaluetrace = "";
my $target = 0;
my $prot = "";
my $delayfield = "";
my $tracefield = "";
#my $PATH = "/home/maximo/trabalho/projetos/nsquare/code/ttregconfig/";
my $PATH = "/ncc/ttpro/bin/";
my $auxstr = "";
my @online = ();
my @exclude = ();



#parse command line

my $parameter = shift(@ARGV);
if($parameter){
    do{
	if($parameter eq "-v4"){
            $prot = "4";

	}elsif($parameter eq "-v6"){
           $prot = "6";

	}elsif($parameter eq "-t"){
	    $target = shift(@ARGV);
            if(!($target=~/tt\d(.+)/)){
		print "You MUST specify a valid target(-t ttxx) where xx is a number\n";
		&usage;
		exit;
	    }
	}elsif($parameter eq "-e"){
	    $parameter = shift(@ARGV);
	    $parameter=~s/\n//;
	    push @exclude, $parameter;
	}elsif($parameter eq "-h"){
	    &usage;
	    exit;
	}elsif($parameter eq "-d"){
	    $DEBUG = 1;	   
	}	   
	$parameter = shift(@ARGV);
    }while $parameter;
}

#test parameters
if($prot eq "4"){
	    $auxstr = $PATH."ttconfig -v TTLIST CURRENT";
	    @online = `$auxstr`;
	    $delayfield = "o-delay-t";
	    $tracefield = "o-tracer-t";

}elsif($prot eq "6"){
	    $auxstr = $PATH."ttconfig  -v IP6TTLIST CURRENT";
	    @online = `$auxstr`;
	    $delayfield = "o6delay-t";
	    $tracefield = "o6tracer-t";
}else{
    print "You MUST specify -v4 or -v6 in the command line! \n";
    &usage;
    exit;
}

if(!$target){
    print "You MUST specify a target(-t ttxx) where xx is a number\n";
    &usage;
    exit;
}

@online = sort @online;
my @online2 = @online;




foreach my $tb (@online){
    $tb=~s/\n//;
    next if(&to_exclude($tb));
    if($target){
	next if(!($tb=~/$target/));
	&create_addvalue($tb);       
        my $auxstr = $PATH."ttregconfig.pl ADD $delayfield $tb $addvaluedelay";
	if($DEBUG){
	    print $auxstr. "\n";
	}else{
	    `$auxstr`;
	}
        my $auxstr = $PATH."ttregconfig.pl ADD $tracefield $tb $addvaluetrace";
	if($DEBUG){
	    print $auxstr. "\n";
	}else{
	    `$auxstr`;
	}

    }else{
        #for the case creating r.g. for all tbs becomes neccessary again
        #now it should not happen anymore
	&create_addvalue($tb);
        my $auxstr = $PATH."ttregconfig.pl ADD $delayfield $tb $addvaluedelay";
      	if($DEBUG){
	    print $auxstr. "\n";
	}else{
	    `$auxstr`;
	}
        my $auxstr = $PATH."ttregconfig.pl ADD $tracefield $tb $addvaluetrace";
	if($DEBUG){
	    print $auxstr. "\n";
	}else{
	    `$auxstr`;
	}
    }
}

sub create_addvalue {

    $addvaluedelay = "";
    $addvaluetrace = "";
    my $tb = $_[0];
    foreach my $tb2 (@online2){
	$tb2=~s/\n//;
#	next if($tb=~/$tb2/);   # old [RW]
	next if($tb eq $tb2);	# new [rw]
	next if(&to_exclude($tb2));
	$addvaluedelay = $addvaluedelay ." ". '"'.$tb2." ".$portnumber." ".$packetrate." ".$packetlength.'"';
        $addvaluetrace = $addvaluetrace ." ". '"'.$tb2." ".$tracerouterate.'"';
    }

}


sub usage{

    print "Purpose: creates in ttreg the necessary entries for a full mesh measurement relation for one test box when it's specified or all test boxes if no one is specified\n";
    print "Command line: \n";
    print " makefullmesh.pl [-h] [-d] {-v4 | -v6} {-t ttxx} [-e ttxy] [-e ttzz] [-e ttzx] [-e ...] \n";
    print " { }: required argument \n";
    print " [ ]: optional argument \n";
    print " -v4 | -v6 : creates full mesh for v4 chain OR v6 chain \n";
    print " -t ttxy: creates full mesh for ttxy only. \n";
    print " -e ttxy: doesn't include ttxy in the measurement chain. The -e argument might be repeated many times\n";  
    print " -h: prints that and exit\n";
    print " -d: used for debug. No real action is take\n";

}

sub to_exclude{
    my $target = $_[0];

    foreach my $excluded (@exclude){
	return 1 if($target=~/$excluded/);
    }
    return 0;
}













