#!/usr/local/bin/perl
#
# $Id: makeiiilist.pl,v 1.2 2006/11/04 14:40:49 ruben Exp $
#
#
# All Rights Reserved
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
# AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
# DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

#------------------------------------------------------------------------------
# Module Header
# Filename          : makeiiilist.pl
# Purpose           : creates iii html page listing all tb's and their targets
# Author            : Maximo Alves
# Date              : 05 Feb 2003
# Description       : 
# Language Version  : Perl 5
# OSs Tested        : Linux
#
# Input Files       : 
# Output Files      : 
# External Programs : ttconfig, sed
#                    
# Problems          :
#                    
# To Do             : 
#                     
# Comments          :
#                     
#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
use lib '/ncc/ttpro/bin/';
use strict;
use datafunctions;

my @activetbs = `/ncc/ttpro/bin/ttconfig -v TTLIST`;



sub isonline {
    #return 1 if not online
    #       0 if online

    my $target = $_[0];
    foreach my $tb (@activetbs){
	if($tb=~/$target/){
	    return 0;
	}
    }
    return 1;
}

sub print_list {
    my $title = shift @_;
    my @list = @_;
    if(scalar(@list)>0){
	print "<P><FONT COLOR=BLACK  SIZE=' 2' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'>$title:</FONT> \n";
	foreach my $testbox ( @list ){
	    if(!(&isonline($testbox))){
		print "<FONT COLOR=RED SIZE='1'> $testbox  </FONT>\n";
	    }else{
		print "<FONT COLOR=BLUE SIZE='1'> $testbox  </FONT>\n";
	    }
	}
	my $aux =  scalar(@list);
	print "<br><FONT COLOR=BLACK  SIZE='2' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'>Total: $aux </FONT><br> \n";
    }else{

	print "<br><FONT COLOR=BLACK  SIZE='2' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'>No $title configured</FONT><br> \n";

    }
} # sub print_list ends here !!!



###### Start here ######################
&filldatamatrix;

my @tb = keys %datamatrix;
@tb = sort @tb;

# start print html 
print <<EOF;

<HTML>
<HEAD>
<TITLE>Alarm Configuration</TITLE>
</HEAD>
<BODY BGCOLOR=WHITE>

  <P ALIGN=CENTER><b><FONT COLOR=BLACK  SIZE=" +2" FACE="Verdana,Tahoma,Arial,Helvetica,sans-serif">
    Target List   
  </FONT></b></P>        
  <p><p>
<P><b><FONT COLOR=BLACK  SIZE='2' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'>
Please note that:
 <ul>
  <li>On-line boxes are in red</li>
  <li>Off-line boxes are in blue</li>
  <li>For a help page explaining TT-Ops targets, Remote targets and Local targets click <a href="http://tt01.ripe.net:10259/html/configurationhelp.html">here</a></li>   
 </ul>
</FONT></b> </p>

    
<P><b><FONT COLOR=BLACK  SIZE='2' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'>
Choose an TB from the list bellow:
</FONT></b> </p>

EOF


foreach my $tb (@tb){
    if($tb){
        my $spc = " - ";
        my $straux = "#TB$tb";
	if(!(&isonline($tb))){
	    print "<FONT COLOR=RED SIZE='1'><a HREF='$straux'>$tb$spc</a> </FONT>\n";
	}else{
	    print "<FONT COLOR=BLUE SIZE='1'><a HREF='$straux'>$tb$spc</a> </FONT>\n";
	}
    }
}



print"<br><br>  <hr> \n";





foreach my $tb (@tb){
    my @online = ();
    my @offline = ();
    my $targets = $targetmatrix{$tb};

    print"<P ALIGN=CENTER><b><FONT COLOR=BLACK  SIZE='+1' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'><a NAME='TB$tb'> $tb </a></FONT></b></P>\n";      
    my @aux = sort @$targets;
    foreach my $testbox ( @aux ){ 
        if($testbox){
	    if(!(&isonline($testbox))){
		push @online, $testbox;
       	    }else{
		push @offline, $testbox;
	    }
        }
    }
    my $online =  scalar(@online);
    my $offline = scalar (@offline);
    print "<P><FONT COLOR=BLACK  SIZE=' 2' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'> Online targets: $online    -    Offline targets: $offline</FONT> \n";

    my (@udelay, @rdelay, @odelay, @utrace, @rtrace, @otrace, @udelay6, @rdelay6, @odelay6, @utrace6, @rtrace6, @otrace6) = ();
    my $p1 = $datamatrix{$tb};
    my @attributes = keys %$p1;
    foreach my $attribute (@attributes){
	my $p2 = $$p1{$attribute};
	foreach my $value (@$p2){
	    if($attribute eq "o-delay-t"){
		push @odelay, (split(/\s/, $value))[1];
	    }elsif($attribute eq "u-delay-t"){
		push @udelay, (split(/\s/, $value))[1];
	    }elsif($attribute eq "r-delay-t"){
		push @rdelay, (split(/\s/, $value))[1];
	    }elsif($attribute eq "o-tracer-t"){
		push @otrace, (split(/\s/, $value))[1];
	    }elsif($attribute eq "u-tracer-t"){
		push @utrace, (split(/\s/, $value))[1];
	    }elsif($attribute eq "r-tracer-t"){
		push @rtrace, (split(/\s/, $value))[1];
	    }elsif($attribute eq "o6delay-t"){
		push @odelay6, (split(/\s/, $value))[1];
	    }elsif($attribute eq "u6delay-t"){
		push @udelay6, (split(/\s/, $value))[1];
	    }elsif($attribute eq "r6delay-t"){
		push @rdelay6, (split(/\s/, $value))[1];
	    }elsif($attribute eq "o6tracer-t"){
		push @otrace6, (split(/\s/, $value))[1];
	    }elsif($attribute eq "u6tracer-t"){
		push @utrace6, (split(/\s/, $value))[1];
	    }elsif($attribute eq "r6tracer-t"){
		push @rtrace6, (split(/\s/, $value))[1];
	    }
	}
    }

    @odelay = sort @odelay;    
    @udelay = sort @udelay;
    @rdelay = sort @rdelay;
    @otrace = sort @otrace;
    @utrace = sort @utrace;
    @rtrace = sort @rtrace;
    @odelay6 = sort @odelay6;
    @udelay6 = sort @udelay6;
    @rdelay6 = sort @rdelay6;
    @otrace6 = sort @otrace6;
    @utrace6 = sort @utrace6;
    @rtrace6 = sort @rtrace6;

    print"   <P><b><FONT COLOR=BLACK  SIZE='2' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'> TT-OPS Targets:  </FONT></b> </p>\n";


&print_list("Delay", @odelay);
&print_list("Trace routes", @otrace);
&print_list("Ipv6 delay", @odelay6); 
&print_list("Ipv6 trace routes", @otrace6);

    print"   <P><b><FONT COLOR=BLACK  SIZE='2' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'> User Targets:  </FONT></b> </p>\n";


&print_list("Delay", @udelay);
&print_list("Trace route", @utrace);
&print_list("Ipv6 delay", @udelay6);
&print_list("Ipv6 trace route", @utrace6);



    print"   <P><b><FONT COLOR=BLACK  SIZE='2' FACE='Verdana,Tahoma,Arial,Helvetica,sans-serif'> Remote Targets:  </FONT></b> </p>\n";

&print_list("Delay", @rdelay);
&print_list("Trace route", @rtrace);
&print_list("Ipv6 delay", @rdelay6);
&print_list("Ipv6 trace route", @rtrace6);


    print " <hr> \n";


}

print <<EOF1;
</BODY>
</HTML>

EOF1
