#! /bin/sh
# $Id: process_relationgroups.sh,v 1.2 2006/11/03 11:19:46 ruben Exp $


#
# 
# Auxiliary script which executes other applications used for measurement relation configuration
#
#

exec=
debug=NO
verbose=NO

while [ $# -gt 0 ]; do
	case "$1" in
	-n)
		exec=echo
		;;
	-d)
		debug=YES
		;;
	-v)
		verbose=YES
		;;
	esac
	shift
done


test "X${verbose}" = "XYES" && echo "*** `date`: creating listofcities.txt ..."

/ncc/ttpro/bin/ttconfig -v CITIES ACTIVE > /ncc/ttpro/tmp/listofcities.txt
for i in 3 4 5 6 7; do
$exec cp /ncc/ttpro/tmp/listofcities.txt /ncc/ttpro/files/proto_test_box_${i}/data/apache/htdocs/assets/
done

test "X${verbose}" = "XYES" && echo "*** `date`: collecting relationgroup.config from test boxes ..."

$exec /ncc/ttpro/bin/collect_tb_configdata.pl

test "X${verbose}" = "XYES" && echo "*** `date`: analysing configuration data from test boxes ..."

$exec /ncc/ttpro/bin/analyse_tb_configdata.pl

test "X${verbose}" = "XYES" && echo "*** `date`: creating new relationgroup.config files ..."

$exec /ncc/ttpro/bin/createrelationgroupconfigfile.pl

test "X${verbose}" = "XYES" && echo "*** `date`: creating new config files ..."

$exec /ncc/ttpro/bin/createconfigfile.pl


test "X${verbose}" = "XYES" && echo "*** `date`: uploading relationgroup.config ..."
$exec /ncc/ttpro/bin/upload_tb_configdata.pl 

