#!/usr/local/bin/perl5 -w
#
# $Id: start_everywhere.pl,v 1.6 2006/11/04 14:40:49 ruben Exp $
#

#
# Script to fire up all processes on all test boxes.
#

$TTROOT="/ncc/ttpro";
$TIMEOUT_SIGNAL="15";
$TIMEOUT=`$TTROOT/bin/ttconfig -v timeout`;
chomp($TIMEOUT);

$PING_COMMAND = "/usr/local/bin/ping -Q";
$TIMEOUT_COMMAND = "/home/ttraffic/bin/forktimeout -t $TIMEOUT -s $TIMEOUT_SIGNAL";
$SSH_COMMAND = "/usr/local/bin/ssh -x -l ttraffic -i $TTROOT/.ssh/ssh_ttraffic_key";
$PARSE_COMMAND = "sed \"s/Looking for .*, pid .*, ps -xuwp OK/OK/g\"|uniq";
$START_COMMAND = "/home/ttraffic/bin/start_processes.pl"; # TBs' startup script

#
# Command line argument: -v for verbose output
#
$verbose = 0;
if ( ($#ARGV == 0) && ($ARGV[0] eq "-v") ) { $verbose = 1; }

#
# Get list of machines
#
open( INFO, "$TTROOT/bin/ttconfig -v TTLIST |") || die "Cannot get list of testboxes\n";
@TTLIST = <INFO>;
close(INFO); 

#
# Parse list of test-boxes & connect to
#
foreach $host (@TTLIST)
  {
   chop $host;

   print "Connecting to $host\n";

   # Check if the host is alive
   $alive = `$PING_COMMAND $host 64 5 2>&1`;

   if (index ($alive, "alive") > -1 ) {
     if ($verbose == 1) {
        print "$host is alive and kicking\n";
     }
    
     @result_list = `$TIMEOUT_COMMAND $SSH_COMMAND $host $START_COMMAND|$PARSE_COMMAND`;
     for ($i=0 ; $i <= $#result_list ; $i++) {
        print $result_list[$i];
     }
   } else {
     print "$host appears to be dead, skipped\n";
   }
}
