/* $Id: packet.h,v 1.10 2006/11/05 16:32:21 ruben Exp $ */

#define MAXPACKETS  3500000

struct packet {
   unsigned int packet_id;        /* Identifier of the packet */
   int          source_id;        /* ID# of the sending testbox */
   int          source_port;      /* Port from which the packet was sent */
   int          target_id;        /* ID# of the receiving testbox */
   int          target_port;      /* Port to which the packet was sent */
   int          packet_size;      /* Packet size in bytes */
   double       arrival_time;     /* -1.0 if undefined */
   double       delay;            /* Delay in ms, -1.0 if undefined */
   unsigned int source_clock;     /* Sending and receiving clock status */
   unsigned int target_clock;
   int          nhops;            /* Number of hops, -1 if unknown */
   int          routeid;          /* Routing vector number, -1 if unknown */
   float        source_ntp;       /* NTP error estimates (empty at the moment) */
   float        target_ntp;
};

