/*
Copyright (c) 2000                      RIPE NCC


All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of the author not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

/*
-------------------------------------------------------------------------------
Module Header
Filename          : RootFileBuffer.C
Author            : Maximo Alves
Date              : 22-AGO-2002
Description       : TTM RootFileBuffer class implementation
Language Version  : C++
OSs Tested        : 

The RootFileBuffer class opens and writes to root files

        

-------------------------------------------------------------------------------
*/

#include "TTree.h"

#include "RootFileBuffer.h"


static char const rcsid[] = "$Id: RootFileBuffer.C,v 1.2 2003/06/17 12:48:21 maximo Exp $";                                                                                       
static char const *rcsid_p = rcsid; 

void  RootFileBuffer::setBranchAddress(const char* bname, void* add){

    T->SetBranchAddress(bname, add);

}


Stat_t  RootFileBuffer::getEntries(){

 
   return(T->GetEntries());

}


Int_t  RootFileBuffer::getEvent(Int_t entry){

    return(T->GetEvent(entry));

}

Int_t RootFileBuffer::openFile(char *filename){
 
 return(T->Add(filename));

}


RootFileBuffer::RootFileBuffer() {
     T = new TChain("tree");


}

RootFileBuffer::~RootFileBuffer() {
     delete T;


}




