/*
Copyright (c) 2000                      RIPE NCC

$Id: RootFileBuffer.h,v 1.2 2006/11/04 14:40:49 ruben Exp $


All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of the author not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

/*
-------------------------------------------------------------------------------
Module Header
Filename          : RootFileBuffer.h
Author            : Maximo Alves
Date              : 22-AGO-2002
Description       : TTM RootFileBuffer class definition
Language Version  : C++
OSs Tested        : 

The RootFileBuffer class opens and writes to root files

	

-------------------------------------------------------------------------------
*/

#include "TChain.h"
#include "TTree.h"


class RootFileBuffer {
    private:
        char *_filename;
        TChain *T;

    public:      
        void setBranchAddress(const char* bname, void* add);
        Stat_t getEntries();
        Int_t getEvent(Int_t entry = 0);
        Int_t openFile(char *filename);
        RootFileBuffer();
        ~RootFileBuffer();
};
