/*
Copyright (c) 2000                      RIPE NCC


All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of the author not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

/*
-------------------------------------------------------------------------------
Module Header
Filename          : RouteStat.C
Author            : Maximo Alves
Date              : 23-AGO-2002
Description       : TTM RouteStat class implementation
Language Version  : C++
OSs Tested        : 

-------------------------------------------------------------------------------
*/

#include "RouteStat.h"

static char const rcsid[] = "$Id: RouteStat.C,v 1.2 2003/06/17 12:48:21 maximo Exp $";                                                                                       
static char const *rcsid_p = rcsid ;

ClassImp(RouteStat)


RouteStat::RouteStat(){
    setId(0);
    setMean(0);
    setRms(0);
    setTimestamp(0);
    setMax(0);
    setMin(0);
}

void RouteStat::setId(Int_t id){
    _id = id;

}

void RouteStat::setMean(Double_t mean){
    _mean = mean;

}

void RouteStat::setRms(Double_t rms){
    _rms = rms;

}

void RouteStat::setTimestamp(Int_t timestamp){
    _timestamp = timestamp;

}


void RouteStat::setMax(Int_t max){
    _max = max;

}

void RouteStat:: setMin(Int_t min){
    _min = min;

}

Int_t RouteStat::getId(){
  return _id;
}

Int_t RouteStat::getTimestamp(){
  return _timestamp;
}

Int_t RouteStat::getMax(){
  return _max;
}

Int_t RouteStat::getMin(){
  return _min;
}

Double_t RouteStat::getMean(){
  return _mean;
}

Double_t RouteStat::getRms(){
  return _rms;
}








