/*
Copyright (c) 2000                      RIPE NCC

$Id: RouteStat.h,v 1.2 2006/11/04 14:40:49 ruben Exp $


All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of the author not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

/*
-------------------------------------------------------------------------------
Module Header
Filename          : RouteStat.h
Author            : Maximo Alves
Date              : 23-AGO-2002
Description       : TTM RouteStat class definition
Language Version  : C++
OSs Tested        : 



-------------------------------------------------------------------------------
*/

#include "TObject.h"


class RouteStat : public TObject {
    private:
        Int_t _id;
        Double_t _mean;
        Double_t _rms;
        Int_t _timestamp;
        Int_t _max;
        Int_t _min;

    public:      
        RouteStat();
        void setId(Int_t id); 
        void setMean(Double_t mean);
        void setRms(Double_t rms);
        void setTimestamp(Int_t timestamp);
        void setMax(Int_t max);
        void setMin(Int_t min);
        Int_t getId();
        Double_t getMean();
        Double_t getRms();
        Int_t getTimestamp();
        Int_t getMax();
        Int_t getMin();
	ClassDef(RouteStat,1) 
};

