/* Module as.h 
 * Purpose:     include file for AS lookups
 * Author:	Rene Wilhelm
 *
 * $Id: as.h,v 1.7 2007/02/06 11:21:57 ruben Exp $
 */ 

#include <netdb.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>

#define RR_SERVER "riswhois.ripe.net"
#define RR_SERVICE "whois"


/*
 * socket related things are global to allow
 * reconnects in signal handler
 */

extern int RRsock;
extern struct sockaddr_in RRsockaddr;

void RRopen(const char *server, const char* service);
void RRconnect(void);

const char *get_origin(const char *net, int ip6flag);
