#include <iostream>


#include <TROOT.h>
#include <TApplication.h>
#include <TError.h>

using namespace std;

#include "utils.h"
#include "TestBoxConfig.h"
#include "TTMSummaryChain.h"
#include "TTMOptions.h"


RCSID("$Id: trendplots.C,v 1.9 2006/11/13 15:21:28 ruben Exp $");


#define NUMINTERVALS 4	 
char *progname;
int verbose = 0;

int main (int argc, char** argv) {

// get options

	TTMOptions options(argc, argv, "46vdp:s:t:o:R:m:z:f:");

	// Ignore ROOT messages
	gErrorIgnoreLevel=1;

	if (options.Debug())
		gErrorIgnoreLevel=0;

// Initialize ROOT system

	TROOT simple ("TTM", "Summaries");
	gROOT->SetBatch();                   // no graphics windows

	TApplication("delayStats", NULL, NULL, NULL, 0);

// now we can start ...

	TestBoxConfig config(options);

	map<uint,TestBox*> &tblist = config.GetTBList();
	map<uint,TestBox*> &targets = PAIR_VAL(tblist.begin())->GetTargets();

	if (options.Verbose()) {
	cout << tblist.size() << " boxes in config, MaxId = " << config.GetMaxBoxId() <<
		" , first box: id " << PAIR_VAL(tblist.begin())->GetId() << " name: " <<
		PAIR_VAL(tblist.begin())->GetName() << " " << targets.size() <<
		" targets, first target: id " << PAIR_VAL(targets.begin())->GetId() <<
		" name: " << PAIR_VAL(targets.begin())->GetName() << endl;
	}

	TTMSummaryChain summary;

	summary.SetConfig(options, config, NUMINTERVALS);
	summary.Chain();
	summary.PlotAll();

	return(0);
}
