#include <stdio.h>
#include <stdlib.h>

#include "packet.h"
#include "rv.h"
#include "testbox.h"

static char const rcsid[] = "$Id: match_vectors.c,v 1.4 2000/07/19 11:23:26 wilhelm Exp $";

void match_vectors (FILE *fileout, int debug) {

   int i, j;
   int it;
   int vector;
   int matched=0;
   int lasttime;
   double packettime;
    
   struct vector_by_elements *address;

   int start, end;

   /* Loop over all routes */
   for (j=0 ; j < knownroutes ; j++) {
      start = test_box_int (route_list[j]->source);
      end   = test_box_int (route_list[j]->dest);

      /* Loop over all packets */
      for (i=0; i<number_of_packets ; i++) {
      
         /* Valid time stamp, packet from source to destination? */
	 /* always assign routevec, regardless of correct timing [RW july 11] */
         if ((list_of_packets[i] != NULL) &&
/*             (list_of_packets[i]->arrival_time > 0.0 ) &&  */
             (list_of_packets[i]->source_id == start) &&
             (list_of_packets[i]->target_id == end)) {

            /* Yes, find the routing vector measured just before the packet was sent */

	    /* REMINDER:  routing vector database is defined in rv.h include file */
            /*            times are *last* time measurements were seen */


/* 	    packettime = list_of_packets[i]->arrival_time;  */

	    packettime = list_of_packets[i]->packet_id; 
            /* == feature of TTM: packetid is set to time packet was send */

	    it = (route_list[j]->entries) - 1;
            lasttime = (route_list[j]->list+it)->time;

	    if (packettime < lasttime) {
		/* this implies the last route seen in the list is used
		   for all packets arrived after that date; since we
                   have no data this is the best we can do */

		while (it > 0) {
	    		it--;
	            	lasttime = (route_list[j]->list+it)->time;
			if (packettime >= lasttime) {
				
	    			/* we overshot by one, so have to increase
				  our 'it' pointer by one to retrieve the
				  matching vector */
	    			it++;
				break;
			}
		}
	    }

   	    vector = (route_list[j]->list+it)->id;
            list_of_packets[i]->routeid = vector;
            address = id_to_vector[vector];

            if (address != NULL) {
               list_of_packets[i]->nhops = address->naddress;
            }

            matched++;
            continue;
         }
      }

   }

   if (debug==TRUE) {
      printf ("Assigned routing vectors to %d packets\n", matched);
   }

   return;

}
