#!/usr/local/bin/perl5 -w
#
# $Id: merge.pl,v 1.5 2006/11/04 14:40:50 ruben Exp $
#

use Socket;
use Time::Local;
#
# Where to find the data files
#
$datadir = "/export/nccfs44/henk/data";               # Raw data
$procdir = "/export/nccfs44/henk/data_processed";     # Output files
$procdir = "/ncc/ttfs2/henk/data_processed";
$confdir = "/home/ttraffic/config/";
#$trdir = "/export/nccfs44/henk/data_processed";     # Output files
$trdir =   "/spool/henk/TTraffic";

#
# Extract command line parameters:
#
# merge.pl <date>     Date to process (YYYYMMDD)
#          <host>     Sending test-box
#
if ( $#ARGV == 1 ) {
   $date_measured = $ARGV[0];
   $sender        = $ARGV[1];
} else {
   print "syntax: merge.pl <date_of_data> <host>\n"; 
   die   ".ripe.net in hostname is optional\n";
}

#
# Add .ripe.net to the hostname if it isn't already there.
#
if (length($sender) < 10) { $sender .= ".ripe.net"; }
if (substr($sender, -9, 9) ne ".ripe.net") { $sender .= ".ripe.net"; }
print "Processing data sent by $sender on $date_measured\n";

#
# Loop over files produced -12..+36 hours from date
#
$start_time = timegm (0, 0, 0,  $date_measured %   100,
                               ($date_measured /   100 ) % 100 - 1,
                               ($date_measured / 10000 ) % 100);
$end_time   = $start_time + 36 * 3600; # End 28 hours after 
$start_time = $start_time - 12 * 3600; # Start 4 hours before

#
# Find files
#
$rcdpfiles = "";
opendir (DATAAREA, "$datadir") || die "Cannot open directory\n";
foreach $datafile (sort readdir(DATAAREA)) {
   # 
   # Name should start with RCDP.machine
   #
   if (index($datafile, "RCDP.") < 0) { next; }
   #
   # Check production date
   #
   ($a, $a, $a, $a, $date) = split(/\./, $datafile);
   ($date, $head) = split("-",  $date);
   $produced_time = timegm (0, 0, 
                               ($head / 10000 ), 
                                $date % 100,
                               ($date /   100 ) % 100 - 1,
                               ($date / 10000 ) % 100);
   if (($produced_time < $start_time) || ($produced_time > $end_time)) {next;}
   #
   # Scan the file for packets
   #
   $rcdpfiles .= " ".$datadir."/".$datafile;
}

close (DATAAREA);
      

$args = "/home/ttraffic/bin/merge_packets -d $date_measured "
      . "-s $sender "
      . "-R $trdir/RBYT "
      . "-L $confdir/LIST_OF_TESTBOXES "
      . "-V $trdir/VBYE "
      . "-S $datadir "
      . "-P $procdir ";

print $args, "\n";
# print $rcdpfiles, "\n";

$status = system ("$args $rcdpfiles");

print $status, "\n";
exit 0;
