#include <stdio.h>
#include <strings.h>
#include <stdlib.h>

#include "rv.h"

int rv_read_route (char * filearea, int debug) {
/*  =============
    This routine reads the file with the existing routes.  Returns 0 if the
    file doesn't exist OR could be successfully read, 1 if something went 
    wrong.

    $Author: ttraffic $
    $Date: 2000/03/28 01:17:35 $
    $Revision: 1.2 $
*/

#define MAXWORDS 500000
  char  line[MAXWORDS];
  char *point = &line[0];
  char **ap, *arg[MAXWORDS];
  FILE *fp;
  int   it;
  int   entries;

  /* Open file with existing routes */
  if (debug) { printf ("Opening file with existing routes\n"); }
  fp = fopen (filearea, "r");
  if (fp == NULL) {
     printf ("Warning: No RBYT file found\n");
     return FALSE;
  }

  /* Read the file */
  while ( (point = fgets (line, MAXWORDS, fp)) != NULL) {


     /* Split line into pieces */
     for (ap = arg ; (*ap=strsep(&point, " \t")) != NULL ; )
        if (**ap != '\0') 
           ++ap;
     /* Check if it is valid data */
     if (strcmp ("RBYT", arg[0]) != 0) {
        continue;
     }
     route_list[knownroutes] = (struct route_by_time *) 
                                    malloc (sizeof (struct route_by_time));
     route_list[knownroutes]->source    = strtoul (arg[2], NULL, 16); 
     route_list[knownroutes]->dest      = strtoul (arg[3], NULL, 16); 
     route_list[knownroutes]->starttime = atoi(arg[4]);
     entries                            = atoi(arg[5]);
     route_list[knownroutes]->entries   = entries; 


     route_list[knownroutes]->list      = (struct time_id_list *)
                                malloc (entries * sizeof (struct time_id_list));
     for (it=0 ; it< (route_list[knownroutes]->entries) ; it++) {

        (route_list[knownroutes]->list + it)->id       = atoi( arg[6+3*it] );
        (route_list[knownroutes]->list + it)->time     = atoi( arg[7+3*it] );
        (route_list[knownroutes]->list + it)->nmeasure = atoi( arg[8+3*it] );
     }
     knownroutes++;
     
  }

  fclose (fp);
  if (debug) {printf ("Processed file with existing routes\n");}
  return TRUE;
}
