#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

#include "rv.h"

int rv_read_vector (char * filearea, int debug) {
/*  ==============
    Read file with known vectors.  Returns 0 if the file could be read or
    doesn't exist (yet), 1 otherwise.

    $Author: ttraffic $
    $Date: 1999/08/13 13:28:11 $
    $Revision: 1.1 $
*/

#define MAXWORDS 50000
   char   line[MAXWORDS];
   char  *point = &line[0];
   char **ap;
   char  *arg[MAXWORDS];
   FILE  *fp;
   struct vector_by_elements *newvect;
   int i, entries, id;
 
   /* Open file with existing vectors */
   if (debug) {printf ("Opening file with existing vectors\n");}
   fp = fopen (filearea, "r");
   if (fp == NULL) {
      printf ("Warning, no VBYE file found\n");
      return FALSE;
   }

   /* Read the file */
   while ( (point = fgets (line, MAXWORDS, fp)) != NULL) {

      /* Split into pieces */
      for (ap = arg ; (*ap=strsep(&point, " \t")) != NULL ; )
         if (**ap != '\0')
            ++ap;
      /* Check if it is valid data */
      if (strcmp("VBYE", arg[0]) != 0) {
         continue;
      }
      /* Build new vector */
      newvect = (struct vector_by_elements *) 
                                   malloc (sizeof(struct vector_by_elements));
      id                    = atoi(arg[2]);
      newvect->ID           = id; 
      newvect->source       = strtoul (arg[3], NULL, 16); 
      newvect->dest         = strtoul (arg[4], NULL, 16);
      entries               = atoi(arg[5]);
      newvect->naddress     = entries; 
      newvect->address_list = (int *) malloc ( entries * sizeof(int) );
      for (i=0 ; i<entries ; i++) {
         *(newvect->address_list+i) = strtoul(arg[6+i], NULL, 16);
      }
      /* Update tables */
      id_to_vector[id] = newvect;
      all_vectors [id] = newvect;
      knownvectors++;
   }

   fclose (fp);
   if (debug) {printf ("Processed file with existing vectors\n");}
   return TRUE;

}
