#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>

/* $Id: testbox.h,v 1.8 2007/02/06 11:57:44 ruben Exp $ */

/* 
   Data structures related to the test-boxes 

   Test-box data is stored in a structure 3 elements:
     id        Arbitrary index
     name[25]  The name, ascii string, max 25 characters
     ipno      IP address, 32 bits as an unsigned int

*/


/* XXX FIXME change to dynamic allocation!!!! */
#define MAXTESTBOXES 1024 /* Maximum number of test-boxes */

struct test_box_data {
   int id;                              /* ID of test-box */
   char name[25];                       /* Name of the test-box */ 
   char ip_addr[INET_ADDRSTRLEN];       /* Its IP4 address if used */
   char ip6_addr[INET6_ADDRSTRLEN];     /* Its IP6 address if used */
   int family;                          /* AF_INET or AF_INET6 */
};

struct test_box_data test_box_list[MAXTESTBOXES];

int number_of_boxes;

int read_test_box_config (int, const char *, int);
int write_test_box_config (int, const char *);
int test_box_id (const char *);
int test_box_ip_id (char *, int);
int test_box_int (unsigned int);

#define BINARY  0
#define ASCII   1

/* TRUE and FALSE */
#ifndef TRUE
  #define TRUE (1)
  #define FALSE (0)
#endif
