#!/usr/local/bin/perl
#
#$Id: invoice.pl,v 1.3 2006/11/04 14:40:50 ruben Exp $
#

use POSIX qw(strftime);

if ( ($ARGV[0] ne "B1") &&
     ($ARGV[0] ne "B2") &&
     ($ARGV[0] ne "B3") ) {
 print "Usage invoice.pl B1   for a full invoice\n";
 print "      invoice.pl B2   for a pro-forma invoice\n";
 print "      invoice.pl B3   for a service fee invoice\n";
 exit;
}

$choice = $ARGV[0];

$tbaddress  = "";
$tbinvoice  = "";
$tbcustomer = "";
$tbprice    = "";
$tbinst     = "";
$tbship     = "";
$tbaddi     = "";
$tbserv     = "";
$tbvat      = "";
$tbtotal    = "";
$tbvisa     = "";
$tbamex     = "";
$tbmcec     = "";
$tbvatno    = "";
$tbdate     = "";
$vat        = "TRUE";

if ($choice eq "B1") { 
  $basename = "invoice_new_box";
  $temparea = "/tmp";
  while (<STDIN>) {
    chop $_;
    ($head, $tail) = split (/:\s+/, $_);
    if ($head eq "bill-name") {
       if ($tbaddress eq "") {
         $tbaddress = $tail; 
       } else {
         $tbaddress = $tail . " \\\\ " . $tbaddress;
       }
    } elsif ($head eq "bill-addr") {
      if ($tbaddress eq "") {
         $tbaddress = $tail; 
      } else {
         $tbaddress = $tbaddress . " \\\\ ". $tail ;
      }
    } elsif ($head eq "hard-sold") {
      ($tbprice, $tbinst, $tbship, $tbaddi, $tbvat) = split (/\s+/, $tail);
    } elsif ($head eq "serv-sold") {
      ($tbserv, $tbstart, $tbvat) = split (/\s+/, $tail);
      # Figure out the pro-rated service fee.
      # This gets the number of months left in the year 
      $tbstart = 13 - int ( ($tbstart % 10000) /100);
      # Pro-rate service fee.
      $tbserv = ($tbserv * $tbstart / 12);
    } elsif ($head eq "bill-vatno") {
      if ($tail ne "") { 
        $tbvatno = $tail ;
        $vat = "FALSE"; 
      }
    } elsif ($head eq "invoice") {
        ($tbdate, $dummy, $tbinvoice) = split (/\s+/, $tail);
      $tbdate = strftime "%d %B %Y", localtime(time()+30*86400);
    } elsif ($head eq "ttid") {
       $tbcustomer = $tail;
    }
  }


  $tbtotal = $tbprice + $tbinst + $tbship + $tbaddi + $tbserv;
  if ($vat eq "TRUE") {
    $tbvat = 0.19 * $tbtotal;
    $tbtotal = $tbtotal + $tbvat;
  }
  $tbvisa = 1.046 * $tbtotal;
  $tbamex = 1.049 * $tbtotal;
  $tbmcec = 1.050 * $tbtotal;

  $paramfile = $temparea."/".$basename."_param.tex";
  open TEXFILE, ">$paramfile";
  printf TEXFILE "\\def\\tbaddress{%s}\n",   $tbaddress;
  printf TEXFILE "\\def\\tbinvoice{%s}\n",   $tbinvoice;
  printf TEXFILE "\\def\\tbcustomer{%s}\n",  $tbcustomer;
  printf TEXFILE "\\def\\tbprice{%.2f}\n",   $tbprice;
  printf TEXFILE "\\def\\tbinst{%.2f}\n",    $tbinst;
  printf TEXFILE "\\def\\tbship{%.2f}\n",    $tbship;
  if ($tbaddi == 0) {
    printf TEXFILE "\\def\\tbaddi{N/A}\n",     $tbaddi;
  } else {
    printf TEXFILE "\\def\\tbaddi{%.2f}\n",    $tbaddi;
  }
  printf TEXFILE "\\def\\tbserv{%.2f}\n",    $tbserv;
  if ($vat eq "TRUE") {
    printf TEXFILE "\\def\\tbvat{%.2f}\n",     $tbvat;
  } else {
    printf TEXFILE "\\def\\tbvat{N/A}\n",      $tbvat;
  }
  printf TEXFILE "\\def\\tbtotal{%.2f}\n",   $tbtotal;
  printf TEXFILE "\\def\\tbvisa{%.2f}\n",    $tbvisa;
  printf TEXFILE "\\def\\tbamex{%.2f}\n",    $tbamex;
  printf TEXFILE "\\def\\tbmcec{%.2f}\n",    $tbmcec;
  printf TEXFILE "\\def\\tbvatno{%s}\n",     $tbvatno;
  printf TEXFILE "\\def\\tbdate{%s}\n",      $tbdate;
  close (TEXFILE);

  do_latex ($temparea, $basename);

} elsif  ($choice eq "B2") { 
  $basename = "proforma_invoice";
  $temparea = "/tmp";

  while (<STDIN>) {
    chop $_;
    ($head, $tail) = split (/:\s+/, $_);
    if ($head eq "bill-name") {
       if ($tbaddress eq "") {
         $tbaddress = $tail; 
       } else {
         $tbaddress = $tail . " \\\\ " . $tbaddress;
       }
    } elsif ($head eq "bill-addr") {
      if ($tbaddress eq "") {
         $tbaddress = $tail; 
      } else {
         $tbaddress = $tbaddress . " \\\\ ". $tail ;
      }
    } elsif ($head eq "hard-sold") {
      ($tbprice, $tbinst, $tbship, $tbaddi, $tbvat) = split (/\s+/, $tail);
      if ($tbvat eq "YES") {$vat = "TRUE";}
    } elsif ($head eq "bill-vatno") {
      if (strlen($tail) > 5) {
        $tbvatno = $tail ;
        $vat = "FALSE"; 
      }
    } elsif ($head eq "ttid") {
       $tbcustomer = $tail;
    }

  }

print $vat, "\n";

  $tbtotal = $tbprice + $tbaddi ;
  if ($vat eq "TRUE") {
    $tbvat = 0.19 * $tbtotal;
    $tbtotal += $tbvat;
  }

  $paramfile = $temparea."/".$basename."_param.tex";
  open TEXFILE, ">$paramfile";
  printf TEXFILE "\\def\\tbaddress{%s}\n",   $tbaddress;
  printf TEXFILE "\\def\\tbinvoice{%s}\n",   $tbinvoice;
  printf TEXFILE "\\def\\tbcustomer{%s}\n",  $tbcustomer;
  printf TEXFILE "\\def\\tbvatno{%s}\n",     $tbvatno;
  printf TEXFILE "\\def\\tbprice{%.2f}\n",   $tbprice;
  if ($tbaddi == 0) {
    printf TEXFILE "\\def\\tbaddi{N/A}\n",     $tbaddi;
  } else {
    printf TEXFILE "\\def\\tbaddi{%.2f}\n",    $tbaddi;
  }
  if ($vat eq "TRUE") {
    printf TEXFILE "\\def\\tbvat{%.2f}\n",     $tbvat;
  } else {
    printf TEXFILE "\\def\\tbvat{N/A}\n",      $tbvat;
  }
  printf TEXFILE "\\def\\tbtotal{%.2f}\n",   $tbtotal;
  close (TEXFILE);

  do_latex ($temparea, $basename);

} elsif ($choice eq "B3") { 
  $basename = "invoice_service";
  $temparea = "/tmp";

  while (<STDIN>) {
    chop $_;
    ($head, $tail) = split (/:\s+/, $_);
    if ($head eq "bill-name") {
       if ($tbaddress eq "") {
         $tbaddress = $tail; 
       } else {
         $tbaddress = $tail . " \\\\ " . $tbaddress;
       }
    } elsif ($head eq "bill-addr") {
      if ($tbaddress eq "") {
         $tbaddress = $tail; 
      } else {
         $tbaddress = $tbaddress . " \\\\ ". $tail ;
      }
    } elsif ($head eq "serv-sold") {
      ($tbserv, $tbstart, $tbvat) = split (/\s+/, $tail);
    } elsif ($head eq "bill-vatno") {
      if ($tail ne "") { 
        $tbvatno = $tail ;
        $vat = "FALSE"; 
      }
    } elsif ($head eq "invoice") {
        ($tbdate, $dummy, $tbinvoice) = split (/\s+/, $tail);
      $tbdate = strftime "%d %B %Y", localtime(time()+30*86400);
    } elsif ($head eq "ttid") {
       $tbcustomer = $tail;
    }

  }

  $tbtotal = $tbprice + $tbinst + $tbship + $tbaddi + $tbserv;
  if ($vat eq "TRUE") {
    $tbvat = 0.19 * $tbtotal;
    $tbtotal = $tbtotal + $tbvat;
  }
  $tbvisa = 1.046 * $tbtotal;
  $tbamex = 1.049 * $tbtotal;
  $tbmcec = 1.050 * $tbtotal;

  $paramfile = $temparea."/".$basename."_param.tex";
  open TEXFILE, ">$paramfile";
  printf TEXFILE "\\def\\tbaddress{%s}\n",   $tbaddress;
  printf TEXFILE "\\def\\tbinvoice{%s}\n",   $tbinvoice;
  printf TEXFILE "\\def\\tbcustomer{%s}\n",  $tbcustomer;
  printf TEXFILE "\\def\\tbserv{%.2f}\n",    $tbserv;
  if ($vat eq "TRUE") {
    printf TEXFILE "\\def\\tbvat{%.2f}\n",     $tbvat;
  } else {
    printf TEXFILE "\\def\\tbvat{N/A}\n",      $tbvat;
  }
  printf TEXFILE "\\def\\tbtotal{%.2f}\n",   $tbtotal;
  printf TEXFILE "\\def\\tbvisa{%.2f}\n",    $tbvisa;
  printf TEXFILE "\\def\\tbamex{%.2f}\n",    $tbamex;
  printf TEXFILE "\\def\\tbmcec{%.2f}\n",    $tbmcec;
  printf TEXFILE "\\def\\tbvatno{%s}\n",     $tbvatno;
  printf TEXFILE "\\def\\tbdate{%s}\n",      $tbdate;
  close (TEXFILE);

  do_latex ($temparea, $basename);

}

exit;

sub do_latex {

  $texstuff = "/ncc/ttpro/ttreg/invoice";
  $latexbin = "/usr/share/texmf/bin/";
  `cp    $texstuff/$basename.template $temparea/$basename.tex`;
  `cp    $texstuff/fey.mf          $temparea`;
  `cp    $texstuff/feymr10.720pk   $temparea`;
  `cp    $texstuff/feymr10.mf      $temparea`;
  `cp    $texstuff/feymr10.tfm     $temparea`;
  `cp    $texstuff/ripe_letter.cfg $temparea`;
  `cp    $texstuff/ripe_letter.cls $temparea`;
  `cp    $texstuff/ripe_logo.ps    $temparea`;
  `cp    $texstuff/eurosym.ps      $temparea`;
  `cd    $temparea ; $latexbin/latex $temparea/$basename`;

  if (!(-e "$temparea/$basename.dvi")) {
    print "Latex error\n"; 
    exit;
  }

  `cd $temparea ; /usr/share/texmf/bin/dvips $basename`; 

  print "\n\n*** Invoice available as $temparea/$basename.ps *** \n\n";
  print "Please print and check before sending off.\n";
  print "Customize by editting $basename.tex or\n";
  print "and rerunning latex and dvips by hand.\n";

}
