#------------------------------------------------------------------------------
#
#$Id: reform.pl,v 1.2 2006/11/04 14:40:50 ruben Exp $
#
# Module Header
# Filename          : reform
# Purpose           : re-format registry information
# Author            : Roderik/Daniel
# Date              : 17 November 1997 (& earlier)
# Description       : This basically reads registry files and writes them
#                     back again, which will take care of changes to
#                     attribute ordering for all registries.
# Language Version  : Perl (Tested with v5.00401)
# OSs Tested        : BSD/OS 2.1
# Command Line      : reg -x reform [-v]
# Input Files       : $REGDIR/* (usually /ncc/registries/*)
# Output Files      :  ""                              ""
# External Programs : perl module regwrite.pm (which also uses regread)
# Problems          :
# To Do             :
# Comments          : This is a 'reg x-script' which can be called with
#                     'reg -x <scriptname>. However, Why not just 'use'
#                     the needed modules in here too? Now it can also be 
#                     called directly if we want...
#                     (Note: 'use strict' is necessary here because the strict
#                     directive apparently doesn't survive a 'do <filename>'.
# The following line will be read by 'reg -x':
# reg-x-description: re-format registry information
#------------------------------------------------------------------------------

use strict;
use regwrite;
use Getopt::Std;

my (@f);	# registries
my ($f);	# current registry

die "reform: Wrong argument specified (only -v is possible)\n" if !getopts('v');

# With the new regwrite::changereg routine, this has shrunk unbelievably :-)
@f = regfiles(0);
while ($f = shift(@f)) {
    print "$f\n" if $Getopt::Std::opt_v;
    changereg($f,0,sub{return $_[0]});
}
