.\" $Id: reg.man,v 1.2 2006/11/04 14:43:44 ruben Exp $
.TH REG 1 
.SH NAME
reg \- registry database tool
.SH SYNOPSIS
.B reg 
.B [-ALBRIUSPenfv]
.B [-r
.IB dir ]
.I regex
.sp
.B reg 
.BI -g[i]
.B [-r
.IB dir ]
.I regex
.sp
.B reg 
.BI -l
.B [-r
.IB dir ]
.sp
.B reg 
.B [-r
.IB dir ]
.BI -x 
.I options
.SH DESCRIPTION
.IX  "reg command"  ""  "\fLref\fP \(em registry database tool
.I reg
is a tool to maintain the database of local registries.
Normally it displays only the published data about a particular 
local registry identified by its registry ID matching
.I regex.
.I regex
is a perl regular expression;
this means that IDs can be abbreviated as long as they are unique.
If more than one registry ID matches
.I regex,
a list of all matching IDs together with their
.I org
attribute is shown.
Note that 
.I reg
.I de
will not just list registries in Germany (starting with de.) but all
those whose IDs contain the string
.I de.
To list only those starting with
.I de
use the command
.I reg
.I '^de'.

To view a schema of the registry information use
.I reg
.I -ev
on an existing registry.
Leaving the editory without making any changes will not cause an update.

.TP 0.6i
.B -A
show all registry data (this not automatically include person objects from the
RIPE DB).
.TP 0.6i
.B -B
show billing relevant data.
.TP 0.6i
.B -I
show information concerning address registration
.TP 0.6i
.B -L
show information about registry related mailing lists.
.TP 0.6i
.B -P
show referenced persons from the RIPE database.
.TP 0.6i
.B -R
show data concerning registry setup/training/closing
.TP 0.6i
.B -S
show the current service level as derived from the billing data
in a one line summary.
.TP 0.6i
.B -U
show data related to audits

.TP 0.6i
.B -e
This is used to maintain the entries without knowing their location.
It calls the editor with a template consisting of the current data
stored about this registry and a blank version of any attribute 
that can be added.
Note that it is now possible to create multi-line attributes in
a way much similar to RFC822 headers. Just start the continuation
lines with whitespace. This works for designated attributes only.
All attributes which require a date, have today's date filled in. 
Blank attributes and those with a date only will be ignored after the edit and
will not be added to the database. 
The appropriate revision control mechanisms will be used automatically
if the entry appears to be under revision control.
If no changes are made no reveision delta will be created and the
entry will appear untouched.

.TP 0.6i
.B -f
produce a form containing all information to be provided by a 
local registry on the standard output.
Works with 
.B -v
to create a verbose form.

.TP 0.6i
.B -g
list registries containing data.
This will search (grep) through all the registries 
and display the one which contains the pattern specified in 
.I regex
if only one such registry exists. 
If more than one matching registry is found,
it will display a short description of all matching registries. 
You can use
.BR perl(1)
regular expressions in regex ... with caution.
.TP 0.6i
.B -i
do case insensitive matching in 
.B -g
searches.

.TP 0.6i
.B -l
list the short descriptions of all registries, one line per entry.

.TP 0.6i
.B -n
will enter a new registry. 
It calls the editor with a template.
The template will contain whatever data about the registry which can
be determined automagically from previous versions of the
registry database or other sources. All attributes which require a
date, have today's date filled in. All attributes which cannot
be deduced are left blank. Blank attributes and those with a date
only will be ignored after the edit.
See also
.B -v!

.TP 0.6i
.B -r reg
selects another registry database. The argument is simply the directory
where the relevant files are located.
If this option is used with creation/update of registry info
no automatic notifications are performed and 
the modifications are not 'published'.

.TP 0.6i
.B -v
produce a very verbose version of the template or form which explains each
attribute.
.B Now also outputs verbose data on normal queries.

.TP 0.6i
.B -x 
execute a special (expert) function.
This should not be done without knowing exactly what one is doing.
.sp 0
The first argument behind 
.B -x
is the name of the function (which is a filename of a separate
script).  Any options after the 
function
name are passed to the function, not evaluated by reg.
(This implies that the 
.B [-r dir]
option should come before the
function
name.)

.SH FILES
REGDIR-CONF
- standard location of files containing the registry database information,
one flat file per registry.
.SH "ENVIRONMENT"
EDITOR  - to determine just that
.br
REGARGS - standard set of flags to be used if no flags present
.SH "SEE ALSO"
.BR perl (1)
.SH AUTHORS
Daniel Karrenberg <dfk@ripe.net>
