#! /usr/local/bin/perl -wT
# $Id: showplots.cgi,v 1.5 2004/02/20 15:28:27 ruben Exp $

use 5.006;
use strict;
use lib qw(/home/ttraffic/lib/perl5.6.0);
use CGI 2.86 qw/-newstyle_urls -nosticky :standard :imagemap/;
use CGI::Carp qw(fatalsToBrowser);
use POSIX;
use RIPE::TTM qw(:all -nohotlist);

# TODO
#
# - Summary support
# - POD support
# - IPv6 Support

$ENV{'PATH'} 		= "/bin/:/usr/bin:/ncc/ttpro/bin:/home/ttraffic/bin";

sub showplotoverview($$;$);
sub cleanup_query_string($$$);

my ($header,$footer, $subtitle);

my $gfxformat = "gif";

my (
	$cgi,
	$view,
	$period,
	$self_url,
	);

# XXX Add your views and descriptions here, not in the code. the code will adapt

my %views	= (
				"Delay"		=> "",
				"Jitter"	=> "ipdv",
				"Trends"	=> "trends",
			);
my @views_order = ("Delay", "Trends", "Jitter");

my %periods	= (
				"Day"	=> "day",
				"Week"	=> "week",
				"Month" => "month",
				"6 Month Trend"	=> "trends",
			);

my %periods_duration	= (
				"Day"	=> 86400,
				"Week"	=> 7 * 86400,
				"Month" => 30 * 86400,
				"6 Month Trend"	=> 6 * 30 * 86400,
			);

my %view_period	= (
				""		=> [qw(Day Week Month)],
				"ipdv."		=> [qw(Day Week)],
				"trends."	=> [("6 Month Trend")],
			);

# XXX Yes it is "ugly", but more readable than doing inline @{[]} map code escapes all the time...
# Part of the return to plot overview navigation
my %view_view	= (
				""		=> "",
				"ipdv."		=> "ipdv",
				"trends."	=> "trends",
			);

# XXX the _order arrays are because of keys %ahash returns random ordered data

# Make usable through SSI and standalone operation
$cgi = exists($ENV{'REDIRECT_QUERY_STRING'}) ?
		new CGI($ENV{'REDIRECT_QUERY_STRING'}) :
		new CGI;

$self_url = exists($ENV{'REDIRECT_SCRIPT_URL'}) ? 
				$ENV{'REDIRECT_SCRIPT_URL'} :
				$cgi->url(-relative=>1);

# Dump the page

die "Need source and destination" if (!(defined($cgi->param("src"))&& defined($cgi->param("dst"))));


$subtitle = exists $ENV{'TTMCHAIN'} ? "Plot Overview for $ENV{'TTMCHAIN'}"
									: "Plot Overview";
$subtitle = $cgi->param("ipv") == 6 ? "IPv6 $subtitle" 
						: "IPv4 $subtitle";
$subtitle .= ", boxes [" . $cgi->param("src") . "&nbsp;-&nbsp;" . $cgi->param("dst") . "]";

$subtitle = "Hotlist $subtitle" if $#RIPE::TTM::hotlist > 0;

($header,$footer) = get_headers("Test Traffic Measurement","$subtitle");

print header, $header,	table(
		Tr(td(showplotoverview($cgi->param("src"),$cgi->param("dst"), $cgi->param("ipv")))),
	), 
$footer;

sub showplotoverview($$;$)
{
	my($src,$dst,$ipv) = @_;
	my ($ipv_prefix, @shortcutplots);

	$ipv = 4 unless defined($ipv);
	$ipv_prefix = $ipv == 6 ? "IPv6." : "";

	@shortcutplots = map {
			my ($plottype) = $_;
			my ($view) = length($views{$_}) ? "$views{$_}." : $views{$_};
			map {
				td(table(
				Tr(td( { -align=>"center"}, i("$plottype plot last $_"))),
				Tr(td( { -align=>"center"}, a( { -href=> "#$periods{$_}${view}" }, img({ -width => 226, -height => 167, -border => 0, -src=>"$RIPE::TTM::base_url/$periods{$_}/mini/${ipv_prefix}${view}${src}.${dst}.${gfxformat}", -alt=> "$plottype plot"  })))),
				))
			} @{$view_period{$view}}
		} @views_order;

	{
		my (@tmp);

		while ($#shortcutplots > -1)
		{
			my ($left,$right);
			$left = shift(@shortcutplots);
			$right = shift(@shortcutplots);
			push(@tmp, Tr($left,$right));
		}

		@shortcutplots = @tmp;
	}

	return CGI::div( {-align=>"center"}, 
		table( 
			Tr(td( { -align=>"center"}, span( { -style => "font-size: larger"}, "$src - $RIPE::TTM::gpsinfo{$src}{'longdesc'}"))),
			Tr(td( { -align=>"center"}, span( { -style => "font-size: larger"}, "to"))),
			Tr(td( { -align=>"center"}, span( { -style => "font-size: larger"}, "$dst - $RIPE::TTM::gpsinfo{$dst}{'longdesc'}"))),
			Tr(td( { -align=>"center"},
						$#RIPE::TTM::hotlist > 0 ? 
								p(a({ -href => $cgi->url(-absolute=>1, -query=>1) . ";nohotlist"  }, "turn off"), " your hotlist temporarily or ", 
								a({ -href => "${RIPE::TTM::hotlist_url}?ipv=$ipv" }, "edit"), " the one that is currently active") 
							: defined($cgi->param('nohotlist')) ? 
								p(a({ -href => $cgi->url(-relative=>1) . "?" . cleanup_query_string("nohotlist", undef, $cgi) }, "turn on"), " temporarily disabled hotlist...") 
								: p(a({ -href => "${RIPE::TTM::hotlist_url}?ipv=$ipv" }, "create a hotlist"), " to discard plots you are not interested in..."),
				)),
			Tr(td(hr)),
			Tr(td({-align=>"center"}, table( {-width=>"80%"}, @shortcutplots))),
			Tr(td(hr)),
			Tr(td(table( { -width=>"100%"}, Tr(
				td( { -align=>"center"}, a({href=> "$self_url?ipv=$ipv;src=${dst};dst=${src}"}, "[Swap Source and Destination]")),
				td( { -align=>"center"}, a({href=> "$RIPE::TTM::overview_url?ipv=$ipv;"}, "[Select a new Source]")),
				td( { -align=>"center"}, a({href=> "$RIPE::TTM::overview_url?ipv=$ipv;node=$src"}, "[Select a new Destination]")),
				)))),
			Tr(td(hr)),
			Tr(td(table(
			map {
				my ($plottype) = $_;
				my ($view) = length($views{$_}) ? "$views{$_}." : $views{$_};
				map {
					my ($timestamp_start, $timestamp_end, $maptype, $URLpod, $URLrouting, $URLoverview, $URLsummary);


					# Obtain the enddate from the files last upload
					$timestamp_end = (stat(getcwd() ."/$periods{$_}/${view}${src}.${dst}.${gfxformat}"))[9];

					# Cut off hours
					$timestamp_end = get_timestamp(strftime("%Y%m%d", gmtime($timestamp_end)), "00:00");
					$timestamp_start = $timestamp_end - $periods_duration{$_};

					$maptype = $views{$plottype} ? ( $views{$plottype} ne "ipdv" ? $views{$plottype} : "jitter" ) : "delay";

					$URLoverview = new CGI("ipv=$ipv;node=$src;period=$periods{$_}" . ( $views{$plottype} ? ";view=$views{$plottype}" : "" ) );
					$URLpod = new CGI("ipv=$ipv;SRC=$src;DST=$dst;mindelay=0;maxdelay=250;plottype=$maptype;embedded=true");
					$URLrouting = new CGI("ipv=$ipv;SRC=$src;DST=$dst");
					$URLsummary = new CGI("ipv=$ipv;boxname=$src;period=$periods{$_}");

					$URLpod->param( -name => 'date_start', -value => strftime("%Y%m%d", gmtime($timestamp_start )));
					$URLpod->param( -name => 'time_start', -value => strftime("%H:%M",   gmtime($timestamp_start )));
					$URLpod->param( -name => 'date_end', -value => strftime("%Y%m%d",   gmtime($timestamp_end )));
					$URLpod->param( -name => 'time_end', -value => strftime("%H:%M",    gmtime($timestamp_end )));

					$URLrouting->param( -name => 'date_start', -value => strftime("%Y%m%d", gmtime($timestamp_start )));
					$URLrouting->param( -name => 'time_start', -value => strftime("%H:%M",   gmtime($timestamp_start )));
					$URLrouting->param( -name => 'date_end', -value => strftime("%Y%m%d",   gmtime($timestamp_end )));
					$URLrouting->param( -name => 'time_end', -value => strftime("%H:%M",    gmtime($timestamp_end )));

					Tr( td("&nbsp;"), 
						td( { -valign=>"top", -align=>"center"}, a( { -name=> "$periods{$_}${view}" }, ""), p({-style=>"font-weight: bold; font-size: larger" }, "$plottype plot of ${src} to ${dst}: Last $_"),
							table( { -width=>"100%"}, Tr(
								td( { -align=>"center" }, a({href=> "$self_url?ipv=$ipv;src=${dst};dst=${src}#$periods{$_}${view}"}, "[Swap Source and Destination]")),
								td( { -align=>"center" }, a({href=> "$RIPE::TTM::overview_url?ipv=$ipv;period=$periods{$_};view=$view_view{$view}"}, "[Select a new Source]")),
								td( { -align=>"center" }, a({href=> "$RIPE::TTM::overview_url?ipv=$ipv;node=$src;period=$periods{$_};view=$view_view{$view}#${dst}"}, "[Select a new Destination]")),
								td( { -align=>"center" }, "[" . join('/',map  { $ipv == $_ ? u("IPv$_") : a({ -href => "$self_url?" . cleanup_query_string("ipv", $_, $cgi) }, "IPv$_" ) } (4,6)) . "]"),
								)),
							),
						td(
							CGI::div( { -style=> "font-size: x-small;" }, table(
								Tr(td({-align=>"right"}, a({ -href=>"#top" }, "Select another period and/or plot type for this box..."))),
								Tr(td({-align=>"right"}, a({ -href=>"${RIPE::TTM::overview_url}?" . $URLoverview->query_string() . "#$dst" }, "See the $plottype overview for this period..."))),
								Tr(td({-align=>"right"}, $periods{$_} =~ /^(day|week)$/ ? a({ -href=>"${RIPE::TTM::summary_url}?" . $URLsummary->query_string() . "#$dst" }, "See the summaries for this period...") : i("No summaries available for this period..."))),
								Tr(td({-align=>"right"}, a({ -href=>"${RIPE::TTM::pod_url}?" . $URLpod->query_string() . "#plot" }, "$plottype plots on demand for this period..."))),
								Tr(td({-align=>"right"}, a({ -href=>"${RIPE::TTM::routing_url}?" . $URLrouting->query_string() . "#result" }, "See the routing vectors for this period..."))),
							))
						)
					),
					Tr(td( { -colspan => 3, -align=>"center"}, 
						img({ -width=>903, -height=>666, -border=>0, -usemap => sprintf("#%s", $periods{$_} . $maptype ), -src=>"$RIPE::TTM::base_url/$periods{$_}/${ipv_prefix}${view}${src}.${dst}.${gfxformat}", -alt=> "$plottype plot"  }),
						createzoommap($URLpod, $timestamp_start, $timestamp_end, 3, $maptype, "plot", $periods{$_} . $maptype),	
					)),
					Tr(td( { colspan => 3, -align=>"center"}, hr)),
				} @{$view_period{$view}}
				
			} @views_order
			)))
		),
	);
}

# vi:ts=4:sw=4:
