#!/usr/local/bin/perl
#
# $Id: addgroup.cgi,v 1.3 2001/04/19 11:19:29 ana Exp $
#
# Copyright (c) 2001  RIPE NCC
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; 
# IN NO EVENT SHALL AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS 
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE 
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE 
# USE OR PERFORMANCE OF THIS SOFTWARE.
#
#-----------------------------------------------------------------------
# Module Header
# Filename          :   addgroup.cgi
# Purpose           :   Add a new box to the list of groups
# Authors           :   Ana Susanj <ana@ripe.net>, RIPE NCC
# Date              :   17-APR-2001
# Description       :   Component of TTwwwpages for Test Traffic project
# Input             :   through the web interface
# Output            :   dbm files in /var/www/conf/tt and web
# Language Version  :   perl v5.6.0
#-----------------------------------------------------------------------

use CGI;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use DB_File;

my $query = new CGI;
my $user = $ENV{REMOTE_USER};
my $dbmgroupfile = "/var/www/conf/tt/dbmgroup";
my $dbmlocfile = "/var/www/conf/tt/dbmloc";
my %groups;
my $func = $query->param('func');
my $modmode = $query->param('modmode') || "showform";
my $grpmode = $query->param('grpmode') || "showform";
my $locmode = $query->param('locmode') || "showform";

tie (%dbmgroup, 'DB_File', $dbmgroupfile) or die "couldn't tie: $!";
tie (%dbmloc, 'DB_File', $dbmlocfile) or die "couldn't tie: $!";

print "Content-Type: text/html\n\n";
print "<HTML><BODY bgcolor=\"#ffffff\" text=\"#000000\">\n";
print "<form method=\"post\" action=\"addgroup.cgi\">";

%States = (
	'Default'	=> \&default,
	'Modify'	=> \&modify,
	'Groups' => \&chgroups,
	'Location' => \&chloc,
	'Showall'	=> \&showall,
);

if ($States{$func}) {
	&{$States{$func}};
} else {
	&{$States{Default}};
}

# this works with latest version of perl only
#if ($States{$func}) {
#	$States{$func}->();
#} else {
#	$States{Default}->();
#}

# sub default
# The front page that the admin gets. 
sub default {

	if ($user eq 'ripe') {
		print "this is the script that will let you add a new group for user 'ripe'. Once you add the new group, you can start adding users to it.<br>";
		print submit( -NAME => "func", -VALUE => "Groups"), "<br>";
		print submit( -NAME => "func", -VALUE => "Location"), "<br>";
		print "<br>";
	} else {
		print "you are not allowed to run this script";
	}
}

# sub chloc
# change location for $group
sub chloc {
	if ($locmode eq "showform") {
		print "tick a box next to a username that you wish to modify:<br><br>";
		@groups{split (/,/, $dbmgroup{$user})} = ();
		foreach (sort keys %groups) {
				unless ($_ =~ /_admin$/) {
					push(@tt, $_);
				}
		}
		print "<table border=\"0\">\n";
		while (@tt) {
			@threegroup = splice (@tt, 0, 3); 
			print "<tr>";
			foreach (@threegroup) {
			print "<td>";
				print "<input type=\"radio\" name=\"group\" value=\"$_\">";
				print "<font color=\"#ff0000\">$_</font> - $dbmloc{$_} ";
				print "</font></td>";
			}
			print "</tr>";
		}
		print "</table>";
		print "<input type=\"hidden\" name=\"locmode\" value=\"enterloc\"><br>";
		print hidden( -NAME => "func", -VALUE => "Location");
		print "<input type=\"submit\"  value=\"Change Location\">";
	}
	if ($locmode eq "enterloc") {
		$group = 	$query->param('group');
		print "enter new location for box $group <br><br>";
		print "group's location <input type=\"text\" name=\"loc\"><br>";
		print "<input type=\"hidden\" name=\"locmode\" value=\"chloc\"><br>";
		print "<input type=\"hidden\" name=\"group\" value=\"$group\"><br>";
		print hidden( -NAME => "func", -VALUE => "Location");
		print "<input type=\"submit\"  value=\"Change Location\">";
	}
	if ($locmode eq "chloc") {
		$loc = $query->param('loc');
		$group = $query->param('group');
		print "changing location for $group<br>";

		$dbmloc{$group} = $loc;
		print "Done.";
	}
}

# sub chgroups
# Change groups for $user
sub chgroups {

if ($grpmode eq "showform") {
	my %usergroups;
	my $user_ok = 1;
	unless ($user eq "ripe") {
		$user_ok = 0;
		print "you are not allowed to use this script<br>";
	}
	if ($user_ok == 1) {
		print "group <input type=\"text\" name=\"group\" value=\"tt\" maxlength=\"6\" size=\"6\"><br>";
		print "group's location <input type=\"text\" name=\"loc\"><br>";
		print "<input type=\"hidden\" name=\"grpmode\" value=\"chgroups\"><br>";
		print hidden( -NAME => "func", -VALUE => "Groups");
		print "<input type=\"submit\"  value=\"add group\">";
    @groups{split (/,/, $dbmgroup{$user})} = ();
    @viewgroups = grep { s/_admin$// } sort keys %groups;
    @admingroups = map {$_."_admin"} @viewgroups;
    while (@viewgroups) {
			@tengroup_v = splice (@viewgroups, 0, 10);
			@tengroup_a = splice (@admingroups, 0, 10);
			print "<table border=\"0\">\n";
			print "<tr bgcolor=\"#0000ff\"><td><font color=\"#ffffff\">View only:</font></td><td><font color=\"#ffffff\">";
			foreach (@tengroup_v) {
				print "$_  ";
			}
			print "</font></td></tr>";
			print "<tr bgcolor=\"#ff0000\"><td><font color=\"#ffffff\">Admin rights:</td><td>";
			print "<font color=\"#ffffff\">";
			foreach (@tengroup_a) {
				my $i = $_;
				$i =~ s/_admin$//;
				print "$i  ";
			}
			print "</font></td></tr></table>";
			print "<br>";
			} 
	}
}

if ($grpmode eq "chgroups") {
	$group = $query->param('group');
	$loc = $query->param('loc');
	my %admingroups;
	my @immusergroups;
	my $user_ok = 1;
	unless ($user eq "ripe") {
		$user_ok = 0;
		print "you are not allowed to run this script<br>";
	}
	if (length $group < 4) {
		$n = $group;
		$user_ok = 0;
		print "ERROR: group should be at least 4 characters long<br>";
		unless ($r =~ m/^tt\d{1,3}$/) {
			print "ERROR: group should be of the following format: ttxy or ttxyz<br>";
		}
	}
	foreach $r (split (/,/, $dbmgroup{$user})) {
		unless ($r eq $group) {
			push (@newgroups, $r);
		} else {
			print "ERROR: group already exists<br>";
			$user_ok = 0;
			exit 1;
		}
	}
	if ($user_ok == 1) { 
		push (@newgroups, $group);
		push (@newgroups, $group._admin);
		$dbmgroup{$user} = join (",", @newgroups);
		$dbmloc{$group} = $loc;
		@groupsnow{split (/,/, $dbmgroup{$user})} = (); 
		if (%groupsnow) {
			print "$user is now in $dbmgroup{$user}";
			print "<br><br>box $group" . "'s" . " location is $dbmloc{$group}"; 
		} 
	}
}
}

print "</form>";
print "</body></html>";

untie %dbmgroup;
untie %dbmloc;
