#!/usr/local/bin/perl
# $Id: admin.cgi,v 1.4 2001/04/19 11:19:29 ana Exp $
#
# Copyright (c) 2001  RIPE NCC
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; 
# IN NO EVENT SHALL AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS 
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE 
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE 
# USE OR PERFORMANCE OF THIS SOFTWARE.
#
#-----------------------------------------------------------------------
# Module Header
# Filename          :   admin.cgi
# Purpose           :   Admin the system with multiple users and groups
# Authors           :   Ana Susanj <ana@ripe.net>, RIPE NCC
# Date              :   17-APR-2001
# Description       :   Component of TTwwwpages for Test Traffic project
# Input             :   through the web interface
# Output            :   dbm files in /var/www/conf/tt and web
# Language Version  :   perl v5.6.0
#-----------------------------------------------------------------------

use CGI;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use DB_File;

my $query = new CGI;
my $user = $ENV{REMOTE_USER};
my $dbmpassfile = "/var/www/conf/tt/dbmpasswd";
my $dbmgroupfile = "/var/www/conf/tt/dbmgroup";
my $dbmnamefile = "/var/www/conf/tt/dbmname";
my %groups;
my $func = $query->param('func');
my $addmode = $query->param('addmode') || "showform";
my $delmode = $query->param('delmode') || "showform";
my $modmode = $query->param('modmode') || "showform";
my $grpmode = $query->param('grpmode') || "showform";
my $rnmode = $query->param('rnmode') || "showform";
my $pwdmode = $query->param('pwdmode') || "showform";

tie (%dbmpasswd, 'DB_File', $dbmpassfile) or die "couldn't tie: $!";
tie (%dbmgroup, 'DB_File', $dbmgroupfile) or die "couldn't tie: $!";
tie (%dbmname, 'DB_File', $dbmnamefile) or die "couldn't tie: $!";

print "Content-Type: text/html\n\n";
print "<HTML><BODY bgcolor=\"#ffffff\" text=\"#000000\">\n";
print "<form method=\"post\" action=\"admin.cgi\">";

%States = (
	'Default'	=> \&default,
	'Add'		=> \&add,
	'Modify'	=> \&modify,
	'Delete'	=> \&delete,
	'Password'	=> \&chpasswd,	
	'Groups'	=> \&chgroups,	
	'Realname'	=> \&chrealname,	
	'Showall'	=> \&showall,
	'Logout'	=> \&logout
);

if ($States{$func}) {
	&{$States{$func}};
} else {
	&{$States{Default}};
}

# this works with latest version of perl only
#if ($States{$func}) {
#	$States{$func}->();
#} else {
#	$States{Default}->();
#}

# sub default
# The front page that the admin gets. 
sub default {

	my $is_admin = 0;
	my $realname = $dbmname{$username};
	@tmpgroups{split (/,/, $dbmgroup{$user})} = ();

	foreach (keys %tmpgroups) {
		if (/_admin$/) {
			$is_admin = 1;
		}
	}

	if ($is_admin == 1) {
		print " user $user ($realname) logged in<br><br>";
		print "add a new user to your groups:"; 
		print submit( -NAME => "func", -VALUE => "Add");
		print "<br>";
		print "modify users already in your groups:";
		print submit( -NAME => "func", -VALUE => "Modify");
		print "<br>";
		if ($user eq 'ripe') {
			print "<a href=\"addgroup.cgi\">add a new group</a><br>";
		}
	} else {
		print "you are not in any admin groups<br>";
	}
}

# sub logout
# It doesn't do anything right now. I got it to send an error
# message back but it still didn't force browser to forget
# the past page. If a user pressed back button, they could 
# still see everything.. If someoen has ideas, please fix.  
sub logout {
	print "logout";
}

# sub add
# Add user. Needed: $username, $password, $groups
# Check: - that the $user belongs to ttxy_admin group, for all groups
#        - if the username already exists, if yes, return error
#        - if the username is less than three characters long, if yes, return error
#        - if the password is less than six characters long, if yes, return error
# If the above tests are passed, add a username
sub add {

if ($addmode eq "showform") {
	print "add a username:<br><br>";
	print "real name: <input type=\"text\" name=\"realname\"><br>";
	print "username: <input type=\"text\" name=\"username\"><br>";
	print "password: <input type=\"password\" name=\"password\"><br>";
	print "groups:<br> ";
	@groups{split (/,/, $dbmgroup{$user})} = ();

	@showgroups = map { ($_, $_."_admin") } grep { s/_admin$// } sort keys %groups;

	@viewgroups = grep { s/_admin$// } sort keys %groups;
	@admingroups = map {$_."_admin"} @viewgroups;

	while (@viewgroups) { 
		@tengroup_v = splice (@viewgroups, 0, 10);
		@tengroup_a = splice (@admingroups, 0, 10);

		@labels_a{@tengroup_a} = @tengroup_v;

		print "<table border=\"0\">\n";

		print "<tr bgcolor=\"#0000ff\"><td><font color=\"#ffffff\">View only:</font></td><td><font color=\"#ffffff\">";
		print checkbox_group( -name => "groups",
				      -value => [ @tengroup_v ] );

		print "</font></td></tr>";
		print "<tr bgcolor=\"#ff0000\"><td><font color=\"#ffffff\">Admin rights:</td><td>";
		print "<font color=\"#ffffff\">";
		print checkbox_group( -name => "groups",
				      -value => [ @tengroup_a ], 
				      -labels => \%labels_a
			 	    );
		print "</font></td></tr></table>";

		print "<br>";
	}

	print "<input type=\"hidden\" name=\"addmode\" value=\"doadd\"><br>";
	print hidden( -NAME => "func", -VALUE => "Add");
	print "<input type=\"submit\" value=\"Add new user\">";
}

if ($addmode eq "doadd") {

    my $user_ok = 1;
    my $username = $query->param('username');
    my @reqgroups = $query->param('groups');
    my $password = $query->param('password');
		my $realname = $query->param('realname');
    my %allowedgroups;

    @allowedgroups{split (/,/, $dbmgroup{$user})} = ();

    foreach (@reqgroups) {
		my $r = $_;
		$r =~ s/_admin$//;
        unless (exists $allowedgroups{$r."_admin"}) {
            $user_ok = 0;
            print "ERROR: you are not admin of \"$r\" <br>";
        }
    }

    foreach (sort keys %dbmpasswd) {
        if ($_ eq $username) {
            $user_ok = 0;
            print "ERROR: username already exists, ";
			print "maybe you just want to <a href=\"admin.cgi\">modify the username??</a><br>";
        }
    }

	if (length $password < 6) {
		$user_ok = 0;
		print "ERROR: password should be more than 6 characters long<br>";
	}

	if (length $realname < 1) {
		$user_ok = 0;
		print "ERROR: please specify user's real name<br>";
	}

	if (length $username < 3) {
		$user_ok = 0;
		print "ERROR: username should be more than 3 characters long<br>";
	}

	if ($user_ok == 1) {
		my $groups = join (",",@reqgroups);
		$dbmpasswd{$username} = crypt($password,'0k');
		$dbmgroup{$username} = $groups;
		$dbmname{$username} = $realname;
		print "$username successfully added to the $groups TT groups<br>";
	}
}

}


# sub modify
# Modify username. Display list of usernames that belong to ttxy, with
# a checkbox next to each. Clicking on checkbox takes you to next stage
# where you can choose to enter new password, add a group or remove a group.
# Check: - that the $user belongs to all groups to which $username wants to 
#          be added, else return error
#        - if the password is less than six characters, if yes, return error
sub modify {

if ($modmode eq "showform") {

    my @tt;
    print "tick a box next to a username that you wish to modify:<br><br>";

    @groups{split (/,/, $dbmgroup{$user})} = ();
    foreach (keys %groups) {
        if (/_admin$/) {
            $_ =~ s/_admin$//;
            push(@tt, $_);
        }
    }
    foreach (sort keys %dbmpasswd) {
        my @membership;
        my $group;
        my %tempgroups;
        my $username = $_;
				my $realname = $dbmname{$username};

        @membership = split /,/, $dbmgroup{$_};
        @tempgroups{@membership} = ();

		foreach $tt (@tt) {
			if (exists $tempgroups{$tt}) {
				print "<input type=\"radio\" name=\"username\" value=\"$username\"> $username , $realname is a member of $dbmgroup{$username} <br>";
				last;
			}
		}
    }

    print "<input type=\"hidden\" name=\"modmode\" value=\"showmod\"><br>";
    print "<input type=\"submit\" name=\"func\" value=\"Modify\">";
	print "<input type=\"submit\" name=\"func\" value=\"Showall\">";
}

if ($modmode eq "showmod") {
    $username = $query->param('username');
	print "things that you can modify for $username:<br>";

	print "<input type=\"hidden\" name=\"username\" value=\"$username\"><br>";
	print "1. change ";
	print submit( -NAME => "func", -VALUE => "Password"), "<br>";
	print "note, you can only change your own password <br>";
	print "2. change ";
	print submit( -NAME => "func", -VALUE => "Groups"), "<br>";
	print "3. change ";
	print submit( -NAME => "func", -VALUE => "Realname"), "<br>";
	print "4. delete ";
	print submit( -NAME => "func", -VALUE => "Delete"), "<br>";
}

}


# sub chpasswd
# Change password for $username
sub chpasswd {
    $username = $query->param('username');

if ($pwdmode eq "showform") {

    my $user_ok = 1;

	if ($username eq "ripe") {
		unless ($user eq "ripe") {
			$user_ok = 0;
			print "not allowed to change password for user \"$username\"<br>";
		}
	}

	if (($user ne "ripe") && ($username ne $user)) {
			$user_ok = 0;
			print "not allowed to change password for user \"$username\"<br>";
	}

	if ($user_ok == 1) {

        my %usergroups;
        $username = $query->param('username');
        print "Change password for <b>$username<\/b> . <br><br>";
		print "Enter new password for $username : <br><br>";
		print "password: NOTE: password should be more than 6 but no more than 8 chars long <br>";
		print "<input type=\"password\" name=\"password\"><br>"; 
		print "confirm password: <br>";
		print "<input type=\"password\" name=\"confirm\"><br>"; 
        print "<input type=\"hidden\" name=\"username\" value=\"$username\"><br>";
        print "<input type=\"hidden\" name=\"pwdmode\" value=\"chpwd\"><br>";
        print hidden( -NAME => "func", -VALUE => "Password");
        print "<input type=\"submit\"  value=\"Submit change\">";
	}
}

if ($pwdmode eq "chpwd") {

    $username = $query->param('username');
    $password = $query->param('password');
    $confirm = $query->param('confirm');
    my %admingroups;
    my %usergroups;
    my $user_ok = 1;
	my $count = 0;

	if ($password ne $confirm) {
		$user_ok = 0;
		print "passwords do not match<br>";
	} 

# only user "ripe" can chnage its password, nobody else
	if ($username eq "ripe") {
		unless ($user eq "ripe") {
			$user_ok = 0;
			print "you are not allowed to change password for user \"$username\"<br>";
		}
	}

    if (length $password < 6) {
        $user_ok = 0;
        print "ERROR: password should be more than 6 characters long<br>";
    }

    @admingroups{split (/,/, $dbmgroup{$user})} = ();
    @usergroups{split (/,/, $dbmgroup{$username})} = ();

# if $user is an admin of any ttxy boxes that a $username is a 
# member of, then $user can change password for $username
	foreach (keys %usergroups) {
		my $r = $_;
        $r =~ s/_admin$//;
		unless (exists $admingroups{$r."_admin"}) {
			print "you are not admin of $_ <br>";
		} else {
			$count = 1;
		} 
	}

    if (($user_ok == 1) && ($count == 1)) { 
		print "changing password for $username <br>";

		if ($password) {
			tie %dbmpasswd, 'DB_File', $dbmpassfile;
			$dbmpasswd{$username} = crypt($password,'0k');
			untie %dbmpasswd;
		}

    }
}


}


# sub chgroups
# Change groups for $username
sub chgroups {

if ($grpmode eq "showform") {

	my %usergroups;
	$username = $query->param('username');
	my $user_ok = 1;

    if ($username eq "ripe") {
        unless ($user eq "ripe") {
            $user_ok = 0;
            print "you are not allowed to change groups for user \"$username\"<br>";
        }
    }

	if ($user_ok == 1) {
	@usergroups{split (/,/, $dbmgroup{$username})} = ();
	print "Change groups for <b>$username<\/b> . <br><br>";
	print "If <b>$username</b> is in any of your groups, the checkbox will be selected below<br><br>";
	print "You ($user) are an admin of the groups below<br>";
	print "and so you have permission to add or remove <b>$username<\/b><br>";
	print "from any of them.<br>";
	print "<br>Select groups for user <b>$username<\/b>.<br>";
	print "NOTE: If you wish to remove user from a group, simply deselect it.<br><br>";

    @groups{split (/,/, $dbmgroup{$user})} = ();
    @showgroups = map { ($_, $_."_admin") } grep { s/_admin$// } sort keys %groups;
    @viewgroups = grep { s/_admin$// } sort keys %groups;
    @admingroups = map {$_."_admin"} @viewgroups;

    while (@viewgroups) {
        @tengroup_v = splice (@viewgroups, 0, 10);
        @tengroup_a = splice (@admingroups, 0, 10);

        print "<table border=\"0\">\n";
        print "<tr bgcolor=\"#0000ff\"><td><font color=\"#ffffff\">View only:</font></td><td><font color=\"#ffffff\">";
		foreach (@tengroup_v) {
			print "<input type=\"checkbox\" name=\"groups\" value=\"$_\"";
			print " checked " if (exists $usergroups{$_});
			print "> $_ ";
		}
        print "</font></td></tr>";
        print "<tr bgcolor=\"#ff0000\"><td><font color=\"#ffffff\">Admin rights:</td><td>";
        print "<font color=\"#ffffff\">";
		foreach (@tengroup_a) {
			my $i = $_;
			$i =~ s/_admin$//;
			print "<input type=\"checkbox\" name=\"groups\" value=\"$_\"";
			print " checked " if (exists $usergroups{$_});
			print "> $i ";
		}
        print "</font></td></tr></table>";
        print "<br>";
    }
	print "<input type=\"hidden\" name=\"username\" value=\"$username\"><br>";
	print "<input type=\"hidden\" name=\"grpmode\" value=\"chgroups\"><br>";
	print hidden( -NAME => "func", -VALUE => "Groups");
	print "<input type=\"submit\"  value=\"Submit change\">";
	}
}

if ($grpmode eq "chgroups") {

	$username = $query->param('username');
	my @reqgroups = $query->param('groups');
	my %admingroups;
	my @immusergroups;
	my $user_ok = 1;

    if ($username eq "ripe") {
        unless ($user eq "ripe") {
            $user_ok = 0;
            print "you are not allowed to change groups for user \"$username\"<br>";
        }
    }

    @admingroups{map { ($_, $_."_admin") } grep { s/_admin$// } split ( /,/, $dbmgroup{$user}) } = ();

    foreach $r (split (/,/, $dbmgroup{$username})) {
		unless (exists $admingroups{$r}) {
			push (@immusergroups, $r);	
		}
    }

    foreach $r (@reqgroups) {
        if (exists $admingroups{$r}) {
			push (@req, $r);
        } else {
			$user_ok = 0;
			print "you are not an admin of $r";
		}
    }

	@newgroups = (@immusergroups, @req);
    if ($user_ok == 1) { 
		$dbmgroup{$username} = join (",", @newgroups);
		@groupsnow{split (/,/, $dbmgroup{$username})} = (); 
		if (%groupsnow) {
        	print "$username is now in $dbmgroup{$username}";
		} else {
			print "$username not in any group. Would you like to delete it?<br>";
			print hidden( -NAME => "username", -VALUE => "$username");
			print "<input type=\"hidden\" name=\"func\" value=\"Delete\">";
    		print "<input type=\"submit\" value=\"YES\">";
			print "<a href=\"admin.cgi\">or go back</a>";
		}
    }
}

}

# sub chrealname
# Change groups for $username
sub chrealname {

if ($rnmode eq "showform") {

  my $username = $query->param('username');
  my $realname = $dbmname{$username};
  my $user_ok = 1;

    if ($username eq "ripe") {
        unless ($user eq "ripe") {
            $user_ok = 0;
            print "you are not allowed to change real name for user \"$username\"<br>";
        }
    }
		print "change real name for <b>$username</b>:<br>";
		print "current real name is $realname<br><br>";
		print "<input type=\"text\" name=\"rn\">";
		print "<input type=\"hidden\" name=\"username\" value=\"$username\">";
		print "<input type=\"hidden\" name=\"func\" value=\"Realname\">";
		print "<input type=\"hidden\" name=\"rnmode\" value=\"chrn\">";
		print "<input type=\"submit\" value=\"Submit\">";
}

if ($rnmode eq "chrn"){
	my $username = $query->param('username');
	my $realname = $dbmname{$username};
	my $newrn = $query->param('rn');
	my $user_ok = 1;

	print "username: $username";

	if (length $newrn < 1) {
		print "new real name should be more than 1 character long";
		$user_ok = 0;
	}

	if ($user_ok == 1) {
		$dbmname{$username} = $newrn;
	}

}

}


# sub delete
# Delete username from group. Needed: $username, $groups
# Check: - that the $user belongs to ttxy_admin group for all groups
# If yes, delete $usernames from all $groups.
# If no, exit, need more permissions.
sub delete {

if ($delmode eq "showform") {

	$username = $query->param('username');
    my $user_ok = 1;

    if ($username eq "ripe") {
        unless ($user eq "ripe") {
            $user_ok = 0;
            print "not allowed to delete user \"$username\"<br>";
        }
    }

    if ($user_ok == 1) {
		delete $dbmpasswd{$username};
		delete $dbmgroup{$username};
		print "$username deleted";
	}
}
} 

# sub showall
sub showall {

	my @tt;
    print "tick a box next to a username that you wish to modify:<br><br>";

    @groups{split (/,/, $dbmgroup{$user})} = ();
    foreach (keys %groups) {
		push(@tt, $_);
    }

    foreach (sort keys %dbmpasswd) {
        my @membership;
        my $group;
        my %tempgroups;
        my $username = $_;
        my $realname = $dbmname{$username};

        @membership = split /,/, $dbmgroup{$_};
        @tempgroups{@membership} = ();

        print "<input type=\"radio\" name=\"username\" value=\"$username\"> $username, $realname is a member of $dbmgroup{$username} <br>";
        foreach $group (@membership) {
            push @{$groups{$group}}, $_;
        }
    }

    print "<input type=\"hidden\" name=\"modmode\" value=\"showmod\"><br>";
    print "<input type=\"submit\" name=\"func\" value=\"Modify\">";
}


print "</form>";
print "</body></html>";

untie %dbmgroup;
untie %dbmpasswd;
untie %dbmname;
