#!/usr/local/bin/perl
#
# $Id: index.cgi,v 1.3 2001/04/19 11:19:29 ana Exp $
#
# Copyright (c) 2001  RIPE NCC
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; 
# IN NO EVENT SHALL AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS 
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE 
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE 
# USE OR PERFORMANCE OF THIS SOFTWARE.
#
#-----------------------------------------------------------------------
# Module Header
# Filename          :   index.cgi
# Purpose           :   Front page for the admin system, decides what
#                       level of access user has and displays relevant
#                       data
# Authors           :   Ana Susanj <ana@ripe.net>, RIPE NCC
# Date              :   17-APR-2001
# Description       :   Component of TTwwwpages for Test Traffic project
# Input             :   through the web interface
# Output            :   dbm files in /var/www/conf/tt and web
# Language Version  :   perl v5.6.0
#-----------------------------------------------------------------------

use CGI;
use DB_File;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);

use strict;

my $passwdfile = "/var/www/conf/tt/dbmpass";
my $groupfile  = "/var/www/conf/tt/dbmgroup";
my $namefile  = "/var/www/conf/tt/dbmname";
my $cgi = new CGI;
my $user = $ENV{REMOTE_USER};
my $admin = $ENV{QUERY_STRING};
my %groups;

my (%dbmpasswd, %dbmgroup, %dbmname);
tie (%dbmpasswd, 'DB_File', $passwdfile) or die "couldn't tie: $!";
tie (%dbmgroup, 'DB_File', $groupfile) or die "couldn't tie: $!";
tie (%dbmname, 'DB_File', $namefile) or die "couldn't tie: $!";

print "Content-Type: text/html\n\n";
print "<HTML><BODY bgcolor=\"#ffffff\" text=\"#000000\">\n";

if ($user) {

	my $realname;
	my (@showgroups, @viewgroups, @admingroups, @tengroup_v);
	my $is_admin = 0;
	$realname = $dbmname{$user};
	@groups{split (/,/, $dbmgroup{$user})} = ();
	@showgroups = map { ($_, $_."_admin") } grep { s/_admin$// } sort keys %groups;
	@viewgroups = grep { !/_admin$/ } sort keys %groups;

	foreach (keys %groups) {
		if (/_admin$/) {
			$is_admin = 1;
		}
	}

	print " user $user ($realname) logged in<br><br>";
	print "<a href=\"admin.cgi\">admin section</a><br>" if $is_admin eq 1;
	print "<br>view data for following TT hosts:<br>";
	print "<a href=\"showloc.cgi\">TT host locations</a>";
	print " - tells you where in the world these TT boxes are<br><br>";

	while (@viewgroups) {
		@tengroup_v = splice (@viewgroups, 0, 10);
		
		print "<table border=\"0\" cellpadding=\"5\" cellspacing=\"1\">\n";
		print "<tr>";

		foreach (@tengroup_v) {
			print "<td bgcolor=\"#dddddd\">";
			print "<a href=\"$_/\">$_</a>";
			print "</td>";
		}
		print "</tr></table>";
		print "<br>";

	}
}

print "</BODY>\n";
print "</HTML>\n";

untie %dbmpasswd;
untie %dbmgroup;
untie %dbmname;
