#!/usr/local/bin/perl
#
# $Id: showloc.cgi,v 1.3 2001/04/19 11:19:29 ana Exp $
#
# Copyright (c) 2001  RIPE NCC
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; 
# IN NO EVENT SHALL AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS 
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE 
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE 
# USE OR PERFORMANCE OF THIS SOFTWARE.
#
#-----------------------------------------------------------------------
# Module Header
# Filename          :   showloc.cgi
# Purpose           :   Displays locations of all test boxes
# Authors           :   Ana Susanj <ana@ripe.net>, RIPE NCC
# Date              :   17-APR-2001
# Description       :   Component of TTwwwpages for Test Traffic project
# Input             :   through the web interface
# Output            :   dbm files in /var/www/conf/tt and web
# Language Version  :   perl v5.6.0
#-----------------------------------------------------------------------

use CGI;
use DB_File;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);

use strict;

my $groupfile  = "/var/www/conf/tt/dbmgroup";
my $locfile  = "/var/www/conf/tt/dbmloc";
my $cgi = new CGI;
my $user = $ENV{REMOTE_USER};
my $admin = $ENV{QUERY_STRING};
my %groups;

my (%dbmgroup, %dbmloc);
tie (%dbmgroup, 'DB_File', $groupfile) or die "couldn't tie: $!";
tie (%dbmloc, 'DB_File', $locfile) or die "couldn't tie: $!";

print "Content-Type: text/html\n\n";
print "<HTML><BODY bgcolor=\"#ffffff\" text=\"#000000\">\n";

if ($user) {
	my (%groups, @tt, @threegroup);
	@groups{split (/,/, $dbmgroup{ripe})} = ();
	foreach (sort keys %groups) {
		unless ($_ =~ /_admin$/) {
			push(@tt, $_);
		}
	}
	print "<table border=\"0\">\n";
	while (@tt) {
		@threegroup = splice (@tt, 0, 3);
		print "<tr>";
		foreach (@threegroup) {
			print "<td>";
			print "<font color=\"#ff0000\">$_</font> - $dbmloc{$_} ";
			print "</font></td>";
		}
		print "</tr>";
	}
	print "</table>";
}

print "</BODY>\n";
print "</HTML>\n";

untie %dbmgroup;
untie %dbmloc;
