#!/usr/local/bin/perl5
#
# $Id: index.pl,v 1.5 2001/05/29 14:30:09 ttraffic Exp $
#
# Copyright (c) 2000  RIPE NCC
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
# AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
# DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
#------------------------------------------------------------------------------
# Module Header
# Filename          :   index.pl
# Purpose           :   Automated generation of TTM webpages in html
# Authors           :   Fotis Georgatos <fotis@ripe.net>, RIPE NCC
# Date              :   18-AUG-2000
# Description       :   Component of TTwwwpages for Test Traffic project
# Input             :   derived from "ttconfig" script  
# Output            :   html code in stdout
# Language Version  :   perl
#------------------------------------------------------------------------------

$TTROOT="/ncc/ttpro";
$OUTPUTDIR="$TTROOT/data/plots";

open( INFO, "$TTROOT/bin/ttconfig -v TTLIST |") || die "Cannot get list of testboxes\n";
@TTLIST = <INFO>;
close(INFO); 

open( INFO, "$TTROOT/bin/ttconfig -v TTWATCH |") || die "Cannot get list of testboxes\n";
$TTWATCH = <INFO>;
close(INFO); 

my($GPSINFO) = "$TTROOT/bin/ttconfig -v GPSINFO |";
my(%ttInfo)  =  &readGPSINFOLines(); # build hash structure

foreach $ff (@TTLIST)
  {
  $f=$ff;
  chop $f;
  print "<TR> <TD align=center><h2><A HREF=\"$f/satellites.$f.html\">$f</TD>\n";
  # Host information (GPS)
  print "<TD>$ttInfo{$f}{'place'}</TD>\n";
  # Overview
  print "<TD><A href=\"$f/index.html\">Overview</TD>\n";

  foreach $gg (@TTLIST)
    {
    $g=$gg;
    chop $g;
    $OUTPUT=" <TD><A HREF=\"$f/$f.$g.html\">$g</A></TD>\n";
    $OUTPUTWATCH=" <TD BGCOLOR=\"c0c0c0\">$g</TD>\n";
    if ( $TTWATCH =~ /$g/ ) { $OUTPUT=$OUTPUTWATCH; }
    if ( $TTWATCH =~ /$f/ ) { $OUTPUT=$OUTPUTWATCH; }
    if ( $g eq $f ) { $OUTPUT="<TD>&nbsp;</TD>"; }
    print $OUTPUT;
    }
  print "</TR>\n\n";
  }

sub readGPSINFOLines { 
        my(%ttInfo) = @_; 
        open( GPS, $GPSINFO)  or die "can't get GPSINFO";

        while (<GPS>) {
                chomp;
                my(@list) = split ('\t', $_);
                $ttInfo{$list[0]}{'name'} = $list[0]; 
                $ttInfo{$list[0]}{'lat'} = $list[1]; 
                $ttInfo{$list[0]}{'long'} = $list[2]; 
                $ttInfo{$list[0]}{'place'} = $list[3]; 
        }
        return (%ttInfo);
}

