#!/usr/local/bin/perl5
#
#      * * *  N O T E   N O T E   N O T E  * * *
#
#  Tasks of this script are now integrated in the main
#  satellite conditions reporting job 'clock_hist.pl'
#  [RW,  20020219]  
#  
#  ----------------------------------------------------
#
# $Id: satellites.ttxx.pl,v 1.4 2002/02/21 18:24:32 ttraffic Exp $
#
# Copyright (c) 2000  RIPE NCC
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the author not be
# used in advertising or publicity pertaining to distribution of the
# software without specific, written prior permission.
#
# THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
# ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
# AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
# DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
# AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
#------------------------------------------------------------------------------
# Module Header
# Filename          :   satellites.ttxx.pl
# Purpose           :   Automated generation of TTM webpages in html
# Author            :   Fotis Georgatos <fotis@ripe.net>, RIPE NCC
# Date              :   18-AUG-2000
# Revision Author   :   Andrew Marcus <andrew@ripe.net>, RIPE NCC intern
# Revision Date     :   24-JAN-2002
# Description       :   Component of TTwwwpages for Test Traffic project
# Input             :   derived from "ttconfig" script
# Output            :   $OUTPUTDIR/*/satellites.*.html
# Language Version  :   perl
#------------------------------------------------------------------------------

$TTROOT="/ncc/ttpro";
$OUTPUTDIR="$TTROOT/data/plots/sats";

open( INFO, "$TTROOT/bin/ttconfig -v TTLIST |") || die "Cannot get list of testboxes\n";
@TTLIST = <INFO>;
close(INFO); 

foreach $ff (@TTLIST)
{
  $f=$ff;
  chop $f;

  open( OUT, ">$OUTPUTDIR/$f/satellites.$f.html" ) || die "Cannot open file for write\n";

  print OUT '<!--#set var="title" value="RIPE NCC: Test Traffic Results"-->
             <!--#include virtual="/ssi/ttmhead1.html"-->
             <CENTER>
               <P>
                 <H1>Satellite conditions for ' . $f . '</H1>
                 <IMG SRC="satellites.' . $f . '.gif">
               </P>
               <P>
                 <H1>Long-term averages for '   . $f . '</H1>
                 <IMG SRC="satellites.' . $f . '.month.gif"><BR>
                 <IMG SRC="satellites.' . $f . '.year.gif"><BR>
               </P>
             </CENTER>
             <!--#include virtual="/ssi/ttmfoot1.html"-->
            ';

  close (OUT);
}
