;
; General ARM Definitions.
; For more information see ARM Architecture Reference Manual,
; Advanced RISC Machines, Ltd., DDI 0100B, Prentice Hall, 1996.
; ISBN 0-13-736299-4
;
; 2.4 Program Status Registers
;
ARM_PSR_N	= (1<<31)
ARM_PSR_Z	= (1<<30)
ARM_PSR_C	= (1<<29)
ARM_PSR_V	= (1<<28)
ARM_PSR_I	= (1<<7)
ARM_PSR_F	= (1<<6)
ARM_PSR_T	= (1<<5)
ARM_PSR_M4	= (1<<4)
ARM_PSR_M3	= (1<<3)
ARM_PSR_M2	= (1<<2)
ARM_PSR_M1	= (1<<1)
ARM_PSR_M0	= (1<<0)
ARM_MODE_USER	= (ARM_PSR_M4)
ARM_MODE_FIQ	= (ARM_PSR_M4|ARM_PSR_M0)
ARM_MODE_IRQ	= (ARM_PSR_M4|ARM_PSR_M1)
ARM_MODE_SVC	= (ARM_PSR_M4|ARM_PSR_M1|ARM_PSR_M0)
ARM_MODE_ABORT	= (ARM_PSR_M4|ARM_PSR_M2|ARM_PSR_M1|ARM_PSR_M0)
ARM_MODE_UNDEF	= (ARM_PSR_M4|ARM_PSR_M3|ARM_PSR_M1|ARM_PSR_M0)
ARM_MODE_MASK	= 0x1F
;
; 2.5 Exceptions, p 2-6
;
ARM_EXCEPT_RESET	= 0x00
ARM_EXCEPT_UNDEF	= 0x04
ARM_EXCEPT_SWI		= 0x08
ARM_EXCEPT_PREFETCH	= 0x0C
ARM_EXCEPT_DATA		= 0x10
ARM_EXCEPT_0X14		= 0x14
ARM_EXCEPT_IRQ		= 0x18
ARM_EXCEPT_FIQ		= 0x1C
;
; ARM710a Internal Coprocessor definitions 
; For more information seee ARM DDI 0022D, ARM710a Data Sheet, p. 5-1 ff.
;
; All are set-enabled (0 - disabled, 1 - enabled)
;
ARM_CP15_CTRL_MMU	= 0x001
ARM_CP15_CTRL_AFAULT	= 0x002
ARM_CP15_CTRL_CACHE	= 0x004
ARM_CP15_CTRL_WBUF	= 0x008
ARM_CP15_CTRL_ARM32P	= 0x010
ARM_CP15_CTRL_ARM32D	= 0x020
ARM_CP15_CTRL_ALWONE	= 0x040
ARM_CP15_CTRL_BIGEND	= 0x080
ARM_CP15_CTRL_SYSTEM	= 0x100
ARM_CP15_CTRL_ROM	= 0x200
