	.include "arm.h"

	.ifdef DAG5
PBR	= 0x42000000	; real
XRR	= 0xC8000000	; CPP Xilinx 1 Runtime Register Base fake
XPS	= 0xC8000000	; CPP Xilinx 1 Program Space fake
XRS	= 0xC8000000	; CPP Xilinx 1 Reset Space fake
PROM	= 0xC0000000	; fake
XLXIMG	= 0x08000000	; fake
XLXMAX	= 1		; true for real DAG5 XXX
	.endif

	.ifdef DAG4
;
; DAG4 address space layout as seen by the StrongARM
;
CRR	= 0x40000000	; CPP Xilinx 3 Runtime Register Base
CPS	= 0x50000000	; CPP Xilinx 3 Program Space
CRS	= 0x60000000	; CPP Xilinx 3 Reset Space
	.ifdef DAG41
DRR	= 0x70000000	; DSP Xilinx 2 Runtime Register Base
DPS	= 0x80000000	; DSP Xilinx 2 Program Space
DRS	= 0x90000000	; DSP Xilinx 2 Reset Space
	.endif ; DAG41
PBR	= 0xA0000000	; PCI Base DAG4.x
XRR	= 0xA0000000	; PCI Xilinx 1 Runtime Register Base
XPS	= 0xB0000000	; PCI Xilinx 1 Program Space
XRS	= 0xC0000000	; PCI Xilinx 1 Reset Space
	.ifdef DAG41
CPLD	= 0xE0000000	; CPLD address space
	.endif
PROM	= 0xF0000000	; EEPROM address space
XLXIMG	= 0x0000B000	; Start of Xilinx image in EEPROM
XLXMAX	= 3		; has 3 Xilinx chips
			; on 4.0 second Xilinx does not exist
	.endif ; DAG4

	.ifdef DAG3
;
; DAG3 address space layout as seen by the StrongARM
;
PMC	= 0x20000000	; PMC 5355 phy chip base
PBR	= 0x40000000	; PCI Base DAG3.x
XRR	= 0x40000000	; Xilinx Runtime Register Base
	.ifdef DAG35
DPS	= 0x80000000	; CPP Xilinx 2 Program Space
DRS	= 0x90000000	; CPP Xilinx 2 Reset Space
XPS	= 0xB0000000	; PCI Xilinx 1 Program Space
CPLD	= 0xE0000000	; CPLD address space
PROM	= 0xF0000000	; EEPROM address space
XLXMAX	= 2		; has 2 Xilinx chips
	.else ; DAG35
XPS	= 0xA0000000	; PCI Xilinx 1 Program Space
PROM	= 0xE0000000	; EEPROM address space
XLXMAX	= 1		; has 1 Xilinx chip
	.endif ; DAG35
XRS	= 0xC0000000	; PCI Xilinx 1 Reset Space
XLXIMG	= 0x0000B000	; Start of Xilinx image in EEPROM
XLX2IMG	= 0x00034000	; Start of second Xilinx image in EEPROM

;
; Registers in the PHY address space
;
PMC_Config	= 0x04
PMC_Config_OC3	= 0x15
PMC_Config_OC12	= 0x1f
PMC_Phy		= 0x18
PMC_Phy_OC12	= 0x1
	.endif ; DAG3

	.ifdef DAG2
;
; DAG2 address space layout as seen by the ARM710
;
DMA	= 0x80000000	; ARM DMA space
XDMA	= 0x90000000	; Xilinx DMA space
XRR	= 0xA0000000	; Xilinx Runtime Register Base
XPS	= 0xB0000000	; Xilinx Program Space
XRS	= 0xC0000000	; Xilinx Reset Space
PBR	= 0xD0000000	; PLX Base DAG2.0
PROM	= 0xF0000000	; EEPROM address space
XLXIMG	= 0x00014000	; Start of Xilinx image in EEPROM
XLXMAX	= 1		; has 1 Xilinx chip
	.endif ; DAG2

	.ifdef IXP
ToAM0	= 0x50
ToAM1	= 0x54
ToAM2	= 0x58
ToAM3	= 0x5c
ToHM0	= 0x50
ToHM1	= 0x54
ToHM2	= 0x58
ToHM3	= 0x5c

	.endif

	.ifdef StrongARM
;
; Mailboxes as seen by the StrongARM
;
ToAM0	= 0x0
ToAM1	= 0x4
ToAM2	= 0x8
ToAM3	= 0xc
ToAM4	= 0x10
ToAM5	= 0x14
ToAM6	= 0x18
ToAM7	= 0x1c
ToAM8	= 0x20
ToAM9	= 0x24
ToAM10	= 0x28
ToAM11	= 0x2c
ToAM12	= 0x30
ToAM13	= 0x34
ToAM14	= 0x38
ToAM15	= 0x3c

ToHM0	= 0x40
ToHM1	= 0x44
ToHM2	= 0x48
ToHM3	= 0x4c
ToHM4	= 0x50
ToHM5	= 0x54
ToHM6	= 0x58
ToHM7	= 0x5c
ToHM8	= 0x60
ToHM9	= 0x64
ToHM10	= 0x68
ToHM11	= 0x6c
ToHM12	= 0x70
ToHM13	= 0x74
ToHM14	= 0x78
ToHM15	= 0x7c

;
; Xilinx register offsets
;
X_Cell		= 0x00
X_Payload	= 0x10
X_Status	= 0xc8
	.ifdef ERF
X_Header	= 0x90
        .else
X_Header        = 0x8c
	.endif
X_CRC		= 0x84
X_Discard_Cell	= 0xd0	
X_Copy_Cell	= 0xd4	
X_Reset		= 0xd8
X_LED1		= 0xf0
X_LED2		= 0xf4

	.endif ; StrongARM

	.ifdef DAG2

ToAM0	= 0xc0
ToAM1	= 0xc4
ToAM2	= 0xc8
ToAM3	= 0xcc

ToHM0	= 0xd0
ToHM1	= 0xd4
ToHM2	= 0xd8
ToHM3	= 0xdc

X_Cell		= 0x00
X_Payload	= 0x10
X_Status	= 0x40
X_GPS		= 0x44
X_Reset		= 0x48
X_Discard_Cell	= 0x4c	
	
PICS    = 0xE8        ; PLX Interrupt Control/Status

	.endif ; DAG2

;
; Common DAG definitions
;
ToHDB	= 0xE4			; ARM -> Host doorbell register
ToADB	= 0xE8			; Host -> ARM doorbell register

REGSAVE		= 0x3000	; register save location
Data_Block	= 0x3100	; params from PC.
Data_Hole_Base	= 0x0		; pci hole base
Data_Hole_Top	= 0x04		; pci hole top
Data_Device_Code= 0x08      	; device code (16bits)
Xilinx_1_Block	= 0x3800	; location of first xilinx header
Xilinx_2_Block	= 0x3880	; location of second xilinx header
Xilinx_3_Block	= 0x3900	; location of third xilinx header
Xilinx_4_Block	= 0x3980	; location of fourth xilinx header
