/*
 * sender.c
 *
 * Author: Thomas Wana <tom@ripe.net>
 *
 * $Id: sender.c,v 1.1.1.1 2005/04/05 12:11:52 tom Exp $
 * 
 */

#include <sys/time.h>
#include <sys/timex.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

int main(int argc, char **argv)
{
	struct sockaddr_in sin;
	int sock;
	struct hostent *he;
	struct ntptimeval pkt;

	if(argc!=3)
	{
		fprintf(stderr, "Usage: %s host port\n\n", argv[0]);
		return -1;
	}

	/*
	 * Create and setup the socket
	 */
	if((sock=socket(AF_INET, SOCK_DGRAM, 0))<0)
	{
		perror("socket");
		return -2;
	}
	sin.sin_family=PF_INET;
	sin.sin_port=ntohs(strtol(argv[2], NULL, 10));
	if((he=gethostbyname(argv[1]))==NULL)
	{
		herror("gethostbyname");
		return -3;
	}
	sin.sin_addr.s_addr=*(in_addr_t *)he->h_addr_list[0];

	/*
	 * Main loop
	 */
	memset(&pkt, 0, sizeof(pkt));
	while(1)
	{
		if(ntp_gettime(&pkt)<0)
		{
			perror("ntp_gettime");
			return -2;
		}
		if(sendto(sock, (const void *)&pkt, sizeof(pkt), 0, (const struct sockaddr *)&sin, sizeof(sin))<0)
		{
			perror("sendto");
			return -1;
		}
		printf("packet sent\n");
		memset(&pkt, 0, sizeof(pkt));
		sleep(1);
	}

	return 0;
}
