#!/usr/local/bin/tclsh8.4


proc doit {p0 f0 d0} {
	puts "PHASE $p0 FREQUENCY $f0"

	# Initial phase offset
	#set p0 -0e-3

	# Initial frequency offset
	#set f0 -1e-6

	# Frequency drift
	#set d0 -1.5e-14

	# Phase Noise
	set pn [expr 2.0 / 8333333.0]

	# Set Frequency Noise
	set fn 1e-15

	set a01 .5
	set a00 .0001
	set st -1
	set e 86400

	set p $p0
	set f $f0
	set t 0
	set x 0


	set b 0

	for {set i 0} {$i < $e} {incr i} {
		if {$st == -1} {
			set mj 8
			set j 0
			set dl 10
			set st 0
			set a0 $a01
			set b0 [expr pow($a0,2)]
			set c0 [expr pow($b0,2)]
			set a 0
			set c 0
			set my 0
			set ly 0
			set lmy 0
			set dy 0
			set say 0
			set sdy 0
			set zc 0
			set z 0
			puts stderr "= i $i st $st a0 $a0 a00 $a00 mj $mj dl $dl"
		}

		if {$j < $mj} {incr j}
		incr dl -1

		incr t
		set p [expr {$p + $f}]
		set f [expr {$f + $d0 + (rand() - .5) * $fn}]

		set z [expr $a + $b]
		if {$z > 500e-6} {
			set z 500e-6
		} elseif {$z < -500e-6} {
			set z -500e-6
		}
		set x [expr $x + $z]
		set y [expr $p - $x]
		set y [expr {$y + (rand() - .5) * $pn}]

		set my [expr {$my + ($y - $my) / $j}]

		if {$lmy * $my < 0} {
			set zc 0
		} else {
			incr zc
		}
		set lmy $my

		set ddy $dy
		set dy [expr $y - $ly]
		set ly $y

		set ay [expr {$dy - $ddy}]
		set ay [expr {abs($ay)}]
		set say [expr {$say + ($ay - $say) / $j}]
		set by [expr {abs($dy)}]
		set sdy [expr {$sdy + ($by - $sdy) / $j}]

		set a [expr $y * $a0]

		if {$st >= 2} {
			set b [expr {$b + $a * $b0 + $c}]
		}

		if {$st >= 4} {
			set c [expr {$c + $a * $b0 * $c0}]
		}

		if {($i % 10) == 0} {
			puts $fo "$t $p $x $y $say $sdy $my $a $b $c [expr $b - $f0] $a0"
		}

		if {$st >= 3 && $zc > 10 / $a0} {
			set a00 [expr $a0 / .8]
			if {$a00 > .5} {
				set $a00 .5
				puts "ARGH!!!"
			}
			set st -1
			puts stderr "< i $i st $st a0 $a0 $b0 $c0 a00 $a00 mj $mj dl $dl $a0 t = [expr 10/$a0]"
		}
		if {$st >= 3 && abs($my) > $sdy} {
			set a00 [expr $a0 / .75]
			if {$a00 > .5} {
				set $a00 .5
				error "ARGH!!!"
			}
			set st -1
			puts stderr "< i $i st $st a0 $a0 $b0 $c0 a00 $a00 mj $mj dl $dl $a0 $my > $sdy"
		}

		if {$dl >= 0} {
			continue;
		} elseif {$st == 0  && abs($y) < ($sdy + 128e-6 / $a0)} {
			set st 1
			set dl [expr int($mj)]
			puts stderr "= i $i st $st a0 $a0 b0 $b0 c0 $c0 a00 $a00 mj $mj dl $dl"
		} elseif {$st == 1} {
			set st 2
			set dl [expr int($mj)]
			puts stderr "= i $i st $st a0 $a0 b0 $b0 c0 $c0 a00 $a00 mj $mj dl $dl"
		} elseif {$st == 2 && abs($my) < $say * .5} {
			set st 3
			set dl [expr int($mj)]
			puts stderr "= i $i st $st a0 $a0 b0 $b0 c0 $c0 a00 $a00 mj $mj dl $dl"
		} elseif {$st >= 3 && abs($my) < $say * .1 && $zc < 10} {
			if {$a0 > $a00} {
				set r .9
				set a0 [expr $a0 * $r]
				set b0 [expr pow($a0,2)]
				set c0 [expr pow($b0,2)]
				set mj [expr $mj / $r]
				# puts stderr "> i $i st $st a0 $a0 b0 $b0 c0 $c0 a00 $a00 mj $mj dl $dl $a0"
			} elseif {$st == 3} {
				set st 4
				puts stderr "= i $i st $st a0 $a0 b0 $b0 c0 $c0 a00 $a00 mj $mj dl $dl"
			}
			set dl [expr int($mj)]
		} 
				
	}
	puts "A0 $a0"
}

set fo [open _ w]
doit 0 0 $fo

exit 0

foreach p0 {-128e-3 -1e-3 -1e-6 0 1e-6 1e-3 128e-3} {
	foreach f0 {-128e-6 -1e-6 -1e-9 0 1e-9 1e-6 128e-6} {
		doit $p0 $f0 1.5e-14
	}
}
