#!/usr/bin/perl

#
# This script removes duplicate paths from a graph in the dot language, the IDs have to be quoted.
#

open (FH,$ARGV[0]) or die ("No input file\n");

while( <FH> ) {
   push @lines, $_;
}
close FH;
$pos = 0;
foreach $line (@lines) {

   if( $line =~ /^.*(\"\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\".*\"\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\").*$/ ) {
      $extracted = $1;
      for( $count = $pos+1; $count < scalar(@lines); $count++ ) {
         if($lines[$count] =~ /^.*(\"\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\".*\"\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\").*$/) {
            if( $1 eq $extracted ) {
               delete $lines[$count];
            }
         }
      }
   }
   if( $line =~ /^.*\"(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\".*\"(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\".*$/ ) {
      if( $1 eq $2 ) {
         delete $lines[$pos];
      }
   }
   $pos++;

}

foreach $line (@lines) {
   print $line;
}
