#!/usr/bin/perl

use POSIX;
use IO::Socket;
use CGI qw(:standard);

# Our CGI query object
$query = new CGI;

if( defined( $query->param('dest') ) && defined($query->param('group')) && defined($query->param('type')) ) {
   $dest = $query->param('dest');
   $group = $query->param('group');
   $type = $query->param('type');
} else {
   # Group and Type are mandatory.
   exit;
}
if( defined($query->param('source')) ) {
   $source = $query->param('source');
}

my $socket = new IO::Socket::INET(
   Proto  => 'tcp',
   PeerAddr  => 'rimu.ripe.net',
   PeerPort  => '4261'
);
die "can't setup socket: $!" unless $socket;
$socket->autoflush(1);

# Request the image that
if( defined($source) ) {
   $command = "getImage $group $source $type";
} else {
   $command = "getImage $group $type";
}
if( defined($query->param('start')) && $query->param('start') =~ /\d{8} \d{2}:\d{2}/ ) {
   $command .= " ".$query->param('start');
}
if( defined($query->param('end')) && $query->param('end') =~ /\d{8} \d{2}:\d{2}/ ) {
   $command .= " ".$query->param('end');
}


print $socket "selDest $dest\n";
print $socket "$command\n";

# Print out the image that we recieve over the socket
print $query->header( -type       => "image/gif",
                      -attachment => "plot.gif" );

# Output the image we got over the socket
while (<$socket>) {
   print $_;
}
