#!/usr/bin/perl

use POSIX qw(strftime);
use CGI qw(:standard);

# Our CGI query object
$query = new CGI;

#
# Front end for showing and merging graph files.
#
print "Content-type: text/html\n\n";

if( defined($query->param('img')) ) {
   $img = $query->param('img');
} else {
   print "No Image to show...";
   exit;
}

print <<EOF;

<html>
<head>
   <title>Zoomer</title>
   <style type="text/css">
   <!--
   .moveable {
      position: absolute;
      cursor: move;
   }
-->
</style>
   <script type="text/javascript">
      //DRAG CODE
      var selObj = null;

      document.onmousedown=dragHandler;
      document.onmousemove=getMouseXY;

      function moveHandler(e){
         if (e == null) { e = window.event } 
         if (e.button<=1&&dragOK){
            newH = parseInt(document.getElementById("zoomer").height);
            newW = parseInt(document.getElementById("zoomer").width);
            newX = e.clientX-dragXoffset;
            newY = e.clientY-dragYoffset;
            // Some sanity checks
            if( newW < getWinX() ) {
              if( newX > 0 && newX + newW > getWinX() ) {
                  newX = getWinX() - newW;
               }
               if( newX < 0 && newX + newW < getWinX() ) {
                  newX = 0;
               }
            } else {
               if( newX > 0 ) {
                  newX = 0;
               }
               if( newX + newW < getWinX () ) {
                  newX = getWinX() - newW;
               }
            }
            if( newH < getWinY() ) {
               if( newY > 0 && newY + newH > getWinY() ) {
                  newY = getWinY() - newH;
               }
               if( newY < 0 && newY + newH < getWinY() ) {
                  newY = 0;
               }
            } else {
               if( newY > 0 ) {
                  newY = 0;
               }
               if( newY + newH < getWinY () ) {
                  newY = getWinY() - newH;
               }
            }
            selObj.style.left=newX+'px';
            selObj.style.top=newY+'px';
            return false;
         }
      }

      function cleanup(e) {
         document.onmousemove=getMouseXY;
         document.onmouseup=null;
         selObj.style.cursor=orgCursor;
         dragOK=false;
      }

      function dragHandler(e){
         var htype='-moz-grabbing';
         if (e == null) { e = window.event; htype='move';} 
         var target = e.target != null ? e.target : e.srcElement;
         selObj=target;
         orgCursor=target.style.cursor;
         if (target.className=="moveable") {
            target.style.cursor=htype;
            dragOK=true;
            dragXoffset=e.clientX-parseInt(selObj.style.left);
            dragYoffset=e.clientY-parseInt(selObj.style.top);
            document.onmousemove=moveHandler;
            document.onmouseup=cleanup;
            document.onmouseout=cleanup;
            return false;
         }
      }


      // ZOOM CODE
      var mouseX;
      var mouseY;
      var zoomSumY = 500; // How much the y coordinate should be in/decreased on each zoom step
      var realImgW; // Set by startup funtionc
      var realImgH;

      // Detect if the browser is IE or not.
      // If it is not IE, we assume that the browser is NS.
      var IE = document.all?true:false

      function getMouseXY (e) {
         if (IE) { // grab the x-y pos.s if browser is IE
            mouseX = event.clientX + document.body.scrollLeft;
            mouseY = event.clientY + document.body.scrollTop;
         } else {  // grab the x-y pos.s if browser is NS
            mouseX = e.pageX;
            mouseY = e.pageY;
         }
      }

      function startup() {
         realImgH = parseInt(document.getElementById("zoomer").height);
         realImgW = parseInt(document.getElementById("zoomer").width);
         zoomFit();
      }

      function zoomOrg() {
         document.getElementById("zoomer").style.width = realImgW.toString()+"px";
         document.getElementById("zoomer").style.height = realImgH.toString()+"px";
         //document.getElementById("zoomer").style.left = "0px";
         //document.getElementById("zoomer").style.top = "0px";
      }

      function zoomFit() {
         imgOrgH = parseInt(document.getElementById("zoomer").height);
         imgOrgW = parseInt(document.getElementById("zoomer").width);
         winH = parseInt(window.innerHeight);
         winW = parseInt(window.innerWidth);
         // First try to adjust the width
         diffW = imgOrgW - winW;
         diffH = Math.floor((imgOrgH / imgOrgW) * diffW);
         if( winH > imgOrgW - diffH ) {
            // That is the way to go, do it.
            newH = imgOrgH - diffH;
            newW = imgOrgW - diffW;
         } else {
            // Nope, other way
            diffH = imgOrgH - winH;
            diffW = Math.floor((imgOrgW / imgOrgH) * diffH);
            // And now the actual zooming.
            newH = imgOrgH - diffH;
            newW = imgOrgW - diffW;
         }
         document.getElementById("zoomer").style.width = newW.toString()+"px";
         document.getElementById("zoomer").style.height = newH.toString()+"px";
         document.getElementById("zoomer").style.left = "0px";
         document.getElementById("zoomer").style.top = "0px"
      }


      function zoomIn () {
         // Zooming
         imgOrgH = parseInt(document.getElementById("zoomer").height);
         imgOrgW = parseInt(document.getElementById("zoomer").width);
         imgOrgY = parseInt(document.getElementById("zoomer").style.top);
         imgOrgX = parseInt(document.getElementById("zoomer").style.left);
         // Do the zooming
         zoomSumX = Math.floor((imgOrgW / imgOrgH) * zoomSumY);
         newH = imgOrgH + zoomSumY;
         // Snap to the original image size if close enough
         if( Math.abs(newH-realImgH) < zoomSumY/2 ) {
            newH = realImgH;
            newW = realImgW;
         } else {
            newW = imgOrgW + zoomSumX;
         }
         // Moving
         newX = imgOrgX - zoomSumX/2;
         newY = imgOrgY - zoomSumY/2;
         // Some sanity checks
         if( newW < getWinX() ) {
           if( newX > 0 && newX + newW > getWinX() ) {
               newX = getWinX() - newW;
            }
            if( newX < 0 && newX + newW < getWinX() ) {
               newX = 0;
            }
         } else {
            if( newX > 0 ) {
               newX = 0;
            }
            if( newX + newW < getWinX () ) {
               newX = getWinX() - newW;
            }
         }
         if( newH < getWinY() ) {
            if( newY > 0 && newY + newH > getWinY() ) {
               newY = getWinY() - newH;
            }
            if( newY < 0 && newY + newH < getWinY() ) {
               newY = 0;
            }
         } else {
            if( newY > 0 ) {
               newY = 0;
            }
            if( newY + newH < getWinY () ) {
               newY = getWinY() - newH;
            }
         }
         document.getElementById("zoomer").style.left = Math.floor(newX).toString()+"px";
         document.getElementById("zoomer").style.top = Math.floor(newY).toString()+"px";
         document.getElementById("zoomer").style.width = newW.toString()+"px";
         document.getElementById("zoomer").style.height = newH.toString()+"px";
      }

      function zoomInCenter () {
         imgOrgH = parseInt(document.getElementById("zoomer").height);
         imgOrgW = parseInt(document.getElementById("zoomer").width);
         imgOrgY = parseInt(document.getElementById("zoomer").style.top);
         imgOrgX = parseInt(document.getElementById("zoomer").style.left);
         // Do the zooming
         zoomSumX = Math.floor((imgOrgW / imgOrgH) * zoomSumY);
         newH = imgOrgH + zoomSumY;
         // Snap to the original image size if close enough
         if( Math.abs(newH-realImgH) < zoomSumY/2 ) {
            newH = realImgH;
            newW = realImgW;
         } else {
            newW = imgOrgW + zoomSumX;
         }
         // Do the moving
         newX = imgOrgX - Math.abs(imgOrgW-newW)/2 + (getWinX()/2 - mouseX);
         newY = imgOrgY - Math.abs(imgOrgH-newH)/2 + (getWinY()/2 - mouseY);
         // Some sanity checks
         if( newW < getWinX() ) {
           if( newX > 0 && newX + newW > getWinX() ) {
               newX = getWinX() - newW;
            }
            if( newX < 0 && newX + newW < getWinX() ) {
               newX = 0;
            }
         } else {
            if( newX > 0 ) {
               newX = 0;
            }
            if( newX + newW < getWinX () ) {
               newX = getWinX() - newW;
            }
         }
         if( newH < getWinY() ) {
            if( newY > 0 && newY + newH > getWinY() ) {
               newY = getWinY() - newH;
            }
            if( newY < 0 && newY + newH < getWinY() ) {
               newY = 0;
            }
         } else {
            if( newY > 0 ) {
               newY = 0;
            }
            if( newY + newH < getWinY () ) {
               newY = getWinY() - newH;
            }
         }
         // Save everything
         document.getElementById("zoomer").style.width = Math.floor(newW).toString()+"px";
         document.getElementById("zoomer").style.height = Math.floor(newH).toString()+"px";
         document.getElementById("zoomer").style.left = Math.floor(newX).toString()+"px";
         document.getElementById("zoomer").style.top = Math.floor(newY).toString()+"px";
      }

      function zoomOut() {
         // Get some data 
         imgOrgH = parseInt(document.getElementById("zoomer").height);
         imgOrgW = parseInt(document.getElementById("zoomer").width);
         imgOrgY = parseInt(document.getElementById("zoomer").style.top);
         imgOrgX = parseInt(document.getElementById("zoomer").style.left);
         // Do the zooming
         if( imgOrgH > zoomSumY ) {
            zoomSumX = Math.floor((imgOrgW / imgOrgH) * zoomSumY);
            newH = imgOrgH - zoomSumY;
            // Snap to the original image size if close enough
            if( Math.abs(newH-realImgH) < zoomSumY/2 ) {
               newH = realImgH;
               newW = realImgW;
            } else {
               newW = imgOrgW - zoomSumX;
            }
            // Moving
            newX = imgOrgX + zoomSumX/2;
            newY = imgOrgY + zoomSumY/2;
            // Some sanity checks
            if( newW < getWinX() ) {
               if( newX > 0 && newX + newW > getWinX() ) {
                  newX = getWinX() - newW;
               }
               if( newX < 0 && newX + newW < getWinX() ) {
                  newX = 0;
               }
            } else {
               if( newX > 0 ) {
                  newX = 0;
               }
               if( newX + newW < getWinX () ) {
                  newX = getWinX() - newW;
               }
            }
            if( newH < getWinY() ) {
               if( newY > 0 && newY + newH > getWinY() ) {
                  newY = getWinY() - newH;
               }
               if( newY < 0 && newY + newH < getWinY() ) {
                  newY = 0;
               }
            } else {
               if( newY > 0 ) {
                  newY = 0;
               }
               if( newY + newH < getWinY () ) {
                  newY = getWinY() - newH;
               }
            }

            document.getElementById("zoomer").style.left = Math.floor(newX).toString()+"px";
            document.getElementById("zoomer").style.top = Math.floor(newY).toString()+"px";
            document.getElementById("zoomer").style.width = newW.toString()+"px";
            document.getElementById("zoomer").style.height = newH.toString()+"px";
         }
      }

      function getWinX () {
         return window.innerWidth;
      }
      function getWinY() {
         return window.innerHeight;
      }

   </script>
</head>
<body onload="startup()">

   <img src="zoomin.jpg" onclick="zoomIn()" style="position: absolute; top:0px; left:0px; z-index:10;">
   <img src="zoomout.jpg" onclick="zoomOut()" style="position: absolute; top:0px; left:40px; z-index:10;">
   <img src="zoomfit.jpg" onclick="zoomFit()" style="position: absolute; top:0px; left:80px; z-index:10;">
   <img src="zoom100.jpg" onclick="zoomOrg()" style="position: absolute; top:0px; left:120px; z-index:10;">
EOF

   print '<img src="'.$img.'" ondblclick="zoomInCenter()" class=\'moveable\' style="top:20px; left:20px;" id="zoomer"> ';

   print <<EOF;
</body>
EOF
