#ifndef _TESTBOX_H_
#define _TESTBOX_H_
/* $Id: testbox.h,v 1.8 2006/11/04 15:28:53 ruben Exp $ */


/* 
   Data structures related to the test-boxes 

   Test-box data is stored in a structure 3 elements:
     id        Arbitrary index
     name[25]  The name, ascii string, max 25 characters
     ipno      IP address, 32 bits as an unsigned int

*/

/* Maximum number of words on a single line of the config file */
#define MAXTBWORDS     100

/* preallocation number of test-boxes */
#define PREALLOC_TESTBOXES 100

/* lifted from <netinet/in.h> for pre prototype 5 operation */
#ifndef INET_ADDRSTRLEN
#define INET_ADDRSTRLEN                 16
#endif

/* lifted from <netinet6/in6.h> for pre prototype 5 operation */
#ifndef INET6_ADDRSTRLEN
#define INET6_ADDRSTRLEN    46
#endif

struct test_box_data
{
    int                 id;             /* ID of test-box */
    char                name[25];       /* Name of the test-box */
    char                ip_addr[INET6_ADDRSTRLEN+1];/* IP4/6 address if used */
    int                 family;         /* AF_INET or AF_INET6 */
};


extern struct test_box_data *test_box_list;
extern size_t number_of_boxes;


int                 read_test_box_config (char *, int);
void                free_test_box_config (void);
int                 test_box_id (char *);
int                 test_box_ip_id (char *, int);
const char *test_box_ip_name (char *, int);


/* TRUE and FALSE */
#ifndef TRUE
#define TRUE (1)
#define FALSE (0)
#endif

/* Files used by the programs (without $TTROOT/tmp) */

#define PATH_CONFIG	"/home/ttraffic/config"
#define PATH_HISTORY	"/home/ttraffic/tmp"
#define PATH_DATA_ROOT	"/home/ttraffic"

#define FILE_CNF "configfile"
#define LIST_OF_TESTBOXES "LIST_OF_TESTBOXES"

#endif /* _TESTBOX_H_ */
