/*
 * vi:ts=4:sw=4:
 *
 * $Id: measurement.h,v 1.3 2007/03/23 14:18:12 franzsch Exp $
 *
 * Copyright (c) 1998-2003 RIPE NCC
 * 
 * All Rights Reserved
 * 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the author not be used in advertising or 
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.
 * 
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
 * AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
 */
 

#ifndef _TT_MEASUREMENT_H_
#define _TT_MEASUREMENT_H_

#define OUTPUT_TYPE_STDERR  0x0

#ifndef EPERM
#include <errno.h>
#endif

#ifdef __FreeBSD__
#include <sys/time.h>
#else
#include <time.h>
#endif

void                brandom (void *, size_t);
void                HandleError (const char *, ...);
int                 writen (int, char *, int);
struct measurement *create_measurement (struct target *, int, struct measurement *);
void                list_measurement (struct measurement *);

#endif /* _TT_MEASUREMENT_H_ */
