/*
 * vi:ts=4:sw=4:
 *
 * $Id: control_daemon.h,v 1.3 2007/03/23 14:18:12 franzsch Exp $
 *
 * Copyright (c) 1998-2003 RIPE NCC
 * 
 * All Rights Reserved
 * 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the author not be used in advertising or 
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.
 * 
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
 * AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
 */

#ifndef _TT_CONTROL_DAEMON_H
#define _TT_CONTROL_DAEMON_H

#ifndef V4_FLAG
#define V4_FLAG 1
#endif

#ifndef V6_FLAG
#define V6_FLAG 2
#endif

#ifndef TT_ROOT
#define TT_ROOT "/home/ttraffic"
#endif

#ifndef PIDFILENAME
#define PIDFILENAME "/data/mcast/pid_list/McastControlDaemon"
#endif



#ifndef CONFIGFILENAME
#define CONFIGFILENAME "config/mcast/mcasts"
#endif

#include <sys/param.h>
#include "queue.h"


/* Default hard limit on the number of unique ports that will be listened too. */

#ifndef MAX_UDP_PORTS
#define MAX_UDP_PORTS 200
#endif

#define MAXLINE 100
/* 
 * to play with the output of ps(1) we need to copy av[0] into
 * an appropriately dimensioned string and then point av[0] to that.
 * Make it global, since we need it in about every function 
 */

#define DEBUG 0
char                programname[1024];
char*               interface;


struct DaemonsArgumentBuffer
{
	char                hostname[INET6_ADDRSTRLEN];
	short               portnumber;
	int                 family;	/* AF_INET or AF_INET6 */
	struct DaemonsArgumentBuffer *next;
};

struct delayprobetarget
{
	char                hostname[INET6_ADDRSTRLEN];
	short               portnumber;
	int                 family;	/* AF_INET or AF_INET6 */

	SLIST_ENTRY(delayprobetarget) entries;
};

SLIST_HEAD(DelayProbeList, delayprobetarget);


void                handle_signals (int signo);

#endif /* _TT_CONTROL_DAEMON_H */
