#!/usr/local/bin/perl5

use RRDs;

$data_area = "/data/mcast";
$trace_area = "/data/mcast/trace";
$rrd_area = "/data/mcast/rrd";
$rrd_cust_area = "/data/mcast/rrd/cust";
$plots_area = $ENV{"TTROOT"}."/apache/htdocs/gif";

`rm $plots_area/*`;
`rm $data_area/trace/temp/*`;

opendir( RRDDIR, $rrd_area ) || die "Cannot open $rrd_area";
foreach $filename (readdir(RRDDIR)) {
   if( $filename =~ /^.+\.rrd$/ ) {
      $last = RRDs::last("$rrd_area/$filename");
      if( time - $last > 30 * 24 * 60 *60 ) { # Last insert was more than 30 days ago
         `rm $rrd_area/$filename`;
      }
   }
   #
   # Check if this rrd still has data.
   #
   my $end = time;
   my $start = $end - 60*60*24*30;

   @dt = ();
   my ($st,$sp,$nm,$dt) = RRDs::fetch( $rrd_area."/".$filename, "AVERAGE", "-s", $start, "-e", $end );

   @strip = ();
   @sorted = ();
   # Check if all data is NaN or not...
   $empty = 1;
   foreach $line (@$dt) {
     if( defined( @$line[0] ) ) {
       $empty = 0;
     }
   }
   # And delete it if it happens to be empty
   if( $empty == 1 ) {
      `rm $rrd_area/$filename`;
   }
}

opendir( RRDDIR, $rrd_cust_area ) || die "Cannot open $rrd_cust_area";
foreach $filename (readdir(RRDDIR)) {
   if( $filename =~ /^.+\.rrd$/ ) {
      $last = RRDs::last("$rrd_cust_area/$filename");
      if( time - $last > 30 * 24 * 60 *60 ) { # Last insert was more than 30 days ago
         `rm $rrd_cust_area/$filename`;
      }
   }
   #
   # Check if this rrd still has data.
   #
   my $end = time;
   my $start = $end - 60*60*24*30;

   @dt = ();
   my ($st,$sp,$nm,$dt) = RRDs::fetch( $rrd_cust_area."/".$filename, "AVERAGE", "-s", $start, "-e", $end );

   @strip = ();
   @sorted = ();
   # Check if all data is NaN or not...
   $empty = 1;
   foreach $line (@$dt) {
     if( defined( @$line[0] ) ) {
       $empty = 0;
     }
   }
   # And delete it if it happens to be empty
   if( $empty == 1 ) {
      `rm $rrd_cust_area/$filename`;
   }

}

opendir (DATADIR, "$trace_area") || die "Cannot open $trace_area";

foreach $filename (readdir (DATADIR)) {
  if( $filename =~ /^MTRC\..+\.(\d+)$/ ) {
    $timestamp = $1;
    if( time - $timestamp > 43200 ) {
      `rm $data_area/trace/$filename`;
    }
  }
}
closedir DATADIR;

opendir (DATADIR, $data_area) || die "Cannot open $data_area";

foreach $filename (reverse sort readdir (DATADIR)) {
   if (substr($filename, 0, 5 ) eq "MRCP." || substr($filename, 0, 5 ) eq "CRCP.") {

      @_ = gmtime();
      $now_day = $_[3];
      $now_month = $_[4] + 1;
      $now_year = $_[5] + 1900;
      $len = length $filename;
      if( substr($filename, 0, 5 ) eq "MRCP." ) {
         $file_day = substr($filename, $len - 9, 2);
         $file_month = substr($filename, $len - 11, 2);
         $file_year = substr($filename, $len - 15, 4);
         $file_ok = 0;
      } else {
         $file_day = substr($filename, $len - 2, 2);
         $file_month = substr($filename, $len - 4, 2);
         $file_year = substr($filename, $len - 8, 4);
         $file_ok = 0;
      }
      if    ($file_year == $now_year && $file_month == $now_month && $now_day - $file_day < 30) { $file_ok = 1; }
      elsif ($file_year == $now_year && $now_month - $file_month == 1 && 31 - $file_day + $now_day < 30) { $file_ok = 1; }
      elsif ($now_year - $file_year == 1 && $file_month == 12 && $now_month == 1 && 31 - $file_day + $now_day < 30) { $file_ok = 1; }
      if    ( $file_ok == 0 ) { `rm $data_area/$filename`; } # File is too old, delete it
   }
}

closedir DATADIR;
