/*
 * vi:ts=4:sw=4:
 *
 * $Id: test_it.c,v 1.2 2003/10/17 10:49:49 ruben Exp $
 *
 * Copyright (c) 1998-2003 RIPE NCC
 * 
 * All Rights Reserved
 * 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the author not be used in advertising or 
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.
 * 
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
 * AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
 */

#include <stdio.h>
#include <limits.h>
	
#include <regex.h>
int main (void)
{

	size_t              currentsize;
	char                currentline[_POSIX2_LINE_MAX];
	FILE               *fp;
	regex_t            *rc;
	int                 rflags;


	/* 
	 * First compile the regular expression.  A non-empty line in the
	 * configuration file contains a host and portnumber seperated by
	 * one ore more blanks. A host is a alphanumeric set of characters
	 * which may contain . and _ (and what more is allowed in a
	 * hostname.. I should look this up in an RFC)
	 */


	/* See egrep(1) for syntax */

	fp = fopen ("./control.configfile", "r");
	if (fp == NULL)
	{
		printf ("Error reading configuration file");
		exit (1);
	}

	/* read the file line by line... */
	while (fgets (currentline, _POSIX2_LINE_MAX, fp))
	{
		char                hostname[1024];
		int                 port;

		sscanf (currentline, "%s %d", hostname, &port);

		if (!strchr (hostname, '#'))
		{
			printf ("hostname %s port %d\n", hostname, port);
		}

	}



	return (0);
}

