

/* This is a generic framework to test some of the functions I wrote.
 * It is only here to help during development and debugging....
 * It has no vallue whatsoever otherwise
 *  
 * Author: Olaf Kolkman
 * $Id: timertest.c,v 1.6 2003/10/17 10:49:49 ruben Exp $
 */

#include<stdio.h>
#include<sys/time.h>

#ifdef __FreeBSD__
#include<sys/timex.h>
#endif /* __FreeBSD__ */



#ifndef _SYS_GETPPSTIME
#include "getppstime.h"
#endif /* _SYS_GETPPSTIME */

#define NO_MEAS 1

#include <sys/param.h>

#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <limits.h>

#include "if_utils.h"
#include "utils.h"
#include "control_daemon.h"

static char const rcsid[] = "$Id: timertest.c,v 1.6 2003/10/17 10:49:49 ruben Exp $";

extern int CreateTCPDUMPargument(struct DaemonsArgumentBuffer * , char **);

int main (void)
{

	struct timeval      current;
	struct pps_val      ptx;
	struct etherifdata  efdata;
	int                 i;
	char                errbuff[_POSIX2_LINE_MAX];
	char               *test;
	struct DaemonsArgumentBuffer hostlist[] = {
		{"osdorp.ripe.net", 5000, AF_INET, &hostlist[1]},
		{"osdorp.ripe.net", 6000, AF_INET, &hostlist[2]},
		{"x19.ripe.net", 6000, AF_INET, &hostlist[3]},
		{"x22.ripe.net", 6000, AF_INET, &hostlist[4]},
		{"x20.ripe.net", 6000, AF_INET, &hostlist[5]},
		{"pijp.ripe.net", 5000, AF_INET, NULL},
	};
	char                TEST[300];

	brandom (TEST, 300);
	for (i = 0; i < 300; i++)
	{
		printf ("%02hX", (u_char) TEST[i]);
	}

	GetEthernetIFInfo (&efdata, errbuff);
	CreateTCPDUMPargument (hostlist, &test);

	printf ("--->%s<----\n", test);


	printf ("\n------------------------------------------------------------------\n");
	printf ("|                                                                |\n");
	printf ("|                    Test Program Only                           |\n");
	printf ("|               Use only for debugging purposes                  |\n");
	printf ("|                                                                |\n");

	printf ("------------------------------------------------------------------\n");

	printf ("%s\t", inet_ntoa (efdata.ethif_addr));

	printf ("%10lu %5lu %10lu %10lu %5lu %10lu %5lu\n",
			efdata.if_data.ifi_ipackets,
			efdata.if_data.ifi_ierrors,
			efdata.if_data.ifi_ibytes,
			efdata.if_data.ifi_opackets, efdata.if_data.ifi_oerrors, efdata.if_data.ifi_obytes, efdata.if_data.ifi_collisions);

	printf ("\n------------------------------------------------------------------\n");


	for (i = 0; i <= NO_MEAS; i++)
	{
		struct timeval      x;

		gettimeofday (&current, NULL);
		getppstime (&ptx);

		x = pps_diff_cor (ptx.current_time, ptx.last_pps);
		if (i > 0)
		{
			printf ("%ld.%06ld  %ld.%06ld %ld.%06ld  %06ld %06ld %06ld %04X %ld.%06ld\n",
					current.tv_sec, current.tv_usec,
					ptx.current_time.tv_sec, ptx.current_time.tv_usec,
					ptx.last_pps.tv_sec, ptx.last_pps.tv_usec,
					ptx.pll_offset, ptx.maxerror, ptx.esterror, ptx.pps_status, x.tv_sec, x.tv_usec);
		}
	}
	return (0);
}
