#ifndef __refclocksync_h
/* $Id: refclocksync.h,v 1.2 2006/11/04 15:28:54 ruben Exp $ */

#include <sys/select.h>

#define __refclocksync_h

#define LOG_DRIVER 1
#define LOG_INFO 2
#define LOG_ERROR 4
#define LOG_NONL 8
#define LOG_RAW 16
#define LOG_MAIN 32
#define LOG_PPS 64
#define LOG_PLL 128

extern int loglevel;

typedef struct __refclocksync_driver_t
{
	int (*driver_init)(struct __refclocksync_driver_t *driver);
	int (*driver_getfds)(struct __refclocksync_driver_t *driver, fd_set *rdfd);
	void (*driver_input_ready)(struct __refclocksync_driver_t *driver, fd_set *rdfd);
	void (*driver_alarm)(struct __refclocksync_driver_t *driver);

	void *driver_data;
} refclocksync_driver_t;

extern void Log(int flags, char *format, ...);
extern void register_driver(refclocksync_driver_t *driver);
extern void driver_delta(double d);

#endif
