#! /usr/local/bin/perl -wT
use strict;

# $Id: rrd_box_insert.pl,v 1.2 2009/02/10 21:00:14 ruben Exp $
#
# last pid: 13320;  load averages:  0.06,  0.05,  0.01  up 166+04:00:38    13:46:23
# 62 processes:  1 running, 55 sleeping, 1 stopped, 5 zombie
# CPU states:  0.5% user,  0.0% nice,  1.9% system,  0.9% interrupt, 96.8% idle
# Mem: 59M Active, 98M Inact, 41M Wired, 14M Cache, 35M Buf, 37M Free
# Swap: 256M Total, 32K Used, 256M Free
# 
# 
#   PID USERNAME PRI NICE SIZE    RES STATE    TIME   WCPU    CPU COMMAND
# 24418 dfk      -6   0  1732K  2112K piperd   8:38  0.08%  0.08% perl
# 11300 dfk      18   0   688K  1032K pause    0:00  0.00%  0.00% tcsh
# ...

use Time::Local;
use POSIX;
use RRDs;

$ENV{'PATH'} = '/bin:/usr/bin';

my ($pid, $lav1, $lav5, $lav15);
my ($prun, $psle, $psto);
my ($cpuu, $cpun, $cpus, $cput, $cpui) = qw(0 0 0 0 0);
my ($mema, $memb, $memf, $swpf);
my ($year, $month, $day);
my ($hour, $min, $sec);
my ($lasthour);

select(STDOUT); $| = 1;       # make unbuffered

open(TOP,"/usr/bin/top -b -s60 -d1500 |") || die "Couldn't start top: $1";
while (defined(my $input = <TOP>)) {
	my $ERR;

	chomp($input);

	if ($input =~ /DATE ([0-9]+)\s+([0-9]+)\s+([0-9]+)/) {
		($year, $month, $day) = ($1, $2, $3);
	}
	elsif ($input =~ /last pid:\s+([0-9]+);\s+load averages:\s+([0-9.]+),\s+([0-9.]+),\s+([0-9.]+)\s+(up\s+[^ ]+\s+)?\s+([0-9]+):([0-9]+):([0-9]+)/) {

		($pid, $lav1, $lav5, $lav15, undef, $hour, $min, $sec) = ($1, $2, $3, $4, $5, $6, $7, $8);
	}
	elsif ($input =~ /processes:\s+([0-9]+)\s+running,\s+([0-9]+)\s+sleeping/) {
		($prun, $psle) = ($1, $2, $3);
		if ($input =~ /sleeping,\s+([0-9]+) stopped/) {
			$psto = $1;
		}
	}
	elsif ($input =~ /CPU states:\s+([0-9.]+)% user,\s+([0-9.]+)% nice,\s+([0-9.]+)% system,\s+([0-9.]+)% interrupt,\s+([0-9.]+)% idle/) {
		($cpuu, $cpun, $cpus, $cput, $cpui) = ($1, $2, $3, $4, $5);
	}
	elsif ($input =~ /Mem:\s+([0-9]+)([MK]+).*\s+([0-9]+)([MK]+) Buf,\s+([0-9]+)([MK]+) Free/) {
		my $i;
		my (@mems) = ($1, $2, $3, $4, $5, $6);
		for ($i=0; $i<$#mems; $i+=2) {
			if ($mems[$i+1] eq 'M') {
				$mems[$i] *= 1024;
			}
		}
		($mema, $i, $memb, $i, $memf, $i) = @mems;
	}
	elsif ($input =~ /Swap:.*\s+([0-9]+)([MK]+) Free/) {
		$swpf = $1;
		$swpf *= 1024 if $2 eq 'M';

		RRDs::update("/data/rrd/box1.rrd",
			sprintf("%d:%d:%.2f:%.2f:%.2f", time(), $pid, $lav1, $lav5, $lav15) .
			sprintf(":%d:%d:%d", $prun, $psle, $psto) .
			sprintf(":%.1f:%.1f:%.1f:%.1f:%.1f", $cpuu, $cpun, $cpus, $cput, $cpui) .
			sprintf(":%s:%s:%s:%s", $mema, $memb, $memf, $swpf)
		);
		$ERR=RRDs::error;
		warn "ERROR while updating box1.rrd: $ERR\n" if $ERR;
	}
}
close(TOP);
