#! /usr/local/bin/perl -wT
require 5.002;
use strict;
use lib qw(/home/ttraffic/lib);
use lib qw(/usr/local/rrd/lib/perl);

# $Id: rrd_gps64s_insert.pl,v 1.1 2006/06/21 12:22:06 ruben Exp $
#
# U1 31.3.2001 01:22:52 13 01
# C1 31032001 012252 6   62262 110.2 545 6.7 13 5222.371614 N 0453.263573 E 68  -31 -27 26 17 10 8 0 2
# S1 31 1 2 00  0.0  38.9 10.1
# S1 27 2 2 02 32.7  66.4 22.2
# S1 26 3 1 02 57.5 291.1 52.3
# S1 17 4 1 02 49.8 303.6 20.1
# S1 10 5 1 02 53.6 205.4 51.8
# S1 08 6 1 02 56.5  65.7 48.1
# S1 02 8 1 02 58.0 142.0 50.3


use Time::Local;
use POSIX;
use RRDs;

$ENV{'PATH'} = '/bin:/usr/bin';

select(STDOUT); $| = 1;       # make unbuffered

my (@snr,@prn,@azn,@elv);
my ($secs,$satc,$satr,$satv,$mode,$bunc);
my ($date,$time);

$satv = 0;

open(TAIL,"/usr/bin/tail -F /var/log/xntp/clockstats |") || die "Couldn't start tail: $!";
while (<TAIL>) {
	my ($output, $ERR);
	
	last unless defined $_;
	chop;
	next unless /[USC]1 /;
	s/.*([UCS]1 )/$1/;


	if (/U1 /) {
		my $d;
		($d, $d, $d, $mode, $d) = split;
	}

	
	elsif (/C1 /) {
		my (@s,$d);

		if ($date) {
			my ($day, $month, $year, $hour, $min, $sec);

			$day = substr($date, 0, 2);
			$month = substr($date, 2, 2);
			$year = substr($date, 4, 4);
			$hour = substr($time, 0, 2);
			$min = substr($time, 2, 2);
			$sec = substr($time, 4, 2);

			$secs = timegm($sec, $min, $hour, $day, $month-1, $year);

	
			$satr += $satc;
			$satr -= $satv;
			$satv += $satr;


			$output = "$secs:$satc:$satr:$satv:$mode:$bunc";
			$satc = $satr = $satv = 0;

			for (my $i=0; $i<8; $i++) {
				if ($prn[$i] && $snr[$i]) {
					$output .= sprintf ':%s', $snr[$i];
					$output .= sprintf ':%s', $prn[$i];
					$output .= sprintf ':%s', $azn[$i];
					$output .= sprintf ':%s', $elv[$i];
				}
				else {
					$output .= sprintf ':U:U:U:U';
				}
			}
			
			RRDs::update("/data/rrd/gps64s.rrd", $output);
			$ERR=RRDs::error;
			warn "ERROR while updating gps64s.rrd: $ERR\n" if $ERR;
		}


		($d, $date, $time, $mode, $d, $bunc, $d, $d, $d, $d, $d, $d, $d, $d, $s[0], $s[1], $s[2], $s[3], $s[4], $s[5], $s[6], $s[7]) = split;

		for (my $i=0; $i<8; $i++) {
			$satc++ if $s[$i]>0;
			$satr++ if $s[$i]<0;
			$prn[$i] = $s[$i];
		}
	}

	elsif (/S1 /) {
# S1 17 4 1 02 49.8 303.6 20.1
		my ($d, $sat, $chn, $snr, $azn, $elv);
		($d, $sat, $chn, $d, $d, $snr, $azn, $elv) = split;

		$snr[$chn-1] = $snr;
		if ($snr == 0) {
			$satv++;
		}
		$azn[$chn-1] = $azn;
		$elv[$chn-1] = $elv;
	}
}
close(TAIL);
