/*
 * vi:ts=4:sw=4:
 *
 * $Id: taildaemon.h,v 1.6 2005/01/19 13:59:37 wilhelm Exp $
 *
 * Copyright (c) 1998-2003 RIPE NCC
 * 
 * All Rights Reserved
 * 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the author not be used in advertising or 
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.
 * 
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
 * AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
 */


#ifndef PORT
#define PORT 9142
#endif

#ifndef TT_ROOT
#define TT_ROOT  "/usr/home/ttraffic"
#endif /* TT_ROOT */

#ifndef PIDFILENAME
#define PIDFILENAME "data/pid_list/TailDaemon"
#endif

#ifndef CONFIGFILENAME
#define CONFIGFILENAME "config/taildaemon.conf"
#endif

#ifndef MASKFILENAME
#define MASKFILENAME "config/taildaemon.mask"
#endif

/* Maximum number of files to tail */
#ifndef MAX_TAIL_FILES
#define MAX_TAIL_FILES 50
#endif


/* type definition */

typedef struct _filestat {
	char *name;	/* filename */
	FILE *fp;	/* NULL if file is closed */
	int  keep_open; /* currently open file should stay open */
	int  new_file;	/* it's a new file, not in the first config read */
} filestat;


/* function prototypes */

filestat *addfile(filestat *files, int *numfiles, char *filename);
filestat *searchfile(filestat *files, int numfiles, char *filename);

void handlesignal (int signo);
void handleHUPsignal (int signo);

void TailFiles (char *configfilename, int sfd);    
void mark_old_files (filestat *files, int numfiles);
void close_old_files (filestat *files, int numfiles);
int  AllowedClient(struct in_addr in, char *maskfilename) ;
void ReadConfigFile (char *configfilename, filestat *files, int *numfiles);
void WriteFilesToSockets(int sfd, filestat *files, int numfiles);
