#!/usr/bin/perl5 -w
#
# $Id#
#

use strict;
use Socket;
use Socket6;

use vars qw(@input_line);
use vars qw($i $j $buffer $entry $count $head $tail $filename $plotname);
use vars qw(%fields);
use vars qw($MAXBOXES);
use vars qw($temp $flag);
use vars qw($plotstring);
use vars qw(%location);


$MAXBOXES = 200;

&page_header;
#
# Read file with TB location
#
open (TB, "/home/ttraffic/apache/htdocs/assets/listofcities.txt") ||
 print "Cannot open\n";

while (<TB>) {
  chomp ;
  ($i, $j) = split (": ", $_);
  $location{$i} = $j;
}
close (TB);

$buffer = "";
$buffer = $ENV{'QUERY_STRING'};

#
# Replace +-signs by spaces.
#
$_ = $buffer;

s/\+/ /g;
s/%3A/:/g;
s/%2F/\//g;
s/%2C/,/g;
s/%2B/+/g;

$buffer = $_;

@input_line = split (/&/, $buffer);

%fields = ();
foreach $entry (@input_line) {
  ($head, $tail) = split(/=/, $entry);
  $fields{$head} = $tail;
}

#
# Build table with possible options
# 
print <<EOF;
<FORM NAME="Inbound delays" ACTION="/cgi-bin/multiple.cgi" METHOD="GET">
 <TABLE BORDER=0 CELLSPACING=5 CELLPADDING=0 WIDTH=625>
  <TR>
  <TD COLSPAN=1>
   <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Select Test-box(es):</B>
  </TD>
  <TD COLSPAN=2>
   <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <B> <INPUT TYPE="checkbox" name="all" value="all">All testboxes</B></FONT>
  </TD>
 </TR>
 <TR>
EOF

$j = 0;
open(LOT,"/home/ttraffic/config/LIST_OF_TESTBOXES") || die "Couldn't read LIST_OF_TESTBOXES: $!";
while (defined(my $input = <LOT> )) {
  my (@input);
  my ($tb, $tb_real, $tbip,$hostname,$rrdfile,$tb6,$tbip6,$hostname6,$rrdfile6);
  chomp($input);

  @input = split(/\s/,$input);

  $tb = $input[1];

  next unless $tb =~ /tt[0-9]+[a-f]?/;

  ($hostname) = $tb if $input[2] =~ /^(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})$/; 
  ($hostname6) = $tb if $input[2] =~ /^([0-9A-Fa-f]{0,4}:([0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})$/; 

  $tb =~ s/\.ripe\.net$//;
  $tb_real = $tb;
  $tb_real =~ s/[a-f]$//;

  if (defined $hostname) {
    $tbip = $input[2];
    $rrdfile = "/data/rrd/".$tbip.".rrd";
    if ((-e $rrdfile) && ((-M $rrdfile) < 8.0)) {
      if (exists($fields{"all"}) && $fields{"all"} ne "") {$fields{$tb} = $tbip; }

      print "<TD WIDTH=225><INPUT TYPE=\"checkbox\" NAME=\"$tb\" VALUE=\"$tbip\"";
      if (exists($fields{$tb}) && $fields{$tb} ne "") { print " CHECKED"; } 
      print "><FONT FACE=\"Arial,Helvetica,Univers,Zurich BT,sans-serif\">",
       "<B><A HREF=\"http://www.ripe.net/test-traffic/Plots/map_index.cgi?sel=src&box=$tb_real\">$tb</B></A> <FONT SIZE=-2> ", substr($location{$tb_real},0, 22), "</FONT></TD>\n";
      $j++;
      if ($j == 3) {
        printf "</TR><TR>\n";
        $j = 0;
      }
    }
  }
  if (defined $hostname6) {
    $tbip6 = $input[2]; 
    $rrdfile6 = "/data/rrd/".$tbip6.".rrd";
    $tb6 = $tb."_IPv6";
    if ((-e $rrdfile6) && ((-M $rrdfile6) < 8.0)) {
      if (exists($fields{"all"}) && $fields{"all"} ne "") {$fields{$tb6} = $tbip6; }

      print "<TD WIDTH=225><INPUT TYPE=\"checkbox\" NAME=\"$tb6\" VALUE=\"$tbip6\"";
      if (exists($fields{$tb6}) && $fields{$tb6} ne "") { print " CHECKED"; }
      print "><FONT FACE=\"Arial,Helvetica,Univers,Zurich BT,sans-serif\">",
       "<B><A HREF=\"http://www.ripe.net/test-traffic/Plots/map_index.cgi?sel=src&box=$tb_real\">$tb</B></A> (IPv6) <FONT SIZE=-2> ", substr($location{$tb_real},0, 22), "</FONT></TD>\n";
      $j++;
      if ($j == 3) {
        printf "</TR><TR>\n";
        $j = 0;
      }
    }
  }
}
close(LOT);



print <<EOF2;
</TR><TR><TD Colspan=4> <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
Click on the test-box number for a full map</TD>
</TR>
</TABLE>

<TABLE>

<TR>
 <TD><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Delays:</TD>
 <TD><INPUT TYPE="checkbox" name="delay" value="delay"
EOF2

if ($fields{"delay"} ne "") {print "CHECKED";}

if (($fields{"loss"}  eq "") &&
    ($fields{"delay"} eq ""))  {print "CHECKED";}

print <<EOF10;
></TD>
</TR><TR>
<TD><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Losses:</TD>
<TD><INPUT TYPE="checkbox" name="loss" value="loss"
EOF10

if ($fields{"loss"} ne "") {print "CHECKED";}


print <<EOF11;
></TD>
</TR>
 <TR>
  <TD>
   <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Start:</B></FONT>
  </TD>
  <TD ALIGN="LEFT"><INPUT ID="Forms Edit Field1" TYPE=TEXT NAME="RRD_START" VALUE="
EOF11


$_ = $fields{"RRD_START"};
s/\+/ /g;
s/%3A/:/g;
s/%20/ /g;
$fields{"RRD_START"} = "\"".$_."\"";

if ($_ ne "") {
  print $_;
} else {
  print "now-1week";
}
  

print <<EOF3;
" SIZE=16 MAXLENGTH=40>
 </TD>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Length: </B></FONT>
 </TD>
 <TD ALIGN="LEFT">
  <SELECT ID="FormsComboBox4" NAME="RRD_END">
EOF3

if ($fields{"RRD_END"} ne "") {
  print "<OPTION VALUE=\"", $fields{"RRD_END"}, "\">", $fields{"RRD_END"}, "</OPTION>\n";}

print <<EOF4;
   <OPTION VALUE="start+1week">1 week</OPTION>
   <OPTION VALUE="start+4days">4 days</OPTION>
   <OPTION VALUE="start+2days">2 days</OPTION>
   <OPTION VALUE="start+1day">1 day</OPTION>
   <OPTION VALUE="start+12h">12 hours</OPTION>
   <OPTION VALUE="start+6h">6 hours</OPTION>
   <OPTION VALUE="start+4h">4 hours</OPTION>
   <OPTION VALUE="start+2h">2 hours</OPTION>
   <OPTION VALUE="start+1h">1 hour</OPTION>
   <OPTION VALUE="start+1800s">30 minutes</OPTION>
   <OPTION VALUE="start+900s">15 minutes</OPTION>
  </SELECT>
 </TD>
</TR>
<TR>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Height:</B></FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <SELECT ID="FormsComboBox3" NAME="RRD_W">
EOF4

if ($fields{"RRD_W"} ne "") {
  print "<OPTION VALUE=\"", $fields{"RRD_W"}, "\">";
  if    ($fields{"RRD_W"} eq "-h100") {print "small";}
  elsif ($fields{"RRD_W"} eq "-h200") {print "medium";}
  else                                {print "high";  }
  print "</OPTION>\n";
}

print <<EOF5;
    <OPTION VALUE="-h100">small</OPTION>
    <OPTION VALUE="-h200">medium</OPTION>
    <OPTION VALUE="-h300">high</OPTION>
   </SELECT>
  </FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Width: </B></FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <SELECT ID="FormsComboBox5" NAME="RRD_H">
EOF5

if ($fields{"RRD_H"} ne "") {
  print "<OPTION VALUE=\"", $fields{"RRD_H"}, "\">";
  if    ($fields{"RRD_H"} eq "-w350") {print "narrow";}
  elsif ($fields{"RRD_H"} eq "-w600") {print "medium";}
  else                                {print "wide";  }
  print "</OPTION>\n";
}

print <<EOF6;
    <OPTION VALUE="-w350">narrow</OPTION>
    <OPTION VALUE="-w600">medium</OPTION>
    <OPTION VALUE="-w800">wide</OPTION>
   </SELECT>
  </FONT>
 </TD>
</TR>
<TR>
 <TD>
  <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Y-range delay: </B></FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <INPUT ID="RRD_L" TYPE=TEXT NAME="RRD_L" VALUE="
EOF6

if ($fields{"RRD_L"} eq "")  {
  print "0"; 
} else {
  print $fields{"RRD_L"};
}

print <<EOF7;
" SIZE=16 MAXLENGTH=40></TD>
  </FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B> to </B></FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <INPUT ID="FormsEditField3" TYPE=TEXT NAME="RRD_R" VALUE="
EOF7

if ($fields{"RRD_R"} eq "")  {
  print "1"; 
} else {
  print $fields{"RRD_R"};
}

print <<EOF8;
" SIZE=16 MAXLENGTH=40>
  </FONT>
 </TD>
 <TD>
  <SELECT ID="FormsComboBox6" NAME="RRD_RIGID">
EOF8

if ($fields{"RRD_RIGID"} eq "--rigid" ) {
  print "<OPTION VALUE=\"rigid\">fixed</OPTION>";
  print "<OPTION VALUE=\"-l0\">auto-increment</OPTION>";
} else {
  print "<OPTION VALUE=\"-l0\">auto-increment</OPTION>";
  print "<OPTION VALUE=\"--rigid\">fixed</OPTION>";
}

print <<EOF9;
  </SELECT>
 </TD>
</TR>
<TR>
 <TD> 
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B> Loss plots: 
   </B></FONT>
 </TD>
EOF9

if ($fields{"LFORMAT"} eq "LOSS")  {
 print <<EOF98;
 <TD>
  <INPUT TYPE="RADIO" NAME="LFORMAT" VALUE="LOSS" CHECKED>Loss Only
 </TD>
 <TD></TD>
 <TD>
  <INPUT TYPE="RADIO" NAME="LFORMAT" VALUE="BOTH">Loss and Arrived
 </TD>
EOF98
} else {
 print <<EOF99;
 <TD>
  <INPUT TYPE="RADIO" NAME="LFORMAT" VALUE="LOSS">Loss Only
 </TD>
 <TD></TD>
 <TD>
  <INPUT TYPE="RADIO" NAME="LFORMAT" VALUE="BOTH" CHECKED>Loss and Arrived
 </TD>
EOF99
}


print <<EOF10;
</TR>

<TR>
 <TD>
  <INPUT TYPE=SUBMIT NAME="Draw" VALUE="Draw" ID="FormsButton3">
 </TD>
</TR>

</TABLE>

        </FORM>

<TABLE>
EOF10



$flag = 0;

foreach $entry (sort keys %fields) {
  if (substr ($entry, 0, 2) eq "tt") {
    s/%3A/:/g;
    `ln -sf /data/rrd/$fields{$entry}.rrd /data/rrd/delay.rrd`;
    `ln -sf /data/rrd/loss.$fields{$entry}.rrd /data/rrd/loss.rrd`;
    print "<TR>";
    if ($fields{"delay"} ne "") {
      $plotname = "/gif/delay.".$fields{$entry}.".".time.".gif";
      $filename = " /home/ttraffic/apache/htdocs".$plotname;
      $plotstring = "/usr/local/bin/rrdtool graph ";
      $plotstring = $plotstring.$filename;
      $plotstring = $plotstring." --title=\"incoming delays from ".$entry." on ".`date`."\" ";
      $plotstring = $plotstring." ".$fields{"RRD_W"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_H"}." ";
      $plotstring = $plotstring." -l".$fields{"RRD_L"}." ";
      $plotstring = $plotstring." -u".$fields{"RRD_R"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_RIGID"}." ";
      $plotstring = $plotstring." -e".$fields{"RRD_END"}." ";
      $plotstring = $plotstring." -s".$fields{"RRD_START"}." ";
      $plotstring = $plotstring." -v\"Delay [ms]\"";
      $plotstring = $plotstring." -c CANVAS#E0E0E0";
      $plotstring = $plotstring." DEF:val1=/data/rrd/delay.rrd:delay:MAX";
      $plotstring = $plotstring." DEF:val2=/data/rrd/delay.rrd:delay:AVERAGE";
      $plotstring = $plotstring." DEF:val3=/data/rrd/delay.rrd:delay:MIN";
      $plotstring = $plotstring." AREA:val1#FF8800:\"Spread: \""; 
      $plotstring = $plotstring." GPRINT:val3:MIN:\"%.2lf ... \"";
      $plotstring = $plotstring." GPRINT:val1:MAX:\"%.2lf ms \"";
      $plotstring = $plotstring." LINE2:val2#0000FF:\"Average Delay:\"";
      $plotstring = $plotstring." AREA:val3#E0E0E0";
      $plotstring = $plotstring." GPRINT:val2:AVERAGE:\"%.2lf ms\"";
      `$plotstring`;
      print "<TD><IMG SRC=".$plotname."></TD>";
    }

    if ($fields{"loss"} ne "") {
      $plotname = "/gif/loss.".$fields{$entry}.".".time.".gif";
      $filename = " /home/ttraffic/apache/htdocs".$plotname;
      $plotstring = "/usr/local/bin/rrdtool graph ";
      $plotstring = $plotstring.$filename;
      $plotstring = $plotstring." --title=\"incoming losses from ".$entry." on ".`date`."\" ";
      $plotstring = $plotstring." ".$fields{"RRD_W"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_H"}." ";
      $plotstring = $plotstring." -l0.00";
      $plotstring = $plotstring." -e".$fields{"RRD_END"}." ";
      $plotstring = $plotstring." -s".$fields{"RRD_START"}." ";
      $plotstring = $plotstring." -v\"Percentage of packets\"";
      $plotstring = $plotstring." -c CANVAS#E0E0E0";
      $plotstring = $plotstring." DEF:val1=/data/rrd/loss.rrd:loss:AVERAGE";
      $plotstring = $plotstring." CDEF:val3=100,val1,*";
      $plotstring = $plotstring." CDEF:val2=100,val3,-";
      $plotstring = $plotstring." AREA:val2#FF0000:\"Lost: \"";
      $plotstring = $plotstring." GPRINT:val2:AVERAGE:\"%.2lf %% \"";

      if ($fields{"LFORMAT"} ne "LOSS") {
        $plotstring = $plotstring." -u105"; 
        $plotstring = $plotstring." --rigid";
        $plotstring = $plotstring." STACK:val3#00CC00:\"Arrived: \""; 
        $plotstring = $plotstring." GPRINT:val3:AVERAGE:\"%.2lf %% ... \"";
      } else {
        $plotstring = $plotstring." -u1.0"; 
      }
      `$plotstring`;
      print "<TD><IMG SRC=".$plotname."></TD>";
    }
    print "</TR>\n";
  }
}

print <<EOF10;
</TABLE>
EOF10



&page_footer();

exit;






sub page_header {

print "Content-type: text/html\n\n";
print <<EOF;
 
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-1">
<TITLE>Inbound Delays</TITLE>
<SCRIPT>
<!--
function F_loadRollover(){} function F_roll(){}
//-->
</SCRIPT>
<SCRIPT LANGUAGE="JavaScript1.2" SRC="../rollover.js"></SCRIPT>
</HEAD>
<BODY NOF="(MB=(MeasureLayout, 123, 50, 24, 10), L=(InboundDelaysLayout, 701, 382))" BGCOLOR="#FFFFF8" TEXT="#000000" LINK="#333300" VLINK="#6699CC" ALINK="#000000" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
  <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=725 NOF=LY>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD WIDTH=24 HEIGHT=6><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=24 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=1><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=1 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=199><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=199 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=400><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=400 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=1><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=1 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=99><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=99 HEIGHT=1 BORDER=0></TD>
      <TD WIDTH=1><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=1 HEIGHT=1 BORDER=0></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD></TD>
      <TD COLSPAN=5 WIDTH=700><IMG ID="Banner1" HEIGHT=30 WIDTH=700 SRC="../assets/images/autogen/Inbound_Delays_NBanner.GIF" BORDER=0 ALT="Inbound Delays" NOF=B_H></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=7 HEIGHT=5></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=20></TD>
      <TD COLSPAN=5 WIDTH=700>
        <TABLE ID="NavigationBar1" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=NB_UYHP WIDTH=700>
          <TR VALIGN=TOP ALIGN=LEFT>
            <TD WIDTH=100><A HREF="../index.html" onMouseOver="F_roll('NavigationButton1',1)" onMouseOut="F_roll('NavigationButton1',0)"><IMG ID="NavigationButton1" NAME="NavigationButton1" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_52.GIF" onLoad="F_loadRollover(this,'_NRp2_58.GIF')" BORDER=0 ALT="Test Box Home"></A></TD>
            <TD WIDTH=100><A HREF="../html/documentation.html" onMouseOver="F_roll('NavigationButton2',1)" onMouseOut="F_roll('NavigationButton2',0)"><IMG ID="NavigationButton2" NAME="NavigationButton2" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_48.GIF" onLoad="F_loadRollover(this,'_NRp2_54.GIF')" BORDER=0 ALT="Documentation"></A></TD>
            <TD WIDTH=100><A HREF="../html/status.html" onMouseOver="F_roll('NavigationButton3',1)" onMouseOut="F_roll('NavigationButton3',0)"><IMG ID="NavigationButton3" NAME="NavigationButton3" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_49.GIF" onLoad="F_loadRollover(this,'_NRp2_55.GIF')" BORDER=0 ALT="Status"></A></TD>
            <TD WIDTH=100><A HREF="../cgi-bin/configuration_targets.cgi" onMouseOver="F_roll('NavigationButton4',1)" onMouseOut="F_roll('NavigationButton4',0)"><IMG ID="NavigationButton4" NAME="NavigationButton4" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_50.GIF" onLoad="F_loadRollover(this,'_NRp2_56.GIF')" BORDER=0 ALT="Configuration"></A></TD>
            <TD WIDTH=100><A HREF="../html/measurements.html" onMouseOver="F_roll('NavigationButton5',1)" onMouseOut="F_roll('NavigationButton5',0)"><IMG ID="NavigationButton5" NAME="NavigationButton5" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_53.GIF" onLoad="F_loadRollover(this,'_NRp2_59.GIF')" BORDER=0 ALT="Measurements"></A></TD>
            <TD WIDTH=100><A HREF="http://www.ripe.net/test-traffic" onMouseOver="F_roll('NavigationButton6',1)" onMouseOut="F_roll('NavigationButton6',0)"><IMG ID="NavigationButton6" NAME="NavigationButton6" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_51.GIF" onLoad="F_loadRollover(this,'_NRp2_57.GIF')" BORDER=0 ALT="TTM Web Site"></A></TD>
            <TD WIDTH=100 HEIGHT=20><A HREF="../html/help.html" onMouseOver="F_roll('NavigationButton7',1)" onMouseOut="F_roll('NavigationButton7',0)"><IMG ID="NavigationButton7" NAME="NavigationButton7" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_76.GIF" onLoad="F_loadRollover(this,'_NRp2_82.GIF')" BORDER=0 ALT="Help"></A></TD>
          </TR>
        </TABLE>
      </TD>
      <TD></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=7 HEIGHT=13></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=20></TD>
      <TD COLSPAN=2 WIDTH=200>
        <TABLE ID="NavigationBar2" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=NB_UYHP WIDTH=200>
          <TR VALIGN=TOP ALIGN=LEFT>
            <TD WIDTH=100><A HREF="../html/inbound_delays_help.html" onMouseOver="F_roll('NavigationButton8',1)" onMouseOut="F_roll('NavigationButton8',0)"><IMG ID="NavigationButton8" NAME="NavigationButton8" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/Inbound_Delay_Help_Np1_1.GIF" onLoad="F_loadRollover(this,'Inbound_Delay_Help_NRp2_1.GIF')" BORDER=0 ALT="Inbound Delay Help"></A></TD>
            <TD WIDTH=100 HEIGHT=20><A HREF="/cgi-bin/inbound_delays.cgi" onMouseOver="F_roll('NavigationButton9',1)" onMouseOut="F_roll('NavigationButton9',0)"><IMG ID="NavigationButton9" NAME="NavigationButton9" HEIGHT=20 WIDTH=100
               SRC="../assets/images/autogen/_Np1_89.GIF" onLoad="F_loadRollover(this,'_NRp2_88.GIF')" BORDER=0 ALT="Inbound Delays"></A></TD>
          </TR>
        </TABLE>
      </TD>
      <TD COLSPAN=2></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD COLSPAN=5 HEIGHT=12></TD>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
     <TD></TD>
      <TD COLSPAN=3 ALIGN=LEFT VALIGN=TOP WIDTH=600><IMG ID="SiteStyleLine2" HEIGHT=4 WIDTH=700 SRC="../assets/images/Line.gif" BORDER=0></TD>
    </TR>
   <TR VALIGN=TOP ALIGN=LEFT>
    </TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=4></TD>
<TD WIDTH=625>


EOF

}

sub page_footer {
print <<EOF;
      </TD>
    </TR>
  </TABLE>
  <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=724 NOF=LY>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD WIDTH=24><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=24 HEIGHT=1 BORDER=0></TD>
      <TD>
</TD>
</TR>
    <TR VALIGN=TOP ALIGN=LEFT>
      <TD HEIGHT=4></TD>
      <TD ALIGN=LEFT VALIGN=TOP WIDTH=700><BR><IMG ID="SiteStyleLine6" HEIGHT=4 WIDTH=700 SRC="../assets/images/Line.gif" BORDER=0></TD>
    </TR>
  </TABLE>
</BODY>
</HTML>
 
EOF
}
