#!/usr/bin/perl

#
# Script to activate and deactivate monitoring of rrd files.
# TODO: Remove from current_alarms when deactivating.
#

require "header.pl";
require "config.pl";
$config_area = $ttroot."/config/mcast";

`touch $config_area/alarms.conf`;
`touch $config_area/current_alarms`;

#
# Parse GET Strings
#
$buffer = "";
$buffer = $ENV{'QUERY_STRING'};

# Replace +-signs by spaces.
$_ = $buffer;
s/\+/ /g;
s/%3A/:/g;
s/%2F/\//g;
s/%2C/,/g;
s/%2B/+/g;
s/%40/@/g;
$buffer = $_;

@input_line = split (/&/, $buffer);

%fields = ();
foreach $entry (@input_line) {
  ($head, $tail) = split(/=/, $entry);
  $fields{$head} = $tail;
}

&page_header();

#
# Parse current config file
#
open(ALARMCONFIG, $config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
while(<ALARMCONFIG>) {
  chop ;
  if (substr ($_, 0, 1) eq "#") {
    # Ignore Comments
    next;
  } elsif (substr( $_, 0, 5 ) eq "email" ) {
    @line = split(/\s/, $_);
    $email = $line[1];
  } else {
    push @alarms, $_;
  }
}
close (ALARMCONFIG);

#
# See if we have to add or remove an alarm
#

if( $fields{'action'} eq "act" && defined($fields{'rrd'}) ) {
  $found = 0;
  $displayStr = &generate_displayStr($fields{'rrd'});
  foreach $alarm (@alarms) {
    if( $alarm eq $fields{'rrd'} ) {
      $found = 1;
    }
  }
  if( $found == 0 ) {
    push @alarms, $fields{'rrd'};
    print "<b>Operation successful, \"$displayStr\" is now being monitored.</b><br>";
  } else {
    print "<b>Error, \"$displayStr\" is already being monitored.</b><br>";
  }
} elsif( $fields{'action'} eq "deact" && defined($fields{'rrd'}) ) {
  for( $i = 0; $i < scalar(@alarms); $i++ ) {
    if( $alarms[$i] eq $fields{'rrd'} ) {
      splice @alarms, $i, 1;
      $displayStr = &generate_displayStr($fields{'rrd'});
      print "<b>Operation successful, \"$displayStr\" is not being monitored anymore.</b><br>";
    }
  }
}

#
#Save the alarm config file and print the list of alarms.
#

open (ALARMCONFIG, ">".$config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
print ALARMCONFIG "email $email\n";
print "<br><b>Alarm email:</b> $email<br><br><b>List of RRD files being monitored:</b><br>";
foreach $line (@alarms) {
  $displayStr = &generate_displayStr($line);
  print "$displayStr,&nbsp&nbsp&nbsp";
  print "<a href=\"activate_alarm.cgi?action=deact&rrd=$line\">Stop Monitoring</a>";
  print "<br>\n";
  print ALARMCONFIG "$line\n";
}

open (CURALARMS, $config_area."/current_alarms") or die("Error opening $config_area/current_alarms: $!\n");
print "<br><b>Current Alarms:</b><br>\n";
$noalarm = 1;
while( <CURALARMS> ) {
  $displayStr = &generate_displayStr($_);
  print "<font color=red>$displayStr</font><br>\n";
  $noalarm = 0;
}
if( $noalarm ==1 ) {
  print "<font color=green>There are no alarms, everything okay</font><br>\n";
}

&page_footer();

sub generate_displayStr {
  my($str) = @_;
  if( $str =~ /([a-z]+)\.(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\.(\d+)\.(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ ) {
     # A custom listener with port and a source
     $displayStr = "<i>Custom Listener:</i> Group: $2, Port: $3, Source: $4, Type: $1";
  } elsif( $str =~ /([a-z]+)\.(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\.(\d+)/ ) {
     # A custom listener without a source
     $displayStr = "<i>Custom Listener:</i> Group: $2, Port: $3, Type: $1";
  } elsif( $str =~ /([a-z]+)\.(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ ) {
     # A TTM listener
     $displayStr = "<i>TTM Listener:</i> Group: $2, Type: $1";
  } elsif( $str =~ /(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ ) {
     # A TTM listener, special case for the delay
     $displayStr = "<i>TTM Listener:</i> Group: $1, Type: delay";
  } else {
     $displayStr = $str;
  }
  return $displayStr;
}

