#!/usr/bin/perl

use Sys::Hostname;

require "header.pl";
require "config.pl";
$config_area = $ttroot."/config/mcast";
$data_area = "/data/mcast";


$testboxname = hostname;

`touch $config_area/alarms.conf`;
`touch $config_area/mcasts`;

# Parse Query String
$buffer = "";
$buffer = $ENV{'QUERY_STRING'};

#
# Replace +-signs by spaces.
#
$_ = $buffer;

s/\+/ /g;
s/%3A/:/g;
s/%2F/\//g;
s/%2C/,/g;
s/%2B/+/g;
s/%40/@/g;

$buffer = $_;

@input_line = split (/&/, $buffer);

%fields = ();
foreach $entry (@input_line) {
  ($head, $tail) = split(/=/, $entry);
  $fields{$head} = $tail;
}

#Check if configfile exists, if not create it with some mandatory values.
if( !(-e "$config_area/configfile") ) {
   open( CONFIGFILE, ">$config_area/configfile" );
   print CONFIGFILE "VER 1 1.0.0\n";
   print CONFIGFILE "PERI 2 43200 3600\n";
   close( CONFIGFILE );
}


open(ALARMCONFIG, $config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
while(<ALARMCONFIG>) {
  chop ;
  if (substr ($_, 0, 1) eq "#") {
    # Ignore Comments
    next;
  } elsif (substr( $_, 0, 5 ) eq "email" ) {
    @line = split(/\s/, $_);
    $email = $line[1];
  } else {
    push @alarms, $_;
  }
}
close (ALARMCONFIG);

if ($fields{'changed'} ne "true") {
  #Remove TTM Listener
  if(defined $fields{'deleteL'}) {
    open(MCASTCONFIG, $config_area."/mcasts") or die("Error opening $config_area/mcasts: $!\n");
    while(<MCASTCONFIG>) {
      push @listeners, $_;
    }
    close(MCASTCONFIG);
    open(MCASTCONFIG, ">".$config_area."/mcasts") or die("Error opening $config_area/mcasts: $!\n");
    foreach (@listeners) {
      @line = split(/_/, $fields{'deleteL'});
      # See if we have to delete this line
      $count = 0;
      if( index($_, $line[0]) >= 0 && index($_, $line[1]) >= 0  ) {
        #Yes, do nothing!
      } else {
        print MCASTCONFIG $_; # No, print it!
        $count++;
      }
    }
    close(MCASTCONFIG);
    # And restart the listener
    open( PID,"$data_area/pid_list/McastControlDaemon" );
    $pid = <PID>;
    close( PID );
    chomp $pid;
    `kill $pid`;
    `rm $data_area/pid_list/McastControlDaemon`;
    # Only restart it if we have at least one listener
    if( $count > 0 ) {
      `TTROOT=$ttroot $ttroot/bin/mc_runTTMListener`;
    }
 
  }
  #Remove TTM Beacon
  if(defined $fields{'deleteB'}) {
    open(MCASTBEACONCONFIG, $config_area."/configfile") or die("Error opening $config_area/configfile: $!\n");
    while(<MCASTBEACONCONFIG>) {
      push @beacons, $_;
    }
    close(MCASTBEACONCONFIG);
    open(MCASTBEACONCONFIG, ">".$config_area."/configfile") or die("Error opening $config_area/configfile: $!\n");
    foreach (@beacons) {
      @line = split(/_/, $fields{'deleteB'});
      # See if we have to delete this line
      if( index($_, $line[0]) >= 0 && index($_, $line[1]) >= 0  ) {
        #Do Nothing!
      } else {
        print MCASTBEACONCONFIG $_;
      }
    }
    close(MCASTBEACONCONFIG);
  }
}
else {
  #Save the new TTM Listener
  #if($fields{'newlip'} =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/ || $fields{'newlip'} =~ /^([0-9A-Fa-f]{0,4}:([0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})$/ &&
  #   $fields{'newlport'} =~ /^[0-9]*$/ && $fields{'newlport'} <= 65535) {
  #  open(MCASTCONFIG, ">>".$config_area."/mcasts") or die("Error opening $config_area/mcasts: $!\n");;
  #  print MCASTCONFIG "$fields{'newlip'} $fields{'newlport'}\n";
  #  close(MCASTCONFIG);
  #  # And restart the listener
  #  open( PID,"$data_area/pid_list/McastControlDaemon" );
  #  $pid = <PID>;
  #  close( PID );
  #  chomp $pid;
  #  `kill $pid`;
  #  `rm $data_area/pid_list/McastControlDaemon`;
  #  `TTROOT=$ttroot $ttroot/bin/mc_runTTMListener`;
  #} elsif ($fields{'newlip'} ne "" && $fields{'newlport'} ne "") {
  #  $message .= "IP or Port Number (Listener) incorrect.<br>\n";
  #}
  
  #Save new TTM Beacons
  if($fields{'newbip'} =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/ || $fields{'newbip'} =~ /^([0-9A-Fa-f]{0,4}:([0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})$/ &&
     $fields{'newbport'} =~ /^[0-9]*$/ && $fields{'newbport'} <= 65535 && $fields{'newbttl'} =~ /^[0-9]+$/ && $fields{'newbttl'} < 256 ) {
    open(MCASTBEACONCONFIG, ">>".$config_area."/configfile") or die("Error opening $config_area/configfile: $!\n");
    if($fields{'newbip'} =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/) {
      print MCASTBEACONCONFIG "MSND 9 $testboxname $fields{'newbip'} $fields{'newbport'} 100 0 120 1 0 $fields{'newbttl'}\n";
    } else {
      print MCASTBEACONCONFIG "MSN6 9 $testboxname $fields{'newbip'} $fields{'newbport'} 100 0 120 1 0 $fields{'newbttl'}\n";
    }
    close(MCASTBEACONCONFIG);
  } elsif ($fields{'newbip'} ne "" && $fields{'newbport'} ne "") {
    $message .= "IP or Port Number (Beacon) incorrect.<br>\n";
  }
  #Save the alarm config file.
  open (ALARMCONFIG, ">".$config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
  foreach $key (keys %fields) {
    if ($key eq "changed") {
      next;
    }
    elsif ($key eq "email") {
      $email = $fields{$key};
    }
  }
  print ALARMCONFIG "email $email\n";
  foreach $line (@alarms) {
    print ALARMCONFIG "$line\n";
  }

}   


&page_header();

# Print listing of Beacons and listeners
print <<EOF;
 <TABLE BORDER=0 CELLSPACING=5 CELLPADDING=0 WIDTH=625>
   <tr>
   <td colspan=3>
     <font face="Arial,Helvetica,Univers,Zurich BT,sans-serif"><b>TTM Beacons:</b></FONT>
   </td>
   </tr>
EOF
open(MCASTBEACONCONFIG, $config_area."/configfile") or die("Error opening $config_area/configfile: $!\n");
while(<MCASTBEACONCONFIG>) {
  if(substr($_,0,3) eq "MSN") {
    @line = split(/\s/, $_);
    print "<tr><td>$line[3]</td><td>$line[4]</td><td><a href=\"?deleteB=$line[3]_$line[4]\">Remove</a></td></tr>";a
  }
}
close(MCASTBEACONCONFIG);
#print <<EOF;
#   <tr>
#   <td colspan=3>
#     <font face="Arial,Helvetica,Univers,Zurich BT,sans-serif"><b>TTM Listeners:</b></FONT>
#   </td>
#   </tr>
#EOF
#open(MCASTCONFIG, $config_area."/mcasts") or die("Error opening $config_area/mcasts: $!\n");
#while(<MCASTCONFIG>) {
#  if(substr($_,0,1) ne "#") {
#   @line = split(/\s/, $_);
#   print "<tr><td>$line[0]</td><td>$line[1]</td><td><a href=\"?deleteL=$line[0]_$line[1]\">Remove</a></td></tr>";
#  }
#}
#close(MCASTCONFIG);
print <<EOF;
<table>
<br><br>
<font face="Arial,Helvetica,Univers,Zurich BT,sans-serif"><b>Add another Beacon:</b></FONT>
EOF
# Print Configuration Form
print <<EOF;
<FORM NAME="Inbound delays" ACTION="configure_alarms.cgi" METHOD="GET">
 <TABLE BORDER=0 CELLSPACING=5 CELLPADDING=0 WIDTH=625>
  <tr>
EOF
#  <td>
#    <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Add another Listener:</B></FONT>
#  </td>
#  <td>
#  print "Multicast IP: <input type=\"text\" name=\"newlip\"> <br>Port: <input type=\"text\" name=\"newlport\">";

print <<EOF;
  <td>
EOF
  print "Multicast IP:<br> <input type=\"text\" name=\"newbip\"> <br>Port:<br> <input type=\"text\" name=\"newbport\">";
  print "<br>TTL:<br> <input type=\"text\" value=\"128\" name=\"newbttl\">";


print <<EOF;
  </td>
  </tr>
    </table>
  <BR>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Email Alarms to: </B></FONT><br> <INPUT TYPE="text" NAME="email" VALUE="$email" />
  <INPUT TYPE="hidden" NAME="changed" VALUE="true" /><br><br>
  <INPUT TYPE="submit" value="Submit"/>
</FORM>

<FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif" COLOR=RED>$message
</FONT>
EOF


&page_footer();


