#!/usr/bin/perl

use Socket;
use Socket6;

use vars qw(@input_line);
use vars qw($i $j $buffer $entry $count $head $tail $filename $plotname);
use vars qw(%fields);
use vars qw($MAXBOXES);
use vars qw($temp $flag);
use vars qw($plotstring);
use vars qw(%location);

my($data_area);
my($config_area);

$MAXBOXES = 200;
require "config.pl";
require "header.pl";
$data_area = "/data/mcast";
$config_area =  $ttroot."/config/mcast";

&page_header;

# Parse Query String
$buffer = "";
$buffer = $ENV{'QUERY_STRING'};

#
# Replace +-signs by spaces.
#
$_ = $buffer;

s/\+/ /g;
s/%3A/:/g;
s/%2F/\//g;
s/%2C/,/g;
s/%2B/+/g;
s/%40/@/g;

$buffer = $_;

@input_line = split (/&/, $buffer);

%fields = ();
foreach $entry (@input_line) {
  ($head, $tail) = split(/=/, $entry);
  $fields{$head} = $tail;
}

#
# Build table with possible options
# 
print <<EOF;
<FORM NAME="Inbound delays" ACTION="multiple.cgi" METHOD="GET">
 <TABLE BORDER=0 CELLSPACING=5 CELLPADDING=0 WIDTH=625>
  <TR>
  <TD COLSPAN=1>
   <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Select Multicast Membership(s):</B>
  </TD>
  <TD COLSPAN=2>
   <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <B> <INPUT TYPE="checkbox" name="all" value="all">All Memberships</B></FONT>
  </TD>
 </TR>
 <TR>
EOF
$j = 0;
open(LOT,"$config_area/mcasts") || die "Couldn't read Multicast Config File: $!";
while (defined(my $input = <LOT> )) {
  # Ignore comments
  if ($input =~/#.*/) {
     next;
  }
 
  my (@input);
  my ($tb, $tb_real, $tbip,$hostname,$rrdfile,$tb6,$tbip6,$hostname6,$rrdfile6);
  chomp($input);

  @input = split(/\s/,$input);

  ($hostname) = $input[0] if $input[0] =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/; 
  ($hostname6) = $input[0] if $input[0] =~ /^([0-9A-Fa-f]{0,4}:([0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})$/; 

  if (defined $hostname) {
    $rrdfile = $data_area."/rrd/".$hostname.".rrd"; 
    #if ((-e $rrdfile) && ((-M $rrdfile) < 8.0)) {# Should be added as soon as delay measurement are implemented

      print "<TD WIDTH=225><INPUT TYPE=\"checkbox\" NAME=\"$hostname\" VALUE=\"$hostname\"";
      if ((exists($fields{$hostname}) && $fields{$hostname} ne "") 
        ||(exists($fields{"all"}) && $fields{"all"} ne "")) { print " CHECKED"; $fields{$hostname} = $hostname; } 

      print "><FONT FACE=\"Arial,Helvetica,Univers,Zurich BT,sans-serif\">",
       "<B>$hostname</B></FONT></TD>\n";
      $j++;
      if ($j == 3) {
        printf "</TR><TR>\n";
        $j = 0;
      }
    #}
  }
  if (defined $hostname6) {
    $rrdfile6 = $data_area6."/rrd/".$hostname6.".rrd"; 
    #if ((-e $rrdfile6) && ((-M $rrdfile6) < 8.0)) { # Should be added as soon as delay measurement are implemented

      print "<TD WIDTH=225><INPUT TYPE=\"checkbox\" NAME=\"$hostname6\" VALUE=\"$hostname6\"";
      if ((exists($fields{$hostname6}) && $fields{$hostname6} ne "") 
       || (exists($fields{"all"}) && $fields{"all"} ne "")) { print " CHECKED"; $fields{$hostname6} = $hostname6; }
      print "><FONT FACE=\"Arial,Helvetica,Univers,Zurich BT,sans-serif\">",
       "<B>$hostname</B> (IPv6)</FONT></TD>\n";
      $j++;
      if ($j == 3) {
        printf "</TR><TR>\n";
        $j = 0;
      }
    #}
  }
}
close(LOT);


$j = 0;

my $input;
my %done;
%done = ();

opendir (DATADIR, $data_area."/rrd/cust/") || die "Cannot open $data_area";
foreach $input (sort readdir (DATADIR)) {
  my ($tb, $tb_real, $tbip,$hostname,$hostnice,$rrdfile,$tb6,$tbip6,$hostname6,$hostnice6,$rrdfile6);

  # Match something like delay.224.0.10.17.6001.rrd
  if ($input =~ /^.{3,7}\.(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\.(\d{1,6})\.rrd$/) {
    $hostnice = $1." : ".$2; # This is used for display
    $hostname = $1.".".$2; # This is used to grab files and reference this listener, same below with IPv6
  } elsif ($input =~ /^.{3,7}\.([0-9A-Fa-f]{0,4}:(?:[0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})\.(\d{1,6})\.rrd$/) {
    $hostnice = $1." : ".$2;
    $hostname = $1.".".$2;
  } elsif ($input =~ /^.{3,7}\.(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\.(\d{1,6})\.(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\.rrd$/) {
    $hostnice = $1." : ".$2." from ".$3;
    $hostname = $1.".".$2.".".$3;
  } elsif ($input =~ /^.{3,7}\.([0-9A-Fa-f]{0,4}:(?:[0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})\.(\d{1,6})\.([0-9A-Fa-f]{0,4}:(?:[0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})\.rrd$/) {
    $hostnice = $1." : ".$2." from ".$3;
    $hostname = $1.".".$2.".".$3;
  } else {
    next;
  }

  # Check if we already had that IP...
  if(exists($done{$hostname})) {
    next;
  } else {
    $done{$hostname} = 1;
  }



  if (defined $hostname) {
    $rrdfile = $data_area."/rrd/".$hostname.".rrd"; 
    #if ((-e $rrdfile) && ((-M $rrdfile) < 8.0)) {# Should be added as soon as delay measurement are implemented

      print "<TD WIDTH=225><INPUT TYPE=\"checkbox\" NAME=\"$hostname\" VALUE=\"$hostname\"";
      if ((exists($fields{$hostname}) && $fields{$hostname} ne "") 
        ||(exists($fields{"all"}) && $fields{"all"} ne "")) { print " CHECKED"; $fields{$hostname} = $hostname; } 

      print "><FONT FACE=\"Arial,Helvetica,Univers,Zurich BT,sans-serif\">",
       "<B>$hostnice (Custom Listener)</B></FONT></TD>\n";
      $j++;
      if ($j == 3) {
        printf "</TR><TR>\n";
        $j = 0;
      }
    #}
  }
  if (defined $hostname6) {
    $rrdfile6 = $data_area6."/rrd/".$hostname6.".rrd"; 
    #if ((-e $rrdfile6) && ((-M $rrdfile6) < 8.0)) { # Should be added as soon as delay measurement are implemented

      print "<TD WIDTH=225><INPUT TYPE=\"checkbox\" NAME=\"$hostname6\" VALUE=\"$hostname6\"";
      if ((exists($fields{$hostname6}) && $fields{$hostname6} ne "") 
       || (exists($fields{"all"}) && $fields{"all"} ne "")) { print " CHECKED"; $fields{$hostname6} = $hostname6; }
      print "><FONT FACE=\"Arial,Helvetica,Univers,Zurich BT,sans-serif\">",
       "<B>$hostnice6 (Custom Listener)</B> (IPv6)</FONT></TD>\n";
      $j++;
      if ($j == 3) {
        printf "</TR><TR>\n";
        $j = 0;
      }
    #}
  }
}
close(LOT);


print <<EOF2;
</TR></TABLE>

<TABLE>

<TR>
 <TD><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Delays:</TD>
 <TD><INPUT TYPE="checkbox" name="delay" value="delay"
EOF2

if ($fields{"delay"} ne "") {print "CHECKED";}

print <<EOF10;
></TD>
</TR><TR>
<TD><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Losses:</TD>
<TD><INPUT TYPE="checkbox" name="loss" value="loss"
EOF10

if ($fields{"loss"} ne "") {print "CHECKED";}


print <<EOF11;
></TD>
</TR>
<TR>
<TD><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Rate(Custom):</TD>
<TD><INPUT TYPE="checkbox" name="rate" value="rate"
EOF11

if ($fields{"rate"} ne "") {print "CHECKED";}


print <<EOF11;
></TD>
</TR>
<TR>
<TD><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Packet Size (Custom):</TD>
<TD><INPUT TYPE="checkbox" name="psize" value="psize"
EOF11

if ($fields{"psize"} ne "") {print "CHECKED";}


print <<EOF11;
></TD>
</TR>
<TR>
 <TD><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Defined Values (Custom):</TD>
 <TD><INPUT TYPE="checkbox" name="dval" value="dval"
EOF11

if ($fields{"dval"} ne "") {print "CHECKED";}


print <<EOF11;
></TD>
</TR>


 <TR>
  <TD>
   <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Start:</B></FONT>
  </TD>
  <TD ALIGN="LEFT"><INPUT ID="Forms Edit Field1" TYPE=TEXT NAME="RRD_START" VALUE="
EOF11


$_ = $fields{"RRD_START"};
s/\+/ /g;
s/%3A/:/g;
s/%20/ /g;
$fields{"RRD_START"} = "\"".$_."\"";

if ($_ ne "") {
  print $_;
} else {
  print "now-1week";
}
  

print <<EOF3;
" SIZE=16 MAXLENGTH=40>
 </TD>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Length: </B></FONT>
 </TD>
 <TD ALIGN="LEFT">
  <SELECT ID="FormsComboBox4" NAME="RRD_END">
EOF3

if ($fields{"RRD_END"} ne "") {
  print "<OPTION VALUE=\"", $fields{"RRD_END"}, "\">", $fields{"RRD_END"}, "</OPTION>\n";}

print <<EOF4;
   <OPTION VALUE="start+1week">1 week</OPTION>
   <OPTION VALUE="start+4days">4 days</OPTION>
   <OPTION VALUE="start+2days">2 days</OPTION>
   <OPTION VALUE="start+1day">1 day</OPTION>
   <OPTION VALUE="start+12h">12 hours</OPTION>
   <OPTION VALUE="start+6h">6 hours</OPTION>
   <OPTION VALUE="start+4h">4 hours</OPTION>
   <OPTION VALUE="start+2h">2 hours</OPTION>
   <OPTION VALUE="start+1h">1 hour</OPTION>
   <OPTION VALUE="start+1800s">30 minutes</OPTION>
   <OPTION VALUE="start+900s">15 minutes</OPTION>
  </SELECT>
 </TD>
</TR>
<TR>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Height:</B></FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <SELECT ID="FormsComboBox3" NAME="RRD_W">
EOF4

if ($fields{"RRD_W"} ne "") {
  print "<OPTION VALUE=\"", $fields{"RRD_W"}, "\">";
  if    ($fields{"RRD_W"} eq "-h100") {print "small";}
  elsif ($fields{"RRD_W"} eq "-h200") {print "medium";}
  else                                {print "high";  }
  print "</OPTION>\n";
}

print <<EOF5;
    <OPTION VALUE="-h100">small</OPTION>
    <OPTION VALUE="-h200">medium</OPTION>
    <OPTION VALUE="-h300">high</OPTION>
   </SELECT>
  </FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Width: </B></FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <SELECT ID="FormsComboBox5" NAME="RRD_H">
EOF5

if ($fields{"RRD_H"} ne "") {
  print "<OPTION VALUE=\"", $fields{"RRD_H"}, "\">";
  if    ($fields{"RRD_H"} eq "-w350") {print "narrow";}
  elsif ($fields{"RRD_H"} eq "-w600") {print "medium";}
  else                                {print "wide";  }
  print "</OPTION>\n";
}

print <<EOF6;
    <OPTION VALUE="-w350">narrow</OPTION>
    <OPTION VALUE="-w600">medium</OPTION>
    <OPTION VALUE="-w800">wide</OPTION>
   </SELECT>
  </FONT>
 </TD>
</TR>
<TR>
 <TD>
  <P><FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B>Y-range delay: </B></FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <INPUT ID="RRD_L" TYPE=TEXT NAME="RRD_L" VALUE="
EOF6

if ($fields{"RRD_L"} eq "")  {
  print "0"; 
} else {
  print $fields{"RRD_L"};
}

print <<EOF7;
" SIZE=16 MAXLENGTH=40></TD>
  </FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B> to </B></FONT>
 </TD>
 <TD>
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif">
   <INPUT ID="FormsEditField3" TYPE=TEXT NAME="RRD_R" VALUE="
EOF7

if ($fields{"RRD_R"} eq "")  {
  print "1"; 
} else {
  print $fields{"RRD_R"};
}

print <<EOF8;
" SIZE=16 MAXLENGTH=40>
  </FONT>
 </TD>
 <TD>
  <SELECT ID="FormsComboBox6" NAME="RRD_RIGID">
EOF8

if ($fields{"RRD_RIGID"} eq "--rigid" ) {
  print "<OPTION VALUE=\"rigid\">fixed</OPTION>";
  print "<OPTION VALUE=\"-l0\">auto-increment</OPTION>";
} else {
  print "<OPTION VALUE=\"-l0\">auto-increment</OPTION>";
  print "<OPTION VALUE=\"--rigid\">fixed</OPTION>";
}

print <<EOF9;
  </SELECT>
 </TD>
</TR>
<TR>
 <TD> 
  <FONT FACE="Arial,Helvetica,Univers,Zurich BT,sans-serif"><B> Loss plots: 
   </B></FONT>
 </TD>
EOF9

if ($fields{"LFORMAT"} eq "LOSS")  {
 print <<EOF98;
 <TD>
  <INPUT TYPE="RADIO" NAME="LFORMAT" VALUE="LOSS" CHECKED>Loss Only
 </TD>
 <TD></TD>
 <TD>
  <INPUT TYPE="RADIO" NAME="LFORMAT" VALUE="BOTH">Loss and Arrived
 </TD>
EOF98
} else {
 print <<EOF99;
 <TD>
  <INPUT TYPE="RADIO" NAME="LFORMAT" VALUE="LOSS">Loss Only
 </TD>
 <TD></TD>
 <TD>
  <INPUT TYPE="RADIO" NAME="LFORMAT" VALUE="BOTH" CHECKED>Loss and Arrived
 </TD>
EOF99
}


print <<EOF10;
</TR>

<TR>
 <TD>
  <INPUT TYPE=SUBMIT NAME="Draw" VALUE="Draw" ID="FormsButton3">
 </TD>
</TR>

</TABLE>

        </FORM>

<TABLE>
EOF10



$flag = 0;

foreach $entry (sort keys %fields) {
  if( $entry =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/ || $entry =~ /^([0-9A-Fa-f]{0,4}:([0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})$/ ) {
    s/%3A/:/g;
    `ln -sf $data_area/rrd/$fields{$entry}.rrd $data_area/rrd/delay.rrd`;
    `ln -sf $data_area/rrd/loss.$fields{$entry}.rrd $data_area/data/rrd/loss.rrd`;
    if ($fields{"delay"} ne "") {
      $plotname = "/gif/delay.".$fields{$entry}.".".time.".gif";
      $filename = " ".$ttroot."/apache/htdocs".$plotname;
      $plotstring = $rrdtool." graph ";
      $plotstring = $plotstring.$filename;
      $plotstring = $plotstring." --title=\"delay from ".$entry." on ".`date`."\" ";
      $plotstring = $plotstring." ".$fields{"RRD_W"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_H"}." ";
      $plotstring = $plotstring." -l".$fields{"RRD_L"}." ";
      $plotstring = $plotstring." -u".$fields{"RRD_R"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_RIGID"}." ";
      $plotstring = $plotstring." -e".$fields{"RRD_END"}." ";
      $plotstring = $plotstring." -s".$fields{"RRD_START"}." ";
      $plotstring = $plotstring." -v\"Delay [ms]\"";
      $plotstring = $plotstring." -c CANVAS#E0E0E0";
      $plotstring = $plotstring." DEF:val1=".$data_area."/rrd/delay.rrd:delay:MAX";
      $plotstring = $plotstring." DEF:val2=".$data_area."/rrd/delay.rrd:delay:AVERAGE";
      $plotstring = $plotstring." DEF:val3=".$data_area."/rrd/delay.rrd:delay:MIN";
      $plotstring = $plotstring." AREA:val1#FF8800:\"Spread: \""; 
      $plotstring = $plotstring." GPRINT:val3:MIN:\"%.2lf ... \"";
      $plotstring = $plotstring." GPRINT:val1:MAX:\"%.2lf ms \"";
      $plotstring = $plotstring." LINE2:val2#0000FF:\"Average Delay:\"";
      $plotstring = $plotstring." AREA:val3#E0E0E0";
      $plotstring = $plotstring." GPRINT:val2:AVERAGE:\"%.2lf ms\"";
      `$plotstring`;

      print "<TD><b>Delay ($fields{$entry})</b><br>";
      my $found = 0;
      open(ALARMCONFIG, $config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
      while(<ALARMCONFIG>) {
        chop $_;
        if( $_ eq $fields{$entry} ) {
          $found = 1;
          last;
        }
      }
      if( $found == 0 ) {
        print "<a href=\"activate_alarm.cgi?action=act&rrd=$fields{$entry}\">Activate Alarm for this RRD</a><br>";
      } else {
        print "<a href=\"activate_alarm.cgi?action=deact&rrd=$fields{$entry}\">Deactivate Alarm for this RRD</a><br>";
      }
      print "<IMG SRC=".$plotname."></TD>";

    }

    if ($fields{"loss"} ne "") {
      $plotname = "/gif/loss.".$fields{$entry}.".".time.".gif";
      $filename = " ".$ttroot."/apache/htdocs".$plotname;
      $plotstring = $rrdtool." graph ";
      $plotstring = $plotstring.$filename;
      $plotstring = $plotstring." --title=\"loss from ".$entry." on ".`date`."\" ";
      $plotstring = $plotstring." ".$fields{"RRD_W"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_H"}." ";
      $plotstring = $plotstring." -l0.00";
      $plotstring = $plotstring." -e".$fields{"RRD_END"}." ";
      $plotstring = $plotstring." -s".$fields{"RRD_START"}." ";
      $plotstring = $plotstring." -v\"Percentage of packets\"";
      $plotstring = $plotstring." -c CANVAS#E0E0E0";
      $plotstring = $plotstring." DEF:val1=".$data_area."/rrd/loss.rrd:loss:AVERAGE";
      $plotstring = $plotstring." CDEF:val3=100,val1,*";
      $plotstring = $plotstring." CDEF:val2=100,val3,-";
      $plotstring = $plotstring." AREA:val2#FF0000:\"Lost: \"";
      $plotstring = $plotstring." GPRINT:val2:AVERAGE:\"%.2lf %% \"";

      if ($fields{"LFORMAT"} ne "LOSS") {
        $plotstring = $plotstring." -u105"; 
        $plotstring = $plotstring." --rigid";
        $plotstring = $plotstring." STACK:val3#00CC00:\"Arrived: \""; 
        $plotstring = $plotstring." GPRINT:val3:AVERAGE:\"%.2lf %% ... \"";
      } else {
        $plotstring = $plotstring." -u1.0"; 
      }
      `$plotstring`;

      print "</tr><tr><TD><b>Loss ($fields{$entry})</b><br>";
      my $found = 0;
      open(ALARMCONFIG, $config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
      while(<ALARMCONFIG>) {
        chop $_;
        if( $_ eq "loss.".$fields{$entry} ) {
          $found = 1;
          last;
        }
      }
      if( $found == 0 ) {
        print "<a href=\"activate_alarm.cgi?action=act&rrd=loss.$fields{$entry}\">Activate Alarm for this RRD</a><br>";
      } else {
        print "<a href=\"activate_alarm.cgi?action=deact&rrd=loss.$fields{$entry}\">Deactivate Alarm for this RRD</a><br>";
      }

      print "<IMG SRC=".$plotname."></TD>";
    }
    print "</TR>\n";
  }elsif( $entry =~ /^(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\.(\d{1,7})$/ || 
          $entry =~ /^([0-9A-Fa-f]{0,4}:([0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})\.(\d{1,6})$/ ||
          $entry =~ /^(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\.(\d{1,5})\.(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})$/ || 
          $entry =~ /^([0-9A-Fa-f]{0,4}:(?:[0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})\.\d{1,5}\.([0-9A-Fa-f]{0,4}:(?:[0-9A-Fa-f]{0,4}:){1,6}[0-9A-Fa-f]{1,4})$/) {
    my $disp = "";
    if( defined($3) ) {
      $disp = $1." : ".$2." from ".$3;
    } else {
      $disp = $1." : ".$2;
    }
    
    s/%3A/:/g;
    `ln -sf $data_area/rrd/cust/delay.$fields{$entry}.rrd $data_area/rrd/cust/delay.rrd`;
    `ln -sf $data_area/rrd/cust/loss.$fields{$entry}.rrd $data_area/rrd/cust/loss.rrd`;
    `ln -sf $data_area/rrd/cust/dval.$fields{$entry}.rrd $data_area/rrd/cust/dval.rrd`;
    `ln -sf $data_area/rrd/cust/psize.$fields{$entry}.rrd $data_area/rrd/cust/psize.rrd`;
    `ln -sf $data_area/rrd/cust/rate.$fields{$entry}.rrd $data_area/rrd/cust/rate.rrd`;

    print "<TR>";
    if ($fields{"delay"} ne "" && -e $data_area."/rrd/cust/delay.".$fields{$entry}.".rrd") {
      print "<br><b>Delay ($disp)</b><br>\n";
      my $found = 0;
      open(ALARMCONFIG, $config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
      while(<ALARMCONFIG>) {
        chop $_;
        if( $_ eq "delay.".$fields{$entry} ) {
          $found = 1;
          last;
        }
      }
      if( $found == 0 ) {
        print "<a href=\"activate_alarm.cgi?action=act&rrd=delay.$fields{$entry}\">Activate Alarm for this RRD</a><br>";
      } else {
        print "<a href=\"activate_alarm.cgi?action=deact&rrd=delay.$fields{$entry}\">Deactivate Alarm for this RRD</a><br>";
      }

      $plotname = "/gif/delay.".$fields{$entry}.".".time.".gif";
      $filename = " ".$ttroot."/apache/htdocs".$plotname;
      $plotstring = $rrdtool." graph ";
      $plotstring = $plotstring.$filename;
      $plotstring = $plotstring." --title=\"from ".$entry." on ".`date`."\" ";
      $plotstring = $plotstring." ".$fields{"RRD_W"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_H"}." ";
      $plotstring = $plotstring." -l".$fields{"RRD_L"}." ";
      $plotstring = $plotstring." -u".$fields{"RRD_R"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_RIGID"}." ";
      $plotstring = $plotstring." -e".$fields{"RRD_END"}." ";
      $plotstring = $plotstring." -s".$fields{"RRD_START"}." ";
      $plotstring = $plotstring." -v\"Delay [ms]\"";
      $plotstring = $plotstring." -c CANVAS#E0E0E0";
      $plotstring = $plotstring." DEF:val1=".$data_area."/rrd/cust/delay.rrd:delay:MAX";
      $plotstring = $plotstring." DEF:val2=".$data_area."/rrd/cust/delay.rrd:delay:AVERAGE";
      $plotstring = $plotstring." DEF:val3=".$data_area."/rrd/cust/delay.rrd:delay:MIN";
      $plotstring = $plotstring." AREA:val1#FF8800:\"Spread: \""; 
      $plotstring = $plotstring." GPRINT:val3:MIN:\"%.2lf ... \"";
      $plotstring = $plotstring." GPRINT:val1:MAX:\"%.2lf ms \"";
      $plotstring = $plotstring." LINE2:val2#0000FF:\"Average Delay:\"";
      $plotstring = $plotstring." AREA:val3#E0E0E0";
      $plotstring = $plotstring." GPRINT:val2:AVERAGE:\"%.2lf ms\"";
      `$plotstring`;
      print "<IMG SRC=".$plotname.">";
    } 
    elsif($fields{"delay"} ne "" && !(-e $data_area."/rrd/cust/delay.".$fields{$entry}.".rrd")) 
    {
      print "<br><b>Delay ($disp)</b><br>\n";
      print "No delay data available.<br>\n";
    }

    if ($fields{"loss"} ne "" && -e $data_area."/rrd/cust/loss.".$fields{$entry}.".rrd") {
      print "<br><b>Loss ($disp)</b><br>\n";
      my $found = 0;
      open(ALARMCONFIG, $config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
      while(<ALARMCONFIG>) {
        chop $_;
        if( $_ eq "loss.".$fields{$entry} ) {
          $found = 1;
          last;
        }
      }
      if( $found == 0 ) {
        print "<a href=\"activate_alarm.cgi?action=act&rrd=loss.$fields{$entry}\">Activate Alarm for this RRD</a><br>";
      } else {
        print "<a href=\"activate_alarm.cgi?action=deact&rrd=loss.$fields{$entry}\">Deactivate Alarm for this RRD</a><br>";
      }

      $plotname = "/gif/loss.".$fields{$entry}.".".time.".gif";
      $filename = " ".$ttroot."/apache/htdocs".$plotname;
      $plotstring = $rrdtool." graph ";
      $plotstring = $plotstring.$filename;
      $plotstring = $plotstring." --title=\"from ".$entry." on ".`date`."\" ";
      $plotstring = $plotstring." ".$fields{"RRD_W"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_H"}." ";
      $plotstring = $plotstring." -l0.00";
      $plotstring = $plotstring." -e".$fields{"RRD_END"}." ";

      $plotstring = $plotstring." -s".$fields{"RRD_START"}." ";
      $plotstring = $plotstring." -v\"Percentage of packets\"";
      $plotstring = $plotstring." -c CANVAS#E0E0E0";
      $plotstring = $plotstring." DEF:val1=".$data_area."/rrd/cust/loss.rrd:loss:AVERAGE";
      $plotstring = $plotstring." CDEF:val3=100,val1,*";
      $plotstring = $plotstring." CDEF:val2=100,val3,-";
      $plotstring = $plotstring." AREA:val2#FF0000:\"Lost: \"";
      $plotstring = $plotstring." GPRINT:val2:AVERAGE:\"%.2lf %% \"";

      if ($fields{"LFORMAT"} ne "LOSS") {
        $plotstring = $plotstring." -u105"; 
        $plotstring = $plotstring." --rigid";
        $plotstring = $plotstring." STACK:val3#00CC00:\"Arrived: \""; 
        $plotstring = $plotstring." GPRINT:val3:AVERAGE:\"%.2lf %% ... \"";
      } else {
        $plotstring = $plotstring." -u1.0"; 
      }
      `$plotstring`;
      print "<IMG SRC=".$plotname.">";
    }
    elsif ($fields{"loss"} ne "" && !(-e $data_area."/rrd/cust/loss.".$fields{$entry}.".rrd"))
    {
      print "<br><b>Loss ($disp)</b><br>\n";
      print "No loss data available.<br>\n";
    }

    if ($fields{"rate"} ne "" && -e $data_area."/rrd/cust/rate.".$fields{$entry}.".rrd") {
      print "<br><b>Rate/Minute ($disp)</b><br>\n";
      my $found = 0;
      open(ALARMCONFIG, $config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
      while(<ALARMCONFIG>) {
        chop $_;
        if( $_ eq "rate.".$fields{$entry} ) {
          $found = 1;
          last;
        }
      }
      if( $found == 0 ) {
        print "<a href=\"activate_alarm.cgi?action=act&rrd=rate.$fields{$entry}\">Activate Alarm for this RRD</a><br>";
      } else {
        print "<a href=\"activate_alarm.cgi?action=deact&rrd=rate.$fields{$entry}\">Deactivate Alarm for this RRD</a><br>";
      }

      $plotname = "/gif/rate.".$fields{$entry}.".".time.".gif";
      $filename = " ".$ttroot."/apache/htdocs".$plotname;
      $plotstring = $rrdtool." graph ";
      $plotstring = $plotstring.$filename;
      $plotstring = $plotstring." --title=\"from ".$entry." on ".`date`."\" ";
      $plotstring = $plotstring." ".$fields{"RRD_W"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_H"}." ";
      $plotstring = $plotstring." -l".$fields{"RRD_L"}." ";
      $plotstring = $plotstring." -u".$fields{"RRD_R"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_RIGID"}." ";
      $plotstring = $plotstring." -e".$fields{"RRD_END"}." ";
      $plotstring = $plotstring." -s".$fields{"RRD_START"}." ";
      $plotstring = $plotstring." -v\"Number of packets\"";
      $plotstring = $plotstring." -c CANVAS#E0E0E0";
      $plotstring = $plotstring." DEF:val1=".$data_area."/rrd/cust/rate.rrd:delay:MAX";
      $plotstring = $plotstring." DEF:val2=".$data_area."/rrd/cust/rate.rrd:delay:AVERAGE";
      $plotstring = $plotstring." DEF:val3=".$data_area."/rrd/cust/rate.rrd:delay:MIN";
      $plotstring = $plotstring." AREA:val1#FF8800:\"Spread: \""; 
      $plotstring = $plotstring." GPRINT:val3:MIN:\"%.2lf ... \"";
      $plotstring = $plotstring." GPRINT:val1:MAX:\"%.2lf packets \"";
      $plotstring = $plotstring." LINE2:val2#0000FF:\"Average:\"";
      $plotstring = $plotstring." AREA:val3#E0E0E0";
      $plotstring = $plotstring." GPRINT:val2:AVERAGE:\"%.2lf packets\"";
      `$plotstring`;
      print "<IMG SRC=".$plotname.">";
    } 
    elsif ($fields{"rate"} ne "" && !(-e $data_area."/rrd/cust/rate.".$fields{$entry}.".rrd"))
    {
      print "<br><b>Rate ($disp)</b><br>\n";
      print "No rate data available.<br>\n";
    }

    if ($fields{"psize"} ne "" && -e $data_area."/rrd/cust/psize.".$fields{$entry}.".rrd") {
      print "<br><b>Packet Size ($disp)</b><br>\n";
      my $found = 0;
      open(ALARMCONFIG, $config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
      while(<ALARMCONFIG>) {
        chop $_;
        if( $_ eq "psize.".$fields{$entry} ) {
          $found = 1;
          last;
        }
      }
      if( $found == 0 ) {
        print "<a href=\"activate_alarm.cgi?action=act&rrd=psize.$fields{$entry}\">Activate Alarm for this RRD</a><br>";
      } else {
        print "<a href=\"activate_alarm.cgi?action=deact&rrd=psize.$fields{$entry}\">Deactivate Alarm for this RRD</a><br>";
      }

      $plotname = "/gif/psize.".$fields{$entry}.".".time.".gif";
      $filename = " ".$ttroot."/apache/htdocs".$plotname;
      $plotstring = $rrdtool." graph ";
      $plotstring = $plotstring.$filename;
      $plotstring = $plotstring." --title=\"from ".$entry." on ".`date`."\" ";
      $plotstring = $plotstring." ".$fields{"RRD_W"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_H"}." ";
      $plotstring = $plotstring." -l".$fields{"RRD_L"}." ";
      $plotstring = $plotstring." -u".$fields{"RRD_R"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_RIGID"}." ";
      $plotstring = $plotstring." -e".$fields{"RRD_END"}." ";
      $plotstring = $plotstring." -s".$fields{"RRD_START"}." ";
      $plotstring = $plotstring." -v\"Packetsize [bytes]\"";
      $plotstring = $plotstring." -c CANVAS#E0E0E0";
      $plotstring = $plotstring." DEF:val1=".$data_area."/rrd/cust/psize.rrd:delay:MAX";
      $plotstring = $plotstring." DEF:val2=".$data_area."/rrd/cust/psize.rrd:delay:AVERAGE";
      $plotstring = $plotstring." DEF:val3=".$data_area."/rrd/cust/psize.rrd:delay:MIN";
      $plotstring = $plotstring." AREA:val1#FF8800:\"Spread: \""; 
      $plotstring = $plotstring." GPRINT:val3:MIN:\"%.2lf ... \"";
      $plotstring = $plotstring." GPRINT:val1:MAX:\"%.2lf bytes \"";
      $plotstring = $plotstring." LINE2:val2#0000FF:\"Average:\"";
      $plotstring = $plotstring." AREA:val3#E0E0E0";
      $plotstring = $plotstring." GPRINT:val2:AVERAGE:\"%.2lf bytes\"";
      `$plotstring`;
      print "<IMG SRC=".$plotname.">";
    } 
    elsif ($fields{"psize"} ne "" && !(-e $data_area."/rrd/cust/loss.".$fields{$entry}.".rrd"))
    {
      print "<br><b>Packet Size ($disp)</b><br>\n";
      print "No packet size data available.<br>\n";
    }

    if ($fields{"dval"} ne "" && -e $data_area."/rrd/cust/dval.".$fields{$entry}.".rrd") {
      print "<br><b>Defined value pass percentage ($disp)</b><br>\n";
      my $found = 0;
      open(ALARMCONFIG, $config_area."/alarms.conf") or die("Error opening $config_area/alarms.conf: $!\n");
      while(<ALARMCONFIG>) {
        chop $_;
        if( $_ eq "dval.".$fields{$entry} ) {
          $found = 1;
          last;
        }
      }
      if( $found == 0 ) {
        print "<a href=\"activate_alarm.cgi?action=act&rrd=dval.$fields{$entry}\">Activate Alarm for this RRD</a><br>";
      } else {
        print "<a href=\"activate_alarm.cgi?action=deact&rrd=dval.$fields{$entry}\">Deactivate Alarm for this RRD</a><br>";
      }

      $plotname = "/gif/dval.".$fields{$entry}.".".time.".gif";
      $filename = " ".$ttroot."/apache/htdocs".$plotname;
      $plotstring = $rrdtool." graph ";
      $plotstring = $plotstring.$filename;
      $plotstring = $plotstring." --title=\"from ".$entry." on ".`date`."\" ";
      $plotstring = $plotstring." ".$fields{"RRD_W"}." ";
      $plotstring = $plotstring." ".$fields{"RRD_H"}." ";
      $plotstring = $plotstring." -l0.00";
      $plotstring = $plotstring." -e".$fields{"RRD_END"}." ";
      $plotstring = $plotstring." -s".$fields{"RRD_START"}." ";
      $plotstring = $plotstring." -v\"Percentage of packets\"";
      $plotstring = $plotstring." -c CANVAS#E0E0E0";
      $plotstring = $plotstring." DEF:val1=".$data_area."/rrd/cust/dval.rrd:loss:AVERAGE";
      $plotstring = $plotstring." CDEF:val3=100,val1,*";
      $plotstring = $plotstring." CDEF:val2=100,val3,-";
      $plotstring = $plotstring." AREA:val2#FF0000:\"Failed: \"";
      $plotstring = $plotstring." GPRINT:val2:AVERAGE:\"%.2lf %% \"";

      if ($fields{"LFORMAT"} ne "LOSS") {
        $plotstring = $plotstring." -u105";
        $plotstring = $plotstring." --rigid";
        $plotstring = $plotstring." STACK:val3#00CC00:\"Passed: \"";
        $plotstring = $plotstring." GPRINT:val3:AVERAGE:\"%.2lf %% ... \"";
      } else {
        $plotstring = $plotstring." -u1.0";
      }
      `$plotstring`;
      print "<IMG SRC=".$plotname.">";
    }elsif($fields{"dval"} ne "" && !(-e $data_area."/rrd/cust/dval.".$fields{$entry}.".rrd")) 
    {
      print "<br><b>Defined value pass percentage ($disp)</b><br>\n";
      print "No defined value data available.<br>\n";
    }
    print "</TR>\n";

  }
}

print <<EOF10;
</TABLE>
EOF10



&page_footer();

exit;
